/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_V8QImode)
      || GET_MODE (x1) != E_V8QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern19 (x3, pnum_clobbers); /* [-1, 1] */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern17 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern16 (x3);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 6;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case ASHIFT:
      if (GET_MODE (x6) != E_TImode)
        return -1;
      return pattern37 (x6, 
E_TImode, 
E_DImode); /* [-1, 2] */

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x6;
      if (!const_scalar_int_operand (operands[2], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 4;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case STRICT_LOW_PART:
      return pattern71 (x1, pnum_clobbers); /* [-1, 1] */

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern72 (x2, pnum_clobbers) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern73 (x2, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V2SFmode:
          if (pattern7 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 4;

        case E_V2BFmode:
          if (pattern7 (x2, 
E_V2BFmode) != 0)
            return -1;
          return 5;

        case E_V4BFmode:
          if (pattern7 (x2, 
E_V4BFmode) != 0)
            return -1;
          return 6;

        case E_V2HFmode:
          if (pattern7 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 7;

        case E_V4HFmode:
          if (pattern7 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 8;

        case E_V8QImode:
          if (pattern8 (x2, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V4HImode:
          if (pattern8 (x2, 
E_V4HImode) != 0)
            return -1;
          return 10;

        case E_V2SImode:
          if (pattern8 (x2, 
E_V2SImode) != 0)
            return -1;
          return 11;

        case E_V4QImode:
          if (pattern74 (x2, pnum_clobbers, 
E_V4QImode) != 0)
            return -1;
          return 12;

        case E_V2QImode:
          if (pattern74 (x2, pnum_clobbers, 
E_V2QImode) != 0)
            return -1;
          return 13;

        case E_V2HImode:
          if (pattern74 (x2, pnum_clobbers, 
E_V2HImode) != 0)
            return -1;
          return 14;

        case E_BFmode:
          if (pattern7 (x2, 
E_BFmode) != 0)
            return -1;
          return 15;

        case E_HFmode:
          if (pattern7 (x2, 
E_HFmode) != 0)
            return -1;
          return 16;

        case E_SFmode:
          if (pattern7 (x2, 
E_SFmode) != 0)
            return -1;
          return 17;

        case E_DFmode:
          if (pattern7 (x2, 
E_DFmode) != 0)
            return -1;
          return 18;

        case E_TFmode:
          if (pattern25 (x2, 
E_TFmode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !nonmemory_operand (operands[2], E_QImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      return pattern128 (x1, 
E_HImode, 
E_V16HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern128 (x1, 
E_QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern128 (x1, 
E_QImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern128 (x1, 
E_QImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern128 (x1, 
E_QImode, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern128 (x1, 
E_QImode, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V32HImode:
      if (pattern128 (x1, 
E_SImode, 
E_V32HImode) != 0)
        return -1;
      return 6;

    case E_V16SImode:
      if (pattern128 (x1, 
E_HImode, 
E_V16SImode) != 0)
        return -1;
      return 7;

    case E_V8DImode:
      if (pattern128 (x1, 
E_QImode, 
E_V8DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          return pattern146 (x1, 
E_V16HImode, 
E_V16QImode, 
E_HImode); /* [-1, 0] */

        case E_V32HImode:
          if (pattern146 (x1, 
E_V32HImode, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 1;

        case E_V8HImode:
          if (pattern147 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x1) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode
              || !nonimm_or_0_operand (operands[2], E_V16SImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              return 3;

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              return 4;

            default:
              return -1;
            }

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x1) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode
              || !nonimm_or_0_operand (operands[2], E_V8SImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 5;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode
              || !nonimm_or_0_operand (operands[2], E_V4SImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 7;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x1) != E_V8DImode
              || GET_MODE (x4) != E_V8DImode
              || !nonimm_or_0_operand (operands[2], E_V8DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 9;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 10;

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x1) != E_V4DImode
              || GET_MODE (x4) != E_V4DImode
              || !nonimm_or_0_operand (operands[2], E_V4DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 12;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 13;

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || !nonimm_or_0_operand (operands[2], E_V2DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2QImode:
              if (!memory_operand (operands[1], E_V2QImode))
                return -1;
              return 15;

            case E_V2HImode:
              if (!memory_operand (operands[1], E_V2HImode))
                return -1;
              return 16;

            case E_V2SImode:
              if (!memory_operand (operands[1], E_V2SImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern195 (x3); /* [-1, 1] */
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern202 (x1); /* [-1, 3] */
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern203 (x1); /* [-1, 3] */
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 0;

    case AND:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      res = pattern204 (x5);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    case PLUS:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      res = pattern205 (x5);
      if (res >= 0)
        return res + 5; /* [5, 8] */
      return -1;

    case MINUS:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      res = pattern206 (x5);
      if (res >= 0)
        return res + 9; /* [9, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!ix86_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x7;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case STRICT_LOW_PART:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCCmode)
    return -1;
  return 0;
}

int
pattern256 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || GET_MODE (x2) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  return pattern255 (x6, 
i1, 
i2); /* [-1, 1] */
}

int
pattern262 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  return pattern39 (x4); /* [-1, 1] */
}

int
pattern266 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      return pattern2 (x3); /* [-1, 1] */

    case STRICT_LOW_PART:
      res = pattern262 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern276 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 2;

        case E_HImode:
          return 3;

        case E_SImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern288 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0))
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != MINUS
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != AND
      || GET_MODE (x10) != E_QImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XEXP (x3, 0);
  if (!nonmemory_operand (x12, E_QImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 63L:
      if (XWINT (x9, 0) != 64L
          || XWINT (x11, 0) != 63L
          || pattern287 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 0;

    case 31L:
      if (XWINT (x9, 0) != 32L
          || XWINT (x11, 0) != 31L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x1, 1);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern306 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern306 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern306 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !vector_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !vector_operand (operands[1], i2))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !vector_operand (operands[1], i3))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  return 0;
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x1, 1);
  return pattern331 (x7, 
i1, 
i2); /* [-1, 0] */
}

int
pattern336 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  return 0;
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern342 (x1); /* [-1, 5] */
}

int
pattern344 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  return pattern343 (x6); /* [-1, 5] */
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  return pattern348 (x6); /* [-1, 5] */
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ZERO_EXTEND)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  return pattern354 (x3); /* [-1, 3] */
}

int
pattern360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return pattern359 (x2); /* [-1, 3] */
}

int
pattern366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 110)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          return 0;

        case USE:
          return 1;

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      res = pattern373 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern389 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern389 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern389 (x1, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern404 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_operator (x3, i1))
    return -1;
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!memory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern424 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern443 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[2] = x7;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern450 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern450 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern463 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern469 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  x7 = XEXP (x1, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          return pattern479 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern479 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern479 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[5] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern484 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SImode:
          if (pattern484 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern484 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern496 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!vector_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!vector_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern502 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!nonimm_or_0_operand (operands[2], E_V4SImode))
        return -1;
      x7 = XEXP (x1, 2);
      operands[3] = x7;
      return 0;

    case CONST_VECTOR:
      if (XVECLEN (x2, 0) != 2)
        return -1;
      x8 = XVECEXP (x2, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 2);
      operands[2] = x7;
      return 1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CONST_VECTOR
      || XVECLEN (x2, 0) != 8
      || GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x2, 0, 4);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x2, 0, 5);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x2, 0, 6);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XVECEXP (x2, 0, 7);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x11 = XEXP (x1, 0);
  if (GET_MODE (x11) != E_V8QImode)
    return -1;
  return 0;
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) < 1)
    return -1;
  operands[4] = x2;
  if (!pmovzx_parallel (operands[4], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern524 (x1, 
E_V16SImode, 
E_V8SImode, 
E_V32SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern524 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x3) != E_V8SImode
          || GET_MODE (x4) != E_V4SImode
          || !vector_operand (operands[1], E_V2SImode)
          || !const0_operand (operands[2], E_V2SImode)
          || !const0_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern538 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern534 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern534 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern534 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V32BFmode:
      if (pattern534 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 3;

    case E_V16BFmode:
      if (pattern534 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 4;

    case E_V8BFmode:
      if (pattern534 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 5;

    case E_V16SFmode:
      if (pattern534 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern534 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V4SFmode:
      if (pattern534 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 8;

    case E_V8DFmode:
      if (pattern534 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 9;

    case E_V4DFmode:
      if (pattern534 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern534 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern547 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_XFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern554 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      return 0;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 38)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern577 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern585 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0))
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != i1
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != SUBREG
          || maybe_ne (SUBREG_BYTE (x13), 0)
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != ZERO_EXTRACT)
            return -1;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x15, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x18 = XEXP (x2, 0);
          operands[4] = x18;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode))
            return -1;
          return pattern584 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern612 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  return 0;
}

int
pattern626 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern625 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern625 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern633 (x1, 
E_V16SImode, 
E_HImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern633 (x1, 
E_V8SImode, 
E_QImode, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern633 (x1, 
E_V4SImode, 
E_QImode, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern643 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[5] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern646 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern646 (x1, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V16SFmode:
      if (pattern646 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V8SFmode:
      if (pattern646 (x1, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_V8DFmode:
      if (pattern646 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_V4DFmode:
      if (pattern646 (x1, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !vector_all_ones_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern666 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern670 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern675 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  return pattern674 (x2); /* [-1, 0] */
}

int
pattern681 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      return pattern679 (x1); /* [-1, 5] */

    case VEC_MERGE:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != VEC_DUPLICATE
          || GET_MODE (x5) != E_V4SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_VECTOR
          || XVECLEN (x6, 0) != 4
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x4, 2);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern680 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern694 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 17
      || GET_MODE (x1) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_TImode:
      return 1;

    case E_QImode:
      return 2;

    case E_HImode:
      return 3;

    case E_SImode:
      return 4;

    case E_SFmode:
      return 5;

    case E_DFmode:
      return 6;

    case E_XFmode:
      return 7;

    default:
      return -1;
    }
}

int
pattern705 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

int
pattern712 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1)
    return -1;
  return 0;
}

int
pattern717 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  return 0;
}

int
pattern724 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_SImode:
      res = pattern293 (x1);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    case E_DImode:
      res = pattern294 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern734 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern742 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[3], E_HImode))
        return -1;
      return pattern740 (); /* [-1, 2] */

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[3], E_QImode))
        return -1;
      res = pattern741 ();
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern755 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SImode)
          || !const0_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SImode)
          || !const0_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DImode)
          || !const0_operand (operands[2], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !const0_operand (operands[2], E_V32QImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const0_operand (operands[2], E_V16QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern779 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  return pattern778 (x1); /* [-1, 2] */
}

int
pattern795 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern802 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !pmovzx_parallel (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern813 (rtx x1, machine_mode i1, int i2, int i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || XVECLEN (x1, 0) != i3
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern816 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != SUBREG
          || maybe_ne (SUBREG_BYTE (x10), 0))
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != ZERO_EXTRACT)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x14, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x2, 0);
          operands[4] = x17;
          return 0;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern837 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern844 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern849 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern852 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern851 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern851 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern858 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern862 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern869 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern878 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern887 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern898 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2DImode
      || !nonimm_or_0_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!memory_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern906 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || !register_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 8:
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x8, 0, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x8, 0, 3);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x13 = XVECEXP (x8, 0, 4);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x14 = XVECEXP (x8, 0, 5);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x15 = XVECEXP (x8, 0, 6);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x16 = XVECEXP (x8, 0, 7);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x4) != E_V16QImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              return pattern134 (x1, 
E_V8HImode); /* [-1, 0] */

            case E_V8SImode:
              if (pattern134 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1;

            case E_V8DImode:
              if (pattern134 (x1, 
E_V8DImode) != 0)
                return -1;
              return 2;

            default:
              return -1;
            }

        case 4:
          res = pattern904 (x1, 
E_V8HImode, 
E_V4HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case 2:
          if (pattern905 (x1, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case VEC_MERGE:
      if (GET_MODE (x5) != E_V4SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != VEC_DUPLICATE
          || GET_MODE (x7) != E_V4SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_VECTOR
          || XVECLEN (x6, 0) != 4
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x17 = XVECEXP (x6, 0, 0);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x18 = XVECEXP (x6, 0, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x6, 0, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XVECEXP (x6, 0, 3);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x21 = XEXP (x5, 2);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XEXP (x7, 0);
      operands[1] = x22;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 4:
          res = pattern904 (x1, 
E_V16QImode, 
E_V4QImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case 2:
          if (pattern905 (x1, 
E_V8HImode, 
E_V2HImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern955 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern954 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern954 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern962 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!ix86_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[4] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 2);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x1, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern968 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!nonimm_or_0_operand (operands[1], E_V16QImode)
              || !nonimm_or_0_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!nonimm_or_0_operand (operands[1], E_V16HImode)
              || !nonimm_or_0_operand (operands[2], E_V16HImode))
            return -1;
          return 1;

        case E_V16SImode:
          if (!nonimm_or_0_operand (operands[1], E_V16SImode)
              || !nonimm_or_0_operand (operands[2], E_V16SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!nonimm_or_0_operand (operands[1], E_V8HImode)
              || !nonimm_or_0_operand (operands[2], E_V8HImode))
            return -1;
          return 3;

        case E_V8SImode:
          if (!nonimm_or_0_operand (operands[1], E_V8SImode)
              || !nonimm_or_0_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!nonimm_or_0_operand (operands[1], E_V4SImode)
              || !nonimm_or_0_operand (operands[2], E_V4SImode))
            return -1;
          return 5;

        case E_V8DImode:
          if (!nonimm_or_0_operand (operands[1], E_V8DImode)
              || !nonimm_or_0_operand (operands[2], E_V8DImode))
            return -1;
          return 6;

        case E_V4DImode:
          if (!nonimm_or_0_operand (operands[1], E_V4DImode)
              || !nonimm_or_0_operand (operands[2], E_V4DImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!nonimm_or_0_operand (operands[1], E_V2DImode)
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern989 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[2], E_V32HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern999 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern1003 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1012 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1022 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1033 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 4
      || GET_MODE (x5) != E_V4SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x4, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || GET_MODE (x4) != E_V4SImode)
    return -1;
  return pattern680 (x1); /* [-1, 2] */
}

int
pattern1044 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_CODE (x6))
    {
    case STRICT_LOW_PART:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return pattern1043 (); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      res = pattern1043 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1051 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1054 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1058 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_CODE (x3))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern369 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern369 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern369 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern369 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1082 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1089 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1093 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 59
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      return pattern1092 (x2, 
E_V8SImode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1092 (x2, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DFmode:
      if (pattern1092 (x2, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V2DFmode:
      if (pattern1092 (x2, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1103 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8HFmode)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 223
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x1, 2);
  if (XWINT (x5, 0) != 3L
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || !vector_operand (operands[1], E_V8HFmode)
      || !vector_operand (operands[2], E_V8HFmode)
      || !vector_operand (operands[3], E_V8HFmode))
    return -1;
  x6 = XVECEXP (x4, 0, 0);
  if (!register_operand (x6, E_QImode))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x2, 1);
  switch (GET_CODE (x8))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x8;
      if (!const0_operand (operands[4], E_V8HFmode))
        return -1;
      operands[5] = x6;
      return 0;

    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      operands[4] = x6;
      return 1;

    default:
      return -1;
    }
}

int
pattern1127 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i3)
      || !register_operand (operands[3], i3)
      || !const0_operand (operands[4], i3))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern1135 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern1135 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !palignr_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 3;

        case E_HImode:
          return 4;

        case E_SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern1166 (x2, 
i1); /* [-1, 2] */
}

int
pattern1174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1182 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[4], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1192 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case REG:
      if (peep2_current_count < 4)
        return -1;
      operands[5] = x3;
      if (!general_reg_operand (operands[5], i1))
        return -1;
      x4 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[5]))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1201 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_unset_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1240 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (!const_0_to_63_operand (x6, E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (!const_0_to_31_operand (x6, E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1247 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern1255 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1261 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[0], i1)
      || !const0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1266 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode)
          || !extract_operator (operands[4], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode)
          || !extract_operator (operands[4], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode)
          || !extract_operator (operands[4], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1277 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1287 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !nonimmediate_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern1298 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1309 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern1315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  if (XVECLEN (x10, 0) != 2)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x10, 0, 1);
  if (GET_CODE (x12) != CONST_INT
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != E_V2DImode
      || GET_MODE (x3) != E_V2DImode
      || GET_MODE (x4) != E_V2SImode
      || !nonimmediate_operand (operands[1], E_V4SImode))
    return -1;
  return 0;
}

int
pattern1327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1334 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern561 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1340 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1346 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  return pattern1345 (x8); /* [-1, 0] */
}

int
pattern1356 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_255_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1373 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1372 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1381 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1380 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1391 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1380 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1400 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern1399 (x1, 
E_V8HFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern1399 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V2DFmode:
          if (pattern1399 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x4;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      x5 = XEXP (x3, 2);
      operands[5] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[6] = x6;
      x11 = XEXP (x2, 1);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1424 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1430 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_QImode:
          return pattern1423 (x3, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern1423 (x3, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern1424 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern1424 (x3, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      if (GET_MODE (x8) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_zext_immediate_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern1457 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i2))
    return -1;
  return 0;
}

int
pattern1466 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1475 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V4DImode
      || !nonimm_or_0_operand (operands[2], E_V4DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1493 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1499 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1505 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  return 0;
}

int
pattern1518 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        case E_V2DFmode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x4;
      x5 = XEXP (x3, 2);
      operands[5] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[6] = x6;
      x7 = XEXP (x2, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1556 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1562 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1574 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1580 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1589 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1599 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1606 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], i2)
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1615 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1614 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1614 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1626 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1632 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1641 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1640 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1640 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1640 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1650 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1649 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1649 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1665 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1672 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1679 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1688 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = PATTERN (peep2_next_insn (2));
  return pattern1536 (x11); /* [-1, 0] */
}

int
pattern1701 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1707 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  switch (GET_MODE (operands[6]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      return pattern1714 (x3, 
E_HImode, 
E_V16SImode); /* [-1, 1] */

    case E_QImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      res = pattern1714 (x3, 
E_QImode, 
E_V8DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1728 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 4);
  if (XWINT (x4, 0) != 6L)
    return -1;
  x5 = XVECEXP (x3, 0, 5);
  if (XWINT (x5, 0) != 14L)
    return -1;
  x6 = XVECEXP (x3, 0, 6);
  if (XWINT (x6, 0) != 7L)
    return -1;
  x7 = XVECEXP (x3, 0, 7);
  if (XWINT (x7, 0) != 15L)
    return -1;
  x8 = XEXP (x2, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  x10 = XEXP (x1, 1);
  operands[3] = x10;
  x11 = XEXP (x1, 2);
  operands[4] = x11;
  return 0;
}

int
pattern1736 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[4], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1741 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1)
      || !scratch_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1740 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1740 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1755 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !x86_64_dwzext_immediate_operand (operands[2], i2)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1762 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1772 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1771 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1771 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1784 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1791 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1799 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!register_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != COMPARE)
    return -1;
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17)
    return -1;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  return 0;
}

int
pattern1811 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return pattern1810 (x1, 
i1); /* [-1, 1] */
}

int
pattern1819 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 0);
      switch (GET_MODE (x9))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1834 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1845 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[5] = x5;
  if (!const_0_to_1_operand (operands[5], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[6] = x8;
  if (!const_0_to_1_operand (operands[6], E_SImode))
    return -1;
  x9 = XEXP (x1, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x6, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

int
pattern1855 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1858 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 109
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 109
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_MODE (x7) != E_CCZmode)
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != E_CCZmode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != E_CCZmode
      || !register_operand (operands[5], i1)
      || !general_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1867 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1876 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1883 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode))
        {
          if (const0_operand (operands[1], E_QImode))
            {
              if ((
#line 1563 "../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)) && 
#line 1555 "../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                return 5; /* *cmpqi_ccz_1 */
              if (
#line 1577 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 9; /* *cmpqi_ccno_1 */
            }
          if (general_operand (operands[1], E_QImode)
              && 
#line 1589 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
            return 13; /* *cmpqi_1 */
        }
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode))
        {
          if (const0_operand (operands[1], E_HImode))
            {
              if (
#line 1563 "../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)))
                return 6; /* *cmphi_ccz_1 */
              if (
#line 1577 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 10; /* *cmphi_ccno_1 */
            }
          if (general_operand (operands[1], E_HImode)
              && 
#line 1589 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
            return 14; /* *cmphi_1 */
        }
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          if (const0_operand (operands[1], E_SImode))
            {
              if ((
#line 1563 "../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                return 7; /* *cmpsi_ccz_1 */
              if (
#line 1577 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 11; /* *cmpsi_ccno_1 */
            }
          if (x86_64_general_operand (operands[1], E_SImode)
              && 
#line 1589 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
            return 15; /* *cmpsi_1 */
        }
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode))
        {
          if (const0_operand (operands[1], E_DImode))
            {
              if ((
#line 1563 "../../gcc/config/i386/i386.md"
(TARGET_AVX512F && ix86_match_ccmode (insn, CCZmode)) && 
#line 1556 "../../gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)))
                return 8; /* *cmpdi_ccz_1 */
              if ((
#line 1577 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 12; /* *cmpdi_ccno_1 */
            }
          if (x86_64_general_operand (operands[1], E_DImode)
              && (
#line 1589 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 16; /* *cmpdi_1 */
        }
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_CCZmode:
      if (GET_MODE (x2) == E_CCZmode)
        {
          switch (pattern844 ())
            {
            case 0:
              if ((
#line 1682 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 33; /* *cmpdi_doubleword */
              break;

            case 1:
              if ((
#line 1682 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 34; /* *cmpti_doubleword */
              break;

            default:
              break;
            }
        }
      break;

    case E_CCFPmode:
      if (GET_MODE (x2) == E_CCFPmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (register_operand (operands[0], E_XFmode)
                  && register_operand (operands[1], E_XFmode)
                  && 
#line 2029 "../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
                return 48; /* *cmpixf_i387 */
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && register_ssemem_operand (operands[1], E_SFmode)
                  && 
#line 2069 "../../gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return 56; /* *cmpisf */
              break;

            case E_DFmode:
              if (register_operand (operands[0], E_DFmode)
                  && register_ssemem_operand (operands[1], E_DFmode)
                  && 
#line 2069 "../../gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return 58; /* *cmpidf */
              break;

            case E_HFmode:
              if (register_operand (operands[0], E_HFmode)
                  && nonimmediate_operand (operands[1], E_HFmode)
                  && 
#line 2106 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 60; /* *cmpihf */
              break;

            case E_BFmode:
              if (register_operand (operands[0], E_BFmode)
                  && nonimmediate_operand (operands[1], E_BFmode)
                  && 
#line 2117 "../../gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
                return 62; /* *cmpibf */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (!nonimmediate_operand (operands[0], E_QImode)
      || pattern601 (x3) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x5, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!extract_operator (operands[2], E_HImode)
          || !
#line 1614 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
        return -1;
      return 21; /* *cmpqi_exthi_1 */

    case E_SImode:
      if (!extract_operator (operands[2], E_SImode)
          || !
#line 1614 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
        return -1;
      return 22; /* *cmpqi_extsi_1 */

    case E_DImode:
      if (!extract_operator (operands[2], E_DImode)
          || !(
#line 1614 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 23; /* *cmpqi_extdi_1 */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      if (general_operand (operands[1], E_QImode)
          && 
#line 3435 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return 111; /* *movstrictqi_1 */
      if (pnum_clobbers == NULL
          || !const0_operand (operands[1], E_QImode)
          || !
#line 3444 "../../gcc/config/i386/i386.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 113; /* *movstrictqi_xor */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      if (general_operand (operands[1], E_HImode)
          && 
#line 3435 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return 112; /* *movstricthi_1 */
      if (pnum_clobbers == NULL
          || !const0_operand (operands[1], E_HImode)
          || !
#line 3444 "../../gcc/config/i386/i386.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 114; /* *movstricthi_xor */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x4 = XEXP (x2, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!general_operand (operands[1], E_HImode))
        return -1;
      return 128; /* insvhi_1 */

    case E_SImode:
      if (!general_operand (operands[1], E_SImode))
        return -1;
      return 129; /* insvsi_1 */

    case E_DImode:
      if (!general_operand (operands[1], E_DImode)
          || !
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 130; /* insvdi_1 */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x2) == MEM)
        {
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (x86_64_movabs_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x1, 1);
              operands[1] = x4;
              switch (GET_MODE (x2))
                {
                case E_QImode:
                  if (nonmemory_operand (operands[1], E_QImode)
                      && 
#line 3289 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
                    return 99; /* *movabsqi_1 */
                  break;

                case E_HImode:
                  if (nonmemory_operand (operands[1], E_HImode)
                      && 
#line 3289 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
                    return 100; /* *movabshi_1 */
                  break;

                case E_SImode:
                  if (nonmemory_operand (operands[1], E_SImode)
                      && 
#line 3289 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
                    return 101; /* *movabssi_1 */
                  break;

                case E_DImode:
                  if (nonmemory_operand (operands[1], E_DImode)
                      && 
#line 3289 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 0)))
                    return 102; /* *movabsdi_1 */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case STRICT_LOW_PART:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XEXP (x1, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (indirect_branch_operand (operands[0], E_SImode)
              && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode))
            return 1460; /* *indirect_jump */
          break;

        case E_DImode:
          if (indirect_branch_operand (operands[0], E_DImode)
              && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode))
            return 1461; /* *indirect_jump */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case MEM:
      operands[0] = x2;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!x86_64_movabs_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode
              || !
#line 3313 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 103; /* *movabsqi_2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !
#line 3313 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 104; /* *movabshi_2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !
#line 3313 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 105; /* *movabssi_2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !
#line 3313 "../../gcc/config/i386/i386.md"
(TARGET_LP64 && ix86_check_movabs (insn, 1)))
            return -1;
          return 106; /* *movabsdi_2 */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[2] = x5;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x5, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x4) != E_QImode)
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_CODE (x2))
            {
            case STRICT_LOW_PART:
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              switch (pattern1353 ())
                {
                case 0:
                  if (!
#line 3458 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  return 115; /* *movstrictqi_exthi_1 */

                case 1:
                  if (!
#line 3458 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  return 116; /* *movstrictqi_extsi_1 */

                case 2:
                  if (!(
#line 3458 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 117; /* *movstrictqi_extdi_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x2;
              if (!nonimmediate_operand (operands[0], E_QImode))
                return -1;
              switch (pattern1353 ())
                {
                case 0:
                  return 125; /* *extzvqi */

                case 1:
                  return 126; /* *extzvqi */

                case 2:
                  if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 127; /* *extzvqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x5;
          if (!general_operand (operands[1], E_QImode)
              || pattern420 (x2) != 0)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              return 131; /* *insvqi_1 */

            case E_SImode:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              return 132; /* *insvqi_1 */

            case E_DImode:
              if (GET_MODE (x4) != E_DImode
                  || !
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 133; /* *insvqi_1 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern248 (x1, pnum_clobbers) != 0)
            return -1;
          x6 = XEXP (x5, 1);
          operands[2] = x6;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern250 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 333; /* *addqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 334; /* *addqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 335; /* *addqi_extdi_1 */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern1727 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 336; /* *addqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 338; /* *addqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 340; /* *addqi_extdi_2 */

            default:
              return -1;
            }

        case MINUS:
          if (pattern248 (x1, pnum_clobbers) != 0)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) == SUBREG)
            {
              switch (pattern1727 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 337; /* *subqi_exthi_2 */

                case 1:
                  *pnum_clobbers = 1;
                  return 339; /* *subqi_extsi_2 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 341; /* *subqi_extdi_2 */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          if (!general_operand (operands[2], E_QImode))
            return -1;
          switch (pattern250 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 422; /* *subqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 423; /* *subqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 424; /* *subqi_extdi_1 */

            default:
              return -1;
            }

        case AND:
          if (pattern248 (x1, pnum_clobbers) != 0)
            return -1;
          x6 = XEXP (x5, 1);
          operands[2] = x6;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern250 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 773; /* *andqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 776; /* *andqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 779; /* *andqi_extdi_1 */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern1727 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 791; /* *andqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 794; /* *andqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 797; /* *andqi_extdi_2 */

            default:
              return -1;
            }

        case IOR:
          if (pattern248 (x1, pnum_clobbers) != 0)
            return -1;
          x6 = XEXP (x5, 1);
          operands[2] = x6;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern250 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 774; /* *iorqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 777; /* *iorqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 780; /* *iorqi_extdi_1 */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern1727 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 792; /* *iorqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 795; /* *iorqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 798; /* *iorqi_extdi_2 */

            default:
              return -1;
            }

        case XOR:
          if (pattern248 (x1, pnum_clobbers) != 0)
            return -1;
          x6 = XEXP (x5, 1);
          operands[2] = x6;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern250 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 775; /* *xorqi_exthi_1 */

                case 1:
                  *pnum_clobbers = 1;
                  return 778; /* *xorqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 781; /* *xorqi_extdi_1 */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern1727 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 793; /* *xorqi_exthi_2 */

            case 1:
              *pnum_clobbers = 1;
              return 796; /* *xorqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 799; /* *xorqi_extdi_2 */

            default:
              return -1;
            }

        case NEG:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern249 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 988; /* *negqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 989; /* *negqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 990; /* *negqi_extdi_1 */

            default:
              return -1;
            }

        case NOT:
          switch (pattern249 (x1))
            {
            case 0:
              return 1049; /* *one_cmplqi_exthi_1 */

            case 1:
              return 1050; /* *one_cmplqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 1051; /* *one_cmplqi_extdi_1 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern251 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1119; /* *ashlqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 1120; /* *ashlqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1121; /* *ashlqi_extdi_1 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern251 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1238; /* *lshrqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 1240; /* *lshrqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1242; /* *lshrqi_extdi_1 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern251 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1239; /* *ashrqi_exthi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 1241; /* *ashrqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1243; /* *ashrqi_extdi_1 */

            default:
              return -1;
            }

        case SS_TRUNCATE:
          if (pattern252 (x1) != 0
              || !
#line 15412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 7295; /* *avx512vl_ss_truncatev2div2qi2_store_2 */

        case TRUNCATE:
          if (pattern252 (x1) != 0
              || !
#line 15412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 7296; /* *avx512vl_truncatev2div2qi2_store_2 */

        case US_TRUNCATE:
          if (pattern252 (x1) != 0
              || !
#line 15412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 7297; /* *avx512vl_us_truncatev2div2qi2_store_2 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 17
          || pattern55 (x1, 
E_CCCmode) != 0
          || !
#line 9877 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 529; /* *setccc */

    case CONST_INT:
      if (pnum_clobbers == NULL
          || GET_CODE (x2) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      switch (XWINT (x4, 0))
        {
        case 0L:
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!nonimmediate_operand (operands[0], E_QImode)
                      || !
#line 18977 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1411; /* *btrqi_2 */

                case E_HImode:
                  if (!nonimmediate_operand (operands[0], E_HImode)
                      || !
#line 18977 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1412; /* *btrhi_2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (!const_0_to_63_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || !
#line 19041 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
                return -1;
              *pnum_clobbers = 1;
              return 1414; /* *btrq_imm */

            default:
              return -1;
            }

        case 1L:
          if (GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[0], E_DImode)
              || !const_0_to_63_operand (operands[1], E_QImode)
              || !
#line 19028 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
            return -1;
          *pnum_clobbers = 1;
          return 1413; /* *btsq_imm */

        default:
          return -1;
        }

    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      return 1459; /* jump */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1, pnum_clobbers))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          x2 = XEXP (x1, 1);
          if (pattern72 (x2, pnum_clobbers) != 0
              || !(
#line 12495 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 704; /* *andti3_doubleword */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern73 (x2, 
E_HImode) != 0)
            return -1;
          if (
#line 12665 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 719; /* *andhi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 12665 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 720; /* *andhi_1 */

        case E_QImode:
          x2 = XEXP (x1, 1);
          if (pattern73 (x2, 
E_QImode) != 0)
            return -1;
          if (
#line 12703 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 723; /* *andqi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 12703 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 724; /* *andqi_1 */

        case E_V2SFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2SFmode) != 0
              || !
#line 1357 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2071; /* andv2sf3 */

        case E_V2BFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2BFmode) != 0
              || !
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return -1;
          return 2105; /* andv2bf3 */

        case E_V4BFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V4BFmode) != 0
              || !(
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return -1;
          return 2108; /* andv4bf3 */

        case E_V2HFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2HFmode) != 0
              || !
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return -1;
          return 2111; /* andv2hf3 */

        case E_V4HFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V4HFmode) != 0
              || !(
#line 2582 "../../gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return -1;
          return 2114; /* andv4hf3 */

        case E_V8QImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V8QImode) != 0
              || !
#line 4687 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (AND, V8QImode, operands)))
            return -1;
          return 2268; /* *mmx_andv8qi3 */

        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V4HImode) != 0
              || !
#line 4687 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (AND, V4HImode, operands)))
            return -1;
          return 2271; /* *mmx_andv4hi3 */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V2SImode) != 0
              || !
#line 4687 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (AND, V2SImode, operands)))
            return -1;
          return 2274; /* *mmx_andv2si3 */

        case E_V4QImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, pnum_clobbers, 
E_V4QImode) != 0
              || !
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V4QImode, operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2277; /* *andv4qi3 */

        case E_V2QImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, pnum_clobbers, 
E_V2QImode) != 0
              || !
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V2QImode, operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2280; /* *andv2qi3 */

        case E_V2HImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, pnum_clobbers, 
E_V2HImode) != 0
              || !
#line 4713 "../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V2HImode, operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2283; /* *andv2hi3 */

        case E_BFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_BFmode) != 0
              || !
#line 5649 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3778; /* andbf3 */

        case E_HFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_HFmode) != 0
              || !
#line 5649 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3781; /* andhf3 */

        case E_SFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_SFmode) != 0
              || !
#line 5649 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3784; /* andsf3 */

        case E_DFmode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_DFmode) != 0
              || !(
#line 5649 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return -1;
          return 3787; /* anddf3 */

        case E_TFmode:
          x2 = XEXP (x1, 1);
          if (pattern25 (x2, 
E_TFmode) != 0
              || !
#line 5723 "../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 3790; /* *andtf3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 12735 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 725; /* *andqi_1_slp */

    case 2:
      if (!
#line 12735 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 728; /* *andhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (pnum_clobbers != NULL
              && GET_CODE (x4) == SUBREG
              && pattern422 (x1, 
E_TImode) == 0
              && (
#line 15197 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1053; /* *ashlti3_doubleword_mask */
            }
          operands[2] = x4;
          switch (pattern254 (x1, pnum_clobbers))
            {
            case 0:
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pnum_clobbers == NULL
                      || !register_operand (operands[0], E_TImode)
                      || GET_MODE (x2) != E_TImode
                      || !reg_or_pm1_operand (operands[1], E_TImode)
                      || !nonmemory_operand (operands[2], E_QImode)
                      || !
#line 1196 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1057; /* ashlti3_doubleword */

                case E_HImode:
                  if (pattern624 (x2, 
E_HImode) != 0)
                    return -1;
                  if (
#line 16099 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                    return 1104; /* *ashlhi3_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 16099 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1105; /* *ashlhi3_1 */

                case E_QImode:
                  if (pattern624 (x2, 
E_QImode) != 0)
                    return -1;
                  if (
#line 16158 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                    return 1106; /* *ashlqi3_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 16158 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1107; /* *ashlqi3_1 */

                case E_V4HImode:
                  if (pattern738 (x2, 
E_V4HImode, 
E_DImode) != 0
                      || !
#line 3891 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return -1;
                  return 2196; /* mmx_ashlv4hi3 */

                case E_V2SImode:
                  if (pattern738 (x2, 
E_V2SImode, 
E_DImode) != 0
                      || !
#line 3891 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return -1;
                  return 2198; /* mmx_ashlv2si3 */

                case E_V1DImode:
                  if (pattern738 (x2, 
E_V1DImode, 
E_DImode) != 0
                      || !
#line 3891 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return -1;
                  return 2200; /* mmx_ashlv1di3 */

                case E_V1SImode:
                  if (pattern738 (x2, 
E_V1SImode, 
E_DImode) != 0
                      || !
#line 3928 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 2202; /* mmx_ashlv1si3 */

                case E_V2HImode:
                  if (pattern738 (x2, 
E_V2HImode, 
E_DImode) != 0
                      || !
#line 3945 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 2204; /* ashlv2hi3 */

                case E_V2QImode:
                  if (pnum_clobbers == NULL
                      || pattern738 (x2, 
E_V2QImode, 
E_QImode) != 0
                      || !
#line 4007 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2208; /* ashlv2qi3 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 16237 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 1108; /* *ashlqi3_1_slp */

            case 2:
              if (!
#line 16237 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 1109; /* *ashlhi3_1_slp */

            default:
              return -1;
            }

        case AND:
          if (pattern0 (x1, pnum_clobbers) != 0
              || !(
#line 15258 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1055; /* *ashlti3_doubleword_mask_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern42 (x1, pnum_clobbers) != 0
          || !(
#line 15359 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 8 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 8 * BITS_PER_UNIT * 2) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1060; /* *ashlti3_doubleword_highpart */

    case ZERO_EXTEND:
      if (pattern42 (x1, pnum_clobbers) != 0
          || !(
#line 15359 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 8 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 8 * BITS_PER_UNIT * 2) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1061; /* *ashlti3_doubleword_highpart */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LTU:
      switch (pattern43 (x1))
        {
        case 0:
          if (
#line 9887 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
            return 530; /* *setcc_qi_negqi_ccc_1_cc */
          break;

        case 1:
          if (
#line 9887 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
            return 531; /* *setcc_qi_negqi_ccc_1_ccc */
          break;

        default:
          break;
        }
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG
      && REGNO (x3) == 17)
    {
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (operands[1]))
    {
    case NE:
    case EQ:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern745 (
E_V8QImode) != 0
              || !
#line 4218 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2229; /* *xop_maskcmp_unsv8qi3 */

        case E_V4HImode:
          if (pattern745 (
E_V4HImode) != 0
              || !
#line 4218 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2230; /* *xop_maskcmp_unsv4hi3 */

        case E_V2SImode:
          if (pattern745 (
E_V2SImode) != 0
              || !
#line 4218 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2231; /* *xop_maskcmp_unsv2si3 */

        case E_V4QImode:
          if (pattern745 (
E_V4QImode) != 0
              || !
#line 4228 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2232; /* *xop_maskcmp_unsv4qi3 */

        case E_V2QImode:
          if (pattern745 (
E_V2QImode) != 0
              || !
#line 4228 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2233; /* *xop_maskcmp_unsv2qi3 */

        case E_V2HImode:
          if (pattern745 (
E_V2HImode) != 0
              || !
#line 4228 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2234; /* *xop_maskcmp_unsv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_55 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x2, 1);
          if (pattern601 (x7) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (pattern1267 (x1))
            {
            case 0:
              if (!
#line 8242 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8242 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8242 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x11 = XEXP (x1, 0);
      operands[0] = x11;
      switch (pattern289 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1358 (x2, 
E_QImode) != 0
                  || !
#line 9271 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1358 (x2, 
E_HImode) != 0
                  || !
#line 9271 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 488; /* subhi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1272 (x2, 
E_QImode) != 0
                  || !
#line 10224 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1272 (x2, 
E_HImode) != 0
                  || !
#line 10224 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *subhi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern90 (x1))
        {
        case 0:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (pattern975 (x2) != 0)
            return -1;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1511 (x2, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 1058 "../../gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()))
                return -1;
              return 2061; /* *mmx_hsubv2sf3_low */

            case E_DFmode:
              if (pattern1511 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3769 "../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_V2DF_REDUCTION_PREFER_HADDPD))
                return -1;
              return 3184; /* *sse3_hsubv2df3_low */

            default:
              return -1;
            }

        case 1:
          switch (pattern854 (x2))
            {
            case 0:
              if (!
#line 22615 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8594; /* ssse3_phsubwv4hi3 */

            case 1:
              if (!
#line 22702 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8601; /* ssse3_phsubdv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_62 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (pattern271 (x2))
        {
        case 0:
          x6 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x6) == CONST_INT)
            {
              switch (pattern979 (x2))
                {
                case 0:
                  if (
#line 1691 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2081; /* *vec_interleave_lowv2sf */
                  break;

                case 1:
                  if (
#line 4991 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2297; /* mmx_punpckldq */
                  break;

                case 2:
                  if (
#line 1708 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2082; /* *vec_interleave_highv2sf */
                  break;

                case 3:
                  if (
#line 4970 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2296; /* mmx_punpckhdq */
                  break;

                default:
                  break;
                }
            }
          x7 = XVECEXP (x3, 0, 0);
          operands[3] = x7;
          switch (pattern980 (x2))
            {
            case 0:
              if (!
#line 6197 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2362; /* *punpckwd */

            case 1:
              if (!
#line 6197 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2363; /* *punpckwd */

            case 2:
              if (!
#line 6197 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2364; /* *punpckwd */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4850 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2290; /* mmx_punpckhbw */

        case 2:
          if (!
#line 4890 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2292; /* mmx_punpcklbw */

        case 3:
          if (!
#line 4871 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2291; /* mmx_punpckhbw_low */

        case 4:
          if (!
#line 4928 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2294; /* mmx_punpckhwd */

        case 5:
          if (!
#line 4911 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2293; /* mmx_punpcklbw_low */

        case 6:
          if (!
#line 4949 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2295; /* mmx_punpcklwd */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern272 (x2) != 0
          || !
#line 8418 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4780; /* sse_cvtps2pi */

    case FIX:
      if (pattern274 (x2) != 0
          || !
#line 8482 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4782; /* sse_cvttps2pi */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 5901 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3793; /* *fma_fmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3810; /* *fma_fmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 5901 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3794; /* *fma_fmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3821; /* *fma_fmadd_df */

            case E_HFmode:
              if (pattern864 (x3, 
E_HFmode) != 0
                  || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5917 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3809; /* *fma_fmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x6) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6000 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3862; /* *fma_fmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3879; /* *fma_fmsub_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x6) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6000 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3863; /* *fma_fmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3890; /* *fma_fmsub_df */

            case E_HFmode:
              if (pattern865 (x3, 
E_HFmode) != 0
                  || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5917 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3878; /* *fma_fmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x5) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6106 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3931; /* *fma_fnmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3948; /* *fma_fnmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x5) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6106 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3932; /* *fma_fnmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3959; /* *fma_fnmadd_df */

            case E_HFmode:
              if (pattern866 (x3, 
E_HFmode) != 0
                  || !(
#line 6138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5917 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3947; /* *fma_fnmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern867 (x3, 
E_SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6213 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 4000; /* *fma_fnmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 4031; /* *fma_fnmsub_sf */

            case E_DFmode:
              if (pattern867 (x3, 
E_DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6213 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 4002; /* *fma_fnmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 4042; /* *fma_fnmsub_df */

            case E_HFmode:
              if (pattern868 (x3, 
E_HFmode) != 0
                  || !(
#line 6246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5917 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4030; /* *fma_fnmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern986 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 5437 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return 2318; /* *mmx_pextrw_zext */
          break;

        case 1:
          if (
#line 6098 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2356; /* *pextrw_zext */
          break;

        case 2:
          if (
#line 21114 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8459; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if (
#line 5474 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2322; /* *mmx_pextrb_zext */
          break;

        case 4:
          if (
#line 6130 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2360; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21114 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21057 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
            return 8457; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern986 (x2, 
E_DImode))
        {
        case 0:
          if ((
#line 5437 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2319; /* *mmx_pextrw_zext */
          break;

        case 1:
          if ((
#line 6098 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2357; /* *pextrw_zext */
          break;

        case 2:
          if ((
#line 21114 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 8460; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if ((
#line 5474 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2323; /* *mmx_pextrb_zext */
          break;

        case 4:
          if ((
#line 6130 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2361; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21114 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && (
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21057 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))))
            return 8458; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[1] = x6;
  switch (XWINT (x5, 0))
    {
    case 0L:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (register_operand (operands[1], E_V2SImode))
            {
              if (
#line 5749 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE4_1))
                return 2344; /* *vec_extractv2si_0_zext_sse4 */
              if (
#line 5764 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 2345; /* *vec_extractv2si_0_zext */
            }
          break;

        case E_V4SImode:
          if (register_operand (operands[1], E_V4SImode))
            {
              if (
#line 21214 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
                return 8467; /* *vec_extractv4si_0_zext_sse4 */
              if (
#line 21229 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 8468; /* *vec_extractv4si_0_zext */
            }
          break;

        default:
          break;
        }
      break;

    case 1L:
      if (register_operand (operands[1], E_V2SImode)
          && 
#line 5826 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE4_1))
        return 2347; /* *vec_extractv2si_1_zext */
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!memory_operand (operands[1], E_V2SImode)
          || !const_0_to_1_operand (operands[2], E_SImode)
          || !
#line 5842 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_64BIT))
        return -1;
      return 2348; /* *vec_extractv2si_zext_mem */

    case E_V4SImode:
      if (!const_0_to_3_operand (operands[2], E_SImode))
        return -1;
      if (register_operand (operands[1], E_V4SImode)
          && 
#line 21290 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
        return 8470; /* *vec_extractv4si_zext */
      if (!memory_operand (operands[1], E_V4SImode)
          || !
#line 21313 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
        return -1;
      return 8472; /* *vec_extractv4si_zext_mem */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x6;
              operands[1] = x4;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern604 (x2, 
E_SImode) != 0
                      || !
#line 8033 "../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))))
                    return -1;
                  return 376; /* *leasi_general_4 */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode)
                    return -1;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && (
#line 8033 "../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 378; /* *leadi_general_4 */
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !(
#line 14131 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return -1;
                  return 929; /* *concatsidi3_5 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              operands[1] = x4;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x5;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !(
#line 14054 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *concatsidi3_1 */

            case SUBREG:
              switch (pattern438 (x2, 
LSHIFTRT))
                {
                case 0:
                  operands[2] = x5;
                  if (pattern1360 (x2) == 0)
                    {
                      if (
#line 15431 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1066; /* x86_64_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15431 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1067; /* x86_64_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1361 (x2) != 0)
                    return -1;
                  if (
#line 15453 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1068; /* x86_64_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15453 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  operands[2] = x5;
                  if (pattern1362 (x2) == 0)
                    {
                      if (
#line 15668 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && TARGET_APX_NF))
                        return 1078; /* x86_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15668 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                        {
                          *pnum_clobbers = 1;
                          return 1079; /* x86_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1363 (x2) != 0)
                    return -1;
                  if (
#line 15690 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1080; /* x86_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15690 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern441 (x2, pnum_clobbers))
                {
                case 0:
                  if (
#line 15469 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1070; /* *x86_64_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15525 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (
#line 15706 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1082; /* *x86_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15762 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  operands[2] = x5;
                  if (rtx_equal_p (x4, operands[0]))
                    {
                      x8 = XEXP (x6, 1);
                      x9 = XEXP (x8, 1);
                      if (rtx_equal_p (x9, operands[2])
                          && 
#line 15578 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                        {
                          *pnum_clobbers = 1;
                          return 1072; /* *x86_64_shld_2 */
                        }
                    }
                  operands[2] = x7;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15599 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  operands[2] = x5;
                  if (rtx_equal_p (x4, operands[0]))
                    {
                      x8 = XEXP (x6, 1);
                      x9 = XEXP (x8, 1);
                      if (rtx_equal_p (x9, operands[2])
                          && 
#line 15814 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                        {
                          *pnum_clobbers = 1;
                          return 1084; /* *x86_shld_2 */
                        }
                    }
                  operands[2] = x7;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15835 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          switch (pattern288 (x2, 
LSHIFTRT))
            {
            case 0:
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (nonimmediate_operand (operands[0], E_DImode))
                {
                  res = recog_78 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[2] = x11;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15416 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1064; /* x86_64_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15416 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1065; /* x86_64_shld_ndd */

            case 1:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || pattern287 (x2, 
E_SImode, 
E_DImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (rtx_equal_p (x4, operands[0]))
                {
                  x13 = XEXP (x7, 1);
                  x14 = XEXP (x13, 1);
                  x15 = XEXP (x14, 0);
                  if (rtx_equal_p (x15, operands[2]))
                    {
                      if (
#line 15630 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                        return 1074; /* x86_shld_nf */
                      if (pnum_clobbers != NULL)
                        {
                          *pnum_clobbers = 1;
                          return 1075; /* x86_shld */
                        }
                    }
                }
              operands[2] = x11;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15652 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1076; /* x86_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15652 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1077; /* x86_shld_ndd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern256 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14090 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 905; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14163 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 935; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern256 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14090 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 908; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14163 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 938; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern286 (x2, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern752 (x2))
                {
                case 0:
                  if (
#line 18819 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    {
                      *pnum_clobbers = 1;
                      return 1391; /* *btssi */
                    }
                  break;

                case 1:
                  if ((
#line 18819 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1393; /* *btsdi */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern761 (x2))
            {
            case 0:
              if (!
#line 18838 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18838 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18866 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18866 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern738 (x2, 
E_DImode, 
E_QImode) == 0
              && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 1;
              return 1131; /* ashrdi3_doubleword */
            }
        }
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_DImode)
          && const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17258 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1168; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17258 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1169; /* ashrdi3_cvt */
            }
        }
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[2], E_DImode)
          && (
#line 17327 "../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1174; /* *bmi2_ashrdi3_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17337 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1177; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17337 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1178; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern624 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17337 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 1175; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17337 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 1176; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19338 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1434; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19338 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1435; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1455 (x4, 
E_SImode) != 0
          || !
#line 19419 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1442; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1455 (x4, 
E_DImode) != 0
          || !(
#line 19419 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1443; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      if (
#line 19487 "../../gcc/config/i386/i386.md"
(TARGET_APX_ZU))
        return 1445; /* *setcc_si_zu */
      if (pnum_clobbers != NULL
          && 
#line 19511 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
        {
          *pnum_clobbers = 1;
          return 1449; /* *setcc_si_1_and */
        }
      if (!
#line 19528 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))))
        return -1;
      return 1451; /* *setcc_si_1_movzbl */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !ix86_comparison_operator (operands[1], E_DImode))
        return -1;
      if ((
#line 19487 "../../gcc/config/i386/i386.md"
(TARGET_APX_ZU) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1446; /* *setcc_di_zu */
      if (!
#line 19495 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL))
        return -1;
      return 1447; /* *setcc_di_1 */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 17:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1487; /* *memory_blockage */

    case 14:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 20774 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1498; /* *set_got */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !
#line 20804 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 1500; /* set_got_rex64 */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!
#line 20796 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1499; /* *set_got_labelled */

        default:
          return -1;
        }

    case 15:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 20813 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 1501; /* set_rip_rex64 */

    case 16:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 20824 "../../gcc/config/i386/i386.md"
(TARGET_LP64))
        return -1;
      return 1502; /* set_got_offset_rex64 */

    case 97:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern300 (x2))
        {
        case 0:
          if ((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI)))
            return 1546; /* tzcnt_si_nf */
          if (pnum_clobbers == NULL
              || !
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1550; /* tzcnt_si */

        case 1:
          if ((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI))))
            return 1548; /* tzcnt_di_nf */
          if (pnum_clobbers == NULL
              || !(((
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI)))
            return -1;
          *pnum_clobbers = 1;
          return 1552; /* tzcnt_di */

        default:
          return -1;
        }

    case 96:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern300 (x2))
        {
        case 0:
          if ((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return 1547; /* lzcnt_si_nf */
          if (pnum_clobbers == NULL
              || !
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          *pnum_clobbers = 1;
          return 1551; /* lzcnt_si */

        case 1:
          if ((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))))
            return 1549; /* lzcnt_di_nf */
          if (pnum_clobbers == NULL
              || !(((
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return -1;
          *pnum_clobbers = 1;
          return 1553; /* lzcnt_di */

        default:
          return -1;
        }

    case 19:
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern23 (x2))
        {
        case 0:
          if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          return 1652; /* *load_tp_si */

        case 1:
          if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          return 1653; /* *load_tp_di */

        default:
          return -1;
        }

    case 22:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      switch (pattern23 (x2))
        {
        case 0:
          if (!(
#line 23207 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
            return -1;
          return 1661; /* *tls_dynamic_gnu2_lea_64_si */

        case 1:
          if (!(
#line 23207 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
            return -1;
          return 1662; /* *tls_dynamic_gnu2_lea_64_di */

        default:
          return -1;
        }

    case 70:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 24986 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          *pnum_clobbers = 1;
          return 1727; /* lrintxfdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !
#line 24995 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1729; /* lrintxfsi2 */

        default:
          return -1;
        }

    case 78:
      switch (pattern119 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 25202 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1740; /* *fistsi2_floor_1 */

        case 1:
          if (!
#line 25202 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1742; /* *fistdi2_floor_1 */

        default:
          return -1;
        }

    case 79:
      switch (pattern119 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 25202 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1741; /* *fistsi2_ceil_1 */

        case 1:
          if (!
#line 25202 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1743; /* *fistdi2_ceil_1 */

        default:
          return -1;
        }

    case 49:
      return recog_107 (x1, insn, pnum_clobbers);

    case 18:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode))
            return -1;
          *pnum_clobbers = 1;
          return 1855; /* probe_stack_1_si */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const0_operand (operands[1], E_DImode)
              || !
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode))
            return -1;
          *pnum_clobbers = 1;
          return 1856; /* probe_stack_1_di */

        default:
          return -1;
        }

    case 33:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1949; /* *pause */

    case 102:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 29666 "../../gcc/config/i386/i386.md"
(TARGET_MOVDIRI))
            return -1;
          return 1980; /* movdirisi */

        case 1:
          if (!(
#line 29666 "../../gcc/config/i386/i386.md"
(TARGET_MOVDIRI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1981; /* movdiridi */

        default:
          return -1;
        }

    case 103:
      if (GET_MODE (x2) != E_XImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_XImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_XImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !(
#line 29674 "../../gcc/config/i386/i386.md"
(TARGET_MOVDIR64B) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1982; /* movdir64b_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 29674 "../../gcc/config/i386/i386.md"
(TARGET_MOVDIR64B) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1983; /* movdir64b_di */

        default:
          return -1;
        }

    case 111:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 636 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
        return -1;
      return 2042; /* sse_movntq */

    case 117:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2009 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 2555; /* sse2_movntisi */

        case 1:
          if (!(
#line 2009 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 2556; /* sse2_movntidi */

        default:
          return -1;
        }

    case 156:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case VEC_SELECT:
          switch (pattern452 (x4))
            {
            case 0:
              switch (pattern1095 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 7811 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4539; /* avx512fp16_vcvtsh2usi */

                case 1:
                  if (!
#line 9023 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                    return -1;
                  return 4904; /* avx512f_vcvtss2usi */

                case 2:
                  if (!
#line 9059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                    return -1;
                  return 4916; /* avx512f_vcvtsd2usi */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1095 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 7811 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4543; /* avx512fp16_vcvtsh2usiq */

                case 1:
                  if (!(
#line 9023 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4906; /* avx512f_vcvtss2usiq */

                case 2:
                  if (!(
#line 9059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4918; /* avx512f_vcvtsd2usiq */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          switch (pattern23 (x2))
            {
            case 0:
              if (!
#line 7822 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4547; /* avx512fp16_vcvtsh2usi_2 */

            case 1:
              if (!(
#line 7822 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 4549; /* avx512fp16_vcvtsh2usiq_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 46:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case VEC_SELECT:
          switch (pattern452 (x4))
            {
            case 0:
              switch (pattern1096 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 7811 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4541; /* avx512fp16_vcvtsh2si */

                case 1:
                  if (!
#line 8551 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 4787; /* sse_cvtss2si */

                case 2:
                  if (!
#line 9095 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4928; /* sse2_cvtsd2si */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1096 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 7811 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4545; /* avx512fp16_vcvtsh2siq */

                case 1:
                  if (!(
#line 8551 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4789; /* sse_cvtss2siq */

                case 2:
                  if (!(
#line 9095 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4930; /* sse2_cvtsd2siq */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern766 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 7822 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4548; /* avx512fp16_vcvtsh2si_2 */

                case 1:
                  if (!
#line 8564 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 4791; /* sse_cvtss2si_2 */

                case 2:
                  if (!
#line 9109 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4932; /* sse2_cvtsd2si_2 */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern766 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 7822 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4550; /* avx512fp16_vcvtsh2siq_2 */

                case 1:
                  if (!(
#line 8564 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4792; /* sse_cvtss2siq_2 */

                case 2:
                  if (!(
#line 9109 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 4933; /* sse2_cvtsd2siq_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 172:
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 7976 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 4687; /* unspec_avx512fp16_fix_truncsi2 */

        case 1:
          if (!
#line 8579 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 4793; /* unspec_sse_cvttss2si */

        case 2:
          if (!
#line 9124 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4934; /* unspec_sse2_cvttsd2si */

        case 3:
          if (!(
#line 7976 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4691; /* unspec_avx512fp16_fix_truncdi2 */

        case 4:
          if (!(
#line 8579 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4795; /* unspec_sse_cvttss2siq */

        case 5:
          if (!(
#line 9124 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4936; /* unspec_sse2_cvttsd2siq */

        default:
          return -1;
        }

    case 173:
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 7976 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 4689; /* unspec_avx512fp16_fixuns_truncsi2 */

        case 1:
          if (!
#line 9034 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 4908; /* unspec_avx512f_vcvttss2usi */

        case 2:
          if (!
#line 9070 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 4920; /* unspec_avx512f_vcvttsd2usi */

        case 3:
          if (!(
#line 7976 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4693; /* unspec_avx512fp16_fixuns_truncdi2 */

        case 4:
          if (!(
#line 9034 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4910; /* unspec_avx512f_vcvttss2usiq */

        case 5:
          if (!(
#line 9070 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4922; /* unspec_avx512f_vcvttsd2usiq */

        default:
          return -1;
        }

    case 191:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_V64QImode)
              || !(
#line 10260 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5193; /* avx512bw_cvtb2maskv64qi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 10260 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5195; /* avx512vl_cvtb2maskv32qi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 10260 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5196; /* avx512bw_cvtw2maskv32hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 276:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 32611 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10913; /* avx10_2_vcvttsd2sissi */

        case 1:
          if (!
#line 32624 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10921; /* avx10_2_vcvttss2sissi */

        case 2:
          if (!(
#line 32611 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10917; /* avx10_2_vcvttsd2sisdi */

        case 3:
          if (!(
#line 32624 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10925; /* avx10_2_vcvttss2sisdi */

        default:
          return -1;
        }

    case 277:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 32611 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10915; /* avx10_2_vcvttsd2usissi */

        case 1:
          if (!
#line 32624 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10923; /* avx10_2_vcvttss2usissi */

        case 2:
          if (!(
#line 32611 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10919; /* avx10_2_vcvttsd2usisdi */

        case 3:
          if (!(
#line 32624 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10927; /* avx10_2_vcvttss2usisdi */

        default:
          return -1;
        }

    case 281:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 60 "../../gcc/config/i386/sync.md"
(TARGET_SSE2))
        return -1;
      return 11007; /* *sse2_lfence */

    case 282:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 79 "../../gcc/config/i386/sync.md"
(TARGET_SSE || TARGET_3DNOW_A))
        return -1;
      return 11008; /* *sse_sfence */

    case 283:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      if (
#line 98 "../../gcc/config/i386/sync.md"
(TARGET_64BIT || TARGET_SSE2))
        return 11009; /* mfence_sse2 */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 11010; /* mfence_nosse */

    case 285:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 356 "../../gcc/config/i386/sync.md"
(TARGET_80387))
        return -1;
      return 11018; /* storedi_via_fpu */

    case 287:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 382 "../../gcc/config/i386/sync.md"
(TARGET_SSE))
        return -1;
      return 11020; /* storedi_via_sse */

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (XWINT (x3, 0))
        {
        case 3L:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1006 (x2, 
E_V8HFmode, 
E_V2HFmode) == 0
                  && 
#line 11861 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return 5292; /* *vec_concatv8hf_movss */
              break;

            case E_V8BFmode:
              if (pattern1006 (x2, 
E_V8BFmode, 
E_V2BFmode) == 0
                  && 
#line 11861 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return 5293; /* *vec_concatv8bf_movss */
              break;

            case E_V8HImode:
              if (pattern1006 (x2, 
E_V8HImode, 
E_V2HImode) == 0
                  && 
#line 11861 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return 5294; /* *vec_concatv8hi_movss */
              break;

            default:
              break;
            }
          break;

        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern1007 (x2, 
E_V4SImode, 
E_SImode) == 0
                  && 
#line 11883 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return 5295; /* vec_setv4si_0 */
              break;

            case E_V4SFmode:
              if (pattern1007 (x2, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 11883 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return 5296; /* vec_setv4sf_0 */
              break;

            case E_V8HImode:
              if (pattern1006 (x2, 
E_V8HImode, 
E_HImode) == 0
                  && 
#line 11964 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 5297; /* vec_setv8hi_0 */
              break;

            case E_V8HFmode:
              if (pattern1006 (x2, 
E_V8HFmode, 
E_HFmode) == 0
                  && 
#line 11964 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 5298; /* vec_setv8hf_0 */
              break;

            case E_V8BFmode:
              if (pattern1006 (x2, 
E_V8BFmode, 
E_BFmode) == 0
                  && 
#line 11964 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 5299; /* vec_setv8bf_0 */
              break;

            case E_V16HImode:
              if (pattern1008 (x2, 
E_V16HImode, 
E_HImode) == 0
                  && 
#line 12059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return 5303; /* vec_setv16hi_0 */
              break;

            case E_V32HImode:
              if (pattern1008 (x2, 
E_V32HImode, 
E_HImode) == 0
                  && (
#line 12059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 985 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 5304; /* vec_setv32hi_0 */
              break;

            case E_V16HFmode:
              if (pattern1008 (x2, 
E_V16HFmode, 
E_HFmode) == 0
                  && 
#line 12059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return 5305; /* vec_setv16hf_0 */
              break;

            case E_V32HFmode:
              if (pattern1008 (x2, 
E_V32HFmode, 
E_HFmode) == 0
                  && (
#line 12059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 986 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 5306; /* vec_setv32hf_0 */
              break;

            case E_V16BFmode:
              if (pattern1008 (x2, 
E_V16BFmode, 
E_BFmode) == 0
                  && 
#line 12059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return 5307; /* vec_setv16bf_0 */
              break;

            case E_V32BFmode:
              if (pattern1008 (x2, 
E_V32BFmode, 
E_BFmode) == 0
                  && (
#line 12059 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 987 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 5308; /* vec_setv32bf_0 */
              break;

            case E_V8SImode:
              if (pattern1008 (x2, 
E_V8SImode, 
E_SImode) == 0
                  && 
#line 12166 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 5320; /* vec_setv8si_0 */
              break;

            case E_V8SFmode:
              if (pattern1008 (x2, 
E_V8SFmode, 
E_SFmode) == 0
                  && 
#line 12166 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 5321; /* vec_setv8sf_0 */
              break;

            case E_V16SImode:
              if (pattern1008 (x2, 
E_V16SImode, 
E_SImode) == 0
                  && (
#line 12166 "../../gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 994 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 5322; /* vec_setv16si_0 */
              break;

            case E_V16SFmode:
              if (pattern1008 (x2, 
E_V16SFmode, 
E_SFmode) == 0
                  && (
#line 12166 "../../gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 5323; /* vec_setv16sf_0 */
              break;

            case E_V2DFmode:
              if (pattern863 (x2, 
E_V2DFmode, 
E_DFmode) == 0
                  && 
#line 12280 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 5330; /* vec_setv2df_0 */
              break;

            case E_V8DFmode:
              if (pattern1008 (x2, 
E_V8DFmode, 
E_DFmode) == 0
                  && (
#line 14958 "../../gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 468 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 7218; /* vec_setv8df_0 */
              break;

            case E_V4DFmode:
              if (pattern1008 (x2, 
E_V4DFmode, 
E_DFmode) == 0
                  && 
#line 14958 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 7219; /* vec_setv4df_0 */
              break;

            case E_V8DImode:
              if (pattern1008 (x2, 
E_V8DImode, 
E_DImode) == 0
                  && (
#line 21746 "../../gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 711 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 8488; /* vec_setv8di_0 */
              break;

            case E_V4DImode:
              if (pattern1008 (x2, 
E_V4DImode, 
E_DImode) == 0
                  && 
#line 21746 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8489; /* vec_setv4di_0 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[3] = x3;
      if (const_int_operand (operands[3], E_SImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern886 (x2, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 12133 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4SFmode))))
                return 5319; /* *vec_setv4sf_sse4_1 */
              break;

            case E_V16QImode:
              if (pattern886 (x2, 
E_V16QImode, 
E_QImode) == 0
                  && (
#line 19881 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V16QImode))) && 
#line 19861 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                return 8376; /* sse4_1_pinsrb */
              break;

            case E_V8HImode:
              if (pattern886 (x2, 
E_V8HImode, 
E_HImode) == 0
                  && 
#line 19881 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HImode))))
                return 8377; /* sse2_pinsrw */
              break;

            case E_V8HFmode:
              if (pattern886 (x2, 
E_V8HFmode, 
E_HFmode) == 0
                  && 
#line 19881 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HFmode))))
                return 8378; /* sse2_pinsrph */
              break;

            case E_V8BFmode:
              if (pattern886 (x2, 
E_V8BFmode, 
E_BFmode) == 0
                  && 
#line 19881 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8BFmode))))
                return 8379; /* sse2_pinsrbf */
              break;

            case E_V4SImode:
              if (pattern886 (x2, 
E_V4SImode, 
E_SImode) == 0
                  && (
#line 19881 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4SImode))) && 
#line 19862 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                return 8380; /* sse4_1_pinsrd */
              break;

            case E_V2DImode:
              if (pattern886 (x2, 
E_V2DImode, 
E_DImode) == 0
                  && (
#line 19881 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2DImode))) && 
#line 19863 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_64BIT)))
                return 8381; /* sse4_1_pinsrq */
              break;

            case E_V8DFmode:
              if (pattern887 (x2, 
E_V8DFmode, 
E_V2DFmode) == 0
                  && (
#line 19985 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V8DFmode) == 4 ? 0xF : 0x3))) && 
#line 12393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
                return 8382; /* *avx512dq_vinsertf64x2_0 */
              break;

            case E_V8DImode:
              if (pattern887 (x2, 
E_V8DImode, 
E_V2DImode) == 0
                  && (
#line 19985 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V8DImode) == 4 ? 0xF : 0x3))) && 
#line 12394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
                return 8383; /* *avx512dq_vinserti64x2_0 */
              break;

            case E_V16SFmode:
              if (pattern887 (x2, 
E_V16SFmode, 
E_V4SFmode) == 0
                  && (
#line 19985 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V16SFmode) == 4 ? 0xF : 0x3))) && 
#line 12395 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8384; /* *avx512f_vinsertf32x4_0 */
              break;

            case E_V16SImode:
              if (pattern887 (x2, 
E_V16SImode, 
E_V4SImode) == 0
                  && (
#line 19985 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V16SImode) == 4 ? 0xF : 0x3))) && 
#line 12395 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8385; /* *avx512f_vinserti32x4_0 */
              break;

            default:
              break;
            }
        }
      if (XWINT (x3, 0) != 1L
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || GET_MODE (x4) != E_V4SImode)
        return -1;
      operands[2] = x5;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x6;
      if (!reg_or_0_operand (operands[1], E_V4SImode)
          || !
#line 21038 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 8452; /* sse2_loadld */

    case REG:
    case SUBREG:
      operands[3] = x3;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern146 (x2, 
E_V2DFmode, 
E_DFmode, 
E_QImode) != 0)
            return -1;
          if ((
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14886 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 7216; /* vec_dupv2df_mask */
          if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 298 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9285; /* avx512vl_vec_dup_gprv2df_mask */

        case E_V16SFmode:
          if (pattern773 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27742 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9231; /* avx512f_broadcastv16sf_mask */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9275; /* avx512f_vec_dup_gprv16sf_mask */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28062 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9331; /* avx512dq_broadcastv16sf_mask_1 */

            default:
              return -1;
            }

        case E_V16SImode:
          if (pattern773 (x2, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27742 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9233; /* avx512f_broadcastv16si_mask */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9263; /* avx512f_vec_dup_gprv16si_mask */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28062 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9333; /* avx512dq_broadcastv16si_mask_1 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (pattern773 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27754 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9235; /* avx512f_broadcastv8df_mask */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 298 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9281; /* avx512f_vec_dup_gprv8df_mask */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28073 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9337; /* avx512dq_broadcastv8df_mask_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (pattern773 (x2, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27754 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9237; /* avx512f_broadcastv8di_mask */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9269; /* avx512f_vec_dup_gprv8di_mask */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28073 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9335; /* avx512dq_broadcastv8di_mask_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (pattern146 (x2, 
E_V64QImode, 
E_QImode, 
E_DImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9239; /* avx512bw_vec_dup_gprv64qi_mask */

        case E_V16QImode:
          if (pattern146 (x2, 
E_V16QImode, 
E_QImode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9241; /* avx512vl_vec_dup_gprv16qi_mask */

        case E_V32QImode:
          if (pattern146 (x2, 
E_V32QImode, 
E_QImode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9243; /* avx512vl_vec_dup_gprv32qi_mask */

        case E_V32HImode:
          if (pattern146 (x2, 
E_V32HImode, 
E_HImode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9245; /* avx512bw_vec_dup_gprv32hi_mask */

        case E_V16HImode:
          if (pattern144 (x2, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9247; /* avx512vl_vec_dup_gprv16hi_mask */

        case E_V8HImode:
          if (pattern146 (x2, 
E_V8HImode, 
E_HImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9249; /* avx512vl_vec_dup_gprv8hi_mask */

        case E_V32HFmode:
          if (pattern146 (x2, 
E_V32HFmode, 
E_HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9251; /* avx512bw_vec_dup_gprv32hf_mask */

        case E_V16HFmode:
          if (pattern146 (x2, 
E_V16HFmode, 
E_HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9253; /* avx512vl_vec_dup_gprv16hf_mask */

        case E_V8HFmode:
          if (pattern146 (x2, 
E_V8HFmode, 
E_HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9255; /* avx512fp16_vec_dup_gprv8hf_mask */

        case E_V32BFmode:
          if (pattern146 (x2, 
E_V32BFmode, 
E_BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 325 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9257; /* avx512bw_vec_dup_gprv32bf_mask */

        case E_V16BFmode:
          if (pattern146 (x2, 
E_V16BFmode, 
E_BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 325 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9259; /* avx512vl_vec_dup_gprv16bf_mask */

        case E_V8BFmode:
          if (pattern146 (x2, 
E_V8BFmode, 
E_BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27766 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 325 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9261; /* avx512vl_vec_dup_gprv8bf_mask */

        case E_V8SImode:
          if (pattern773 (x2, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9265; /* avx512vl_vec_dup_gprv8si_mask */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9327; /* avx512vl_broadcastv8si_mask_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern146 (x2, 
E_V4SImode, 
E_SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9267; /* avx512vl_vec_dup_gprv4si_mask */

        case E_V4DImode:
          if (pattern773 (x2, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9271; /* avx512vl_vec_dup_gprv4di_mask */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9339; /* avx512dq_broadcastv4di_mask_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern146 (x2, 
E_V2DImode, 
E_DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9273; /* avx512vl_vec_dup_gprv2di_mask */

        case E_V8SFmode:
          if (pattern773 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9277; /* avx512vl_vec_dup_gprv8sf_mask */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9329; /* avx512vl_broadcastv8sf_mask_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern146 (x2, 
E_V4SFmode, 
E_SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9279; /* avx512vl_vec_dup_gprv4sf_mask */

        case E_V4DFmode:
          if (pattern773 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27778 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 298 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9283; /* avx512vl_vec_dup_gprv4df_mask */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9341; /* avx512dq_broadcastv4df_mask_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 3);
  if (GET_CODE (x6) != CONST_INT
      || pattern1301 (x4) != 0)
    return -1;
  x7 = XVECEXP (x4, 0, 12);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x4, 0, 13);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x4, 0, 14);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x4, 0, 15);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x2, 2);
  if (!register_operand (x11, E_HImode))
    return -1;
  x12 = XVECEXP (x4, 0, 0);
  switch (XWINT (x12, 0))
    {
    case 2L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 18L
          || XWINT (x5, 0) != 3L
          || XWINT (x6, 0) != 19L
          || pattern1833 (x4) != 0)
        return -1;
      x14 = XVECEXP (x4, 0, 8);
      if (XWINT (x14, 0) != 10L)
        return -1;
      x15 = XVECEXP (x4, 0, 9);
      if (XWINT (x15, 0) != 26L)
        return -1;
      x16 = XVECEXP (x4, 0, 10);
      if (XWINT (x16, 0) != 11L)
        return -1;
      x17 = XVECEXP (x4, 0, 11);
      if (XWINT (x17, 0) != 27L
          || pattern1865 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1580 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11152 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5245; /* avx512f_unpckhps512_mask */

        case E_V16SImode:
          if (pattern1580 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19744 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8367; /* avx512f_interleave_highv16si_mask */

        default:
          return -1;
        }

    case 0L:
      x13 = XVECEXP (x4, 0, 1);
      switch (XWINT (x13, 0))
        {
        case 16L:
          if (XWINT (x5, 0) != 1L
              || XWINT (x6, 0) != 17L)
            return -1;
          x18 = XEXP (x3, 0);
          x19 = XEXP (x18, 1);
          operands[2] = x19;
          x20 = XEXP (x2, 1);
          operands[3] = x20;
          operands[4] = x11;
          x21 = XVECEXP (x4, 0, 4);
          switch (XWINT (x21, 0))
            {
            case 4L:
              x22 = XVECEXP (x4, 0, 5);
              if (XWINT (x22, 0) != 20L)
                return -1;
              x23 = XVECEXP (x4, 0, 6);
              if (XWINT (x23, 0) != 5L)
                return -1;
              x24 = XVECEXP (x4, 0, 7);
              if (XWINT (x24, 0) != 21L)
                return -1;
              x14 = XVECEXP (x4, 0, 8);
              if (XWINT (x14, 0) != 8L)
                return -1;
              x15 = XVECEXP (x4, 0, 9);
              if (XWINT (x15, 0) != 24L)
                return -1;
              x16 = XVECEXP (x4, 0, 10);
              if (XWINT (x16, 0) != 9L)
                return -1;
              x17 = XVECEXP (x4, 0, 11);
              if (XWINT (x17, 0) != 25L
                  || XWINT (x7, 0) != 12L
                  || XWINT (x8, 0) != 28L
                  || XWINT (x9, 0) != 13L
                  || XWINT (x10, 0) != 29L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1580 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
                      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11240 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return -1;
                  return 5251; /* avx512f_unpcklps512_mask */

                case E_V16SImode:
                  if (pattern1580 (x2, 
E_V16SImode, 
E_V32SImode) != 0
                      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19799 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return -1;
                  return 8373; /* avx512f_interleave_lowv16si_mask */

                default:
                  return -1;
                }

            case 2L:
              x22 = XVECEXP (x4, 0, 5);
              if (XWINT (x22, 0) != 18L)
                return -1;
              x23 = XVECEXP (x4, 0, 6);
              if (XWINT (x23, 0) != 3L)
                return -1;
              x24 = XVECEXP (x4, 0, 7);
              if (XWINT (x24, 0) != 19L)
                return -1;
              x14 = XVECEXP (x4, 0, 8);
              switch (XWINT (x14, 0))
                {
                case 4L:
                  x15 = XVECEXP (x4, 0, 9);
                  if (XWINT (x15, 0) != 20L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 10);
                  if (XWINT (x16, 0) != 5L)
                    return -1;
                  x17 = XVECEXP (x4, 0, 11);
                  if (XWINT (x17, 0) != 21L
                      || XWINT (x7, 0) != 6L
                      || XWINT (x8, 0) != 22L
                      || XWINT (x9, 0) != 7L
                      || XWINT (x10, 0) != 23L
                      || pattern1581 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19568 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8327; /* vec_interleave_lowv16qi_mask */

                case 8L:
                  x15 = XVECEXP (x4, 0, 9);
                  if (XWINT (x15, 0) != 24L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 10);
                  if (XWINT (x16, 0) != 9L)
                    return -1;
                  x17 = XVECEXP (x4, 0, 11);
                  if (XWINT (x17, 0) != 25L
                      || XWINT (x7, 0) != 10L
                      || XWINT (x8, 0) != 26L
                      || XWINT (x9, 0) != 11L
                      || XWINT (x10, 0) != 27L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16HImode:
                      if (pattern1580 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19688 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 8353; /* avx2_interleave_lowv16hi_mask */

                    case E_V16HFmode:
                      if (pattern1580 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
                          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19688 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 8355; /* avx2_interleave_lowv16hf_mask */

                    case E_V16BFmode:
                      if (pattern1580 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
                          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19688 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 8357; /* avx2_interleave_lowv16bf_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (pattern1664 (x4) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 8);
          if (XWINT (x14, 0) != 8L)
            return -1;
          x15 = XVECEXP (x4, 0, 9);
          if (XWINT (x15, 0) != 8L)
            return -1;
          x16 = XVECEXP (x4, 0, 10);
          if (XWINT (x16, 0) != 10L)
            return -1;
          x17 = XVECEXP (x4, 0, 11);
          if (XWINT (x17, 0) != 10L
              || XWINT (x7, 0) != 12L
              || XWINT (x8, 0) != 12L
              || XWINT (x9, 0) != 14L
              || XWINT (x10, 0) != 14L
              || pattern1803 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11433 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5267; /* avx512f_movsldup512_mask */

        default:
          return -1;
        }

    case 1L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 1L
          || XWINT (x5, 0) != 3L
          || XWINT (x6, 0) != 3L)
        return -1;
      x21 = XVECEXP (x4, 0, 4);
      if (XWINT (x21, 0) != 5L)
        return -1;
      x22 = XVECEXP (x4, 0, 5);
      if (XWINT (x22, 0) != 5L)
        return -1;
      x23 = XVECEXP (x4, 0, 6);
      if (XWINT (x23, 0) != 7L)
        return -1;
      x24 = XVECEXP (x4, 0, 7);
      if (XWINT (x24, 0) != 7L)
        return -1;
      x14 = XVECEXP (x4, 0, 8);
      if (XWINT (x14, 0) != 9L)
        return -1;
      x15 = XVECEXP (x4, 0, 9);
      if (XWINT (x15, 0) != 9L)
        return -1;
      x16 = XVECEXP (x4, 0, 10);
      if (XWINT (x16, 0) != 11L)
        return -1;
      x17 = XVECEXP (x4, 0, 11);
      if (XWINT (x17, 0) != 11L
          || XWINT (x7, 0) != 13L
          || XWINT (x8, 0) != 13L
          || XWINT (x9, 0) != 15L
          || XWINT (x10, 0) != 15L
          || pattern1803 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11380 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5261; /* avx512f_movshdup512_mask */

    case 8L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 24L
          || XWINT (x5, 0) != 9L
          || XWINT (x6, 0) != 25L)
        return -1;
      x21 = XVECEXP (x4, 0, 4);
      if (XWINT (x21, 0) != 10L)
        return -1;
      x22 = XVECEXP (x4, 0, 5);
      if (XWINT (x22, 0) != 26L)
        return -1;
      x23 = XVECEXP (x4, 0, 6);
      if (XWINT (x23, 0) != 11L)
        return -1;
      x24 = XVECEXP (x4, 0, 7);
      if (XWINT (x24, 0) != 27L
          || pattern1848 (x4) != 0
          || XWINT (x7, 0) != 14L
          || XWINT (x8, 0) != 30L
          || XWINT (x9, 0) != 15L
          || XWINT (x10, 0) != 31L
          || pattern772 (x2, 
E_V32QImode, 
E_V16QImode) != 0
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      x18 = XEXP (x3, 0);
      x19 = XEXP (x18, 1);
      operands[2] = x19;
      if (!vector_operand (operands[2], E_V16QImode))
        return -1;
      x20 = XEXP (x2, 1);
      operands[3] = x20;
      if (!nonimm_or_0_operand (operands[3], E_V16QImode))
        return -1;
      operands[4] = x11;
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19472 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
        return -1;
      return 8321; /* vec_interleave_highv16qi_mask */

    case 4L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 20L
          || XWINT (x5, 0) != 5L
          || XWINT (x6, 0) != 21L
          || pattern1833 (x4) != 0
          || pattern1848 (x4) != 0
          || pattern1865 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1580 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19620 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8335; /* avx2_interleave_highv16hi_mask */

        case E_V16HFmode:
          if (pattern1580 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19620 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8337; /* avx2_interleave_highv16hf_mask */

        case E_V16BFmode:
          if (pattern1580 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19620 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8339; /* avx2_interleave_highv16bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_156 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern315 (x2))
        {
        case 0:
          res = recog_157 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 1:
          if (vector_all_ones_operand (operands[1], E_V16QImode)
              && const0_operand (operands[2], E_V16QImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7910; /* *avx2_pcmpv16qi3_6 */
          if (const0_operand (operands[1], E_V16QImode)
              && vector_all_ones_operand (operands[2], E_V16QImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7933; /* *avx2_pcmpv16qi3_8 */
          break;

        case 2:
          if (vector_all_ones_operand (operands[1], E_V8HImode)
              && const0_operand (operands[2], E_V8HImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7912; /* *avx2_pcmpv8hi3_6 */
          if (const0_operand (operands[1], E_V8HImode)
              && vector_all_ones_operand (operands[2], E_V8HImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7934; /* *avx2_pcmpv8hi3_8 */
          break;

        case 3:
          if (vector_all_ones_operand (operands[1], E_V4SImode)
              && const0_operand (operands[2], E_V4SImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7914; /* *avx2_pcmpv4si3_6 */
          if (const0_operand (operands[1], E_V4SImode)
              && vector_all_ones_operand (operands[2], E_V4SImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7935; /* *avx2_pcmpv4si3_8 */
          break;

        case 4:
          if (vector_all_ones_operand (operands[1], E_V2DImode)
              && const0_operand (operands[2], E_V2DImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7916; /* *avx2_pcmpv2di3_6 */
          if (const0_operand (operands[1], E_V2DImode)
              && vector_all_ones_operand (operands[2], E_V2DImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7936; /* *avx2_pcmpv2di3_8 */
          break;

        case 5:
          if (vector_all_ones_operand (operands[1], E_V32QImode)
              && const0_operand (operands[2], E_V32QImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7918; /* *avx2_pcmpv32qi3_6 */
          if (const0_operand (operands[1], E_V32QImode)
              && vector_all_ones_operand (operands[2], E_V32QImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7937; /* *avx2_pcmpv32qi3_8 */
          break;

        case 6:
          if (vector_all_ones_operand (operands[1], E_V16HImode)
              && const0_operand (operands[2], E_V16HImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7920; /* *avx2_pcmpv16hi3_6 */
          if (const0_operand (operands[1], E_V16HImode)
              && vector_all_ones_operand (operands[2], E_V16HImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7938; /* *avx2_pcmpv16hi3_8 */
          break;

        case 7:
          if (vector_all_ones_operand (operands[1], E_V8SImode)
              && const0_operand (operands[2], E_V8SImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7922; /* *avx2_pcmpv8si3_6 */
          if (const0_operand (operands[1], E_V8SImode)
              && vector_all_ones_operand (operands[2], E_V8SImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7939; /* *avx2_pcmpv8si3_8 */
          break;

        case 8:
          if (vector_all_ones_operand (operands[1], E_V4DImode)
              && const0_operand (operands[2], E_V4DImode)
              && 
#line 18120 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7924; /* *avx2_pcmpv4di3_6 */
          if (const0_operand (operands[1], E_V4DImode)
              && vector_all_ones_operand (operands[2], E_V4DImode)
              && 
#line 18178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7940; /* *avx2_pcmpv4di3_8 */
          break;

        case 9:
          if ((
#line 4145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3239; /* *avx_cmpv8sf3_2 */
          break;

        case 10:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7901; /* *avx2_pcmpv8si3_2 */
          break;

        case 11:
          if (
#line 4145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return 3240; /* *avx_cmpv4sf3_2 */
          break;

        case 12:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7897; /* *avx2_pcmpv4si3_2 */
          break;

        case 13:
          if ((
#line 4145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 423 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3241; /* *avx_cmpv4df3_2 */
          break;

        case 14:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7902; /* *avx2_pcmpv4di3_2 */
          break;

        case 15:
          if ((
#line 4145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 423 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 3242; /* *avx_cmpv2df3_2 */
          break;

        case 16:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7898; /* *avx2_pcmpv2di3_2 */
          break;

        case 17:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7895; /* *avx2_pcmpv16qi3_2 */
          break;

        case 18:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7896; /* *avx2_pcmpv8hi3_2 */
          break;

        case 19:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7899; /* *avx2_pcmpv32qi3_2 */
          break;

        case 20:
          if (
#line 17995 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7900; /* *avx2_pcmpv16hi3_2 */
          break;

        case 21:
          switch (GET_MODE (operands[0]))
            {
            case E_V64QImode:
              if (register_operand (operands[0], E_V64QImode)
                  && GET_MODE (x2) == E_V64QImode
                  && register_operand (operands[1], E_DImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V64QImode)
                      && const0_operand (operands[3], E_V64QImode)
                      && (
#line 10293 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5205; /* *avx512bw_cvtmask2bv64qi */
                  if (const0_operand (operands[2], E_V64QImode)
                      && vector_all_ones_operand (operands[3], E_V64QImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 505 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return 5217; /* *avx512bw_cvtmask2bv64qi_not */
                }
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x2) == E_V16QImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16QImode)
                      && const0_operand (operands[3], E_V16QImode)
                      && (
#line 10293 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5206; /* *avx512vl_cvtmask2bv16qi */
                  if (const0_operand (operands[2], E_V16QImode)
                      && vector_all_ones_operand (operands[3], E_V16QImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 5219; /* *avx512vl_cvtmask2bv16qi_not */
                }
              break;

            case E_V32QImode:
              if (register_operand (operands[0], E_V32QImode)
                  && GET_MODE (x2) == E_V32QImode
                  && register_operand (operands[1], E_SImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V32QImode)
                      && const0_operand (operands[3], E_V32QImode)
                      && (
#line 10293 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5207; /* *avx512vl_cvtmask2bv32qi */
                  if (const0_operand (operands[2], E_V32QImode)
                      && vector_all_ones_operand (operands[3], E_V32QImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 506 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 5218; /* *avx512vl_cvtmask2bv32qi_not */
                }
              break;

            case E_V32HImode:
              if (register_operand (operands[0], E_V32HImode)
                  && GET_MODE (x2) == E_V32HImode
                  && register_operand (operands[1], E_SImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V32HImode)
                      && const0_operand (operands[3], E_V32HImode)
                      && (
#line 10293 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5208; /* *avx512bw_cvtmask2wv32hi */
                  if (const0_operand (operands[2], E_V32HImode)
                      && vector_all_ones_operand (operands[3], E_V32HImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 508 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return 5220; /* *avx512bw_cvtmask2wv32hi_not */
                }
              break;

            case E_V16HImode:
              if (register_operand (operands[0], E_V16HImode)
                  && GET_MODE (x2) == E_V16HImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16HImode)
                      && const0_operand (operands[3], E_V16HImode)
                      && (
#line 10293 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5209; /* *avx512vl_cvtmask2wv16hi */
                  if (const0_operand (operands[2], E_V16HImode)
                      && vector_all_ones_operand (operands[3], E_V16HImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 509 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 5221; /* *avx512vl_cvtmask2wv16hi_not */
                }
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x2) == E_V8HImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8HImode)
                      && const0_operand (operands[3], E_V8HImode)
                      && (
#line 10293 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5210; /* *avx512vl_cvtmask2wv8hi */
                  if (const0_operand (operands[2], E_V8HImode)
                      && vector_all_ones_operand (operands[3], E_V8HImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 5222; /* *avx512vl_cvtmask2wv8hi_not */
                }
              break;

            case E_V16SImode:
              if (register_operand (operands[0], E_V16SImode)
                  && GET_MODE (x2) == E_V16SImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16SImode)
                      && const0_operand (operands[3], E_V16SImode)
                      && (
#line 10316 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5211; /* *avx512f_cvtmask2dv16si */
                  if (const0_operand (operands[2], E_V16SImode)
                      && vector_all_ones_operand (operands[3], E_V16SImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5223; /* *avx512f_cvtmask2dv16si_not */
                }
              break;

            case E_V8SImode:
              if (register_operand (operands[0], E_V8SImode)
                  && GET_MODE (x2) == E_V8SImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8SImode)
                      && const0_operand (operands[3], E_V8SImode)
                      && (
#line 10316 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5212; /* *avx512vl_cvtmask2dv8si */
                  if (const0_operand (operands[2], E_V8SImode)
                      && vector_all_ones_operand (operands[3], E_V8SImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5224; /* *avx512vl_cvtmask2dv8si_not */
                }
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x2) == E_V4SImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V4SImode)
                      && const0_operand (operands[3], E_V4SImode)
                      && (
#line 10316 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5213; /* *avx512vl_cvtmask2dv4si */
                  if (const0_operand (operands[2], E_V4SImode)
                      && vector_all_ones_operand (operands[3], E_V4SImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5225; /* *avx512vl_cvtmask2dv4si_not */
                }
              break;

            case E_V8DImode:
              if (register_operand (operands[0], E_V8DImode)
                  && GET_MODE (x2) == E_V8DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8DImode)
                      && const0_operand (operands[3], E_V8DImode)
                      && (
#line 10316 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5214; /* *avx512f_cvtmask2qv8di */
                  if (const0_operand (operands[2], E_V8DImode)
                      && vector_all_ones_operand (operands[3], E_V8DImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 512 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5226; /* *avx512f_cvtmask2qv8di_not */
                }
              break;

            case E_V4DImode:
              if (register_operand (operands[0], E_V4DImode)
                  && GET_MODE (x2) == E_V4DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V4DImode)
                      && const0_operand (operands[3], E_V4DImode)
                      && (
#line 10316 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5215; /* *avx512vl_cvtmask2qv4di */
                  if (const0_operand (operands[2], E_V4DImode)
                      && vector_all_ones_operand (operands[3], E_V4DImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 512 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5227; /* *avx512vl_cvtmask2qv4di_not */
                }
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V2DImode)
                      && const0_operand (operands[3], E_V2DImode)
                      && (
#line 10316 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5216; /* *avx512vl_cvtmask2qv2di */
                  if (const0_operand (operands[2], E_V2DImode)
                      && vector_all_ones_operand (operands[3], E_V2DImode)
                      && (
#line 10342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 512 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 5228; /* *avx512vl_cvtmask2qv2di_not */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  switch (pattern318 (x2))
    {
    case 0:
      if (!(
#line 4172 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3243; /* *avx_cmpv8sf3_3 */

    case 1:
      if (!
#line 4172 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 3244; /* *avx_cmpv4sf3_3 */

    case 2:
      if (!(
#line 4172 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 423 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3245; /* *avx_cmpv4df3_3 */

    case 3:
      if (!(
#line 4172 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 423 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3246; /* *avx_cmpv2df3_3 */

    case 4:
      if (!(
#line 4193 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3247; /* *avx_cmpv8sf3_4 */

    case 5:
      if (!
#line 4193 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 3248; /* *avx_cmpv4sf3_4 */

    case 6:
      if (!(
#line 4193 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 423 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3249; /* *avx_cmpv4df3_4 */

    case 7:
      if (!(
#line 4193 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 423 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3250; /* *avx_cmpv2df3_4 */

    default:
      return -1;
    }
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern132 (x2))
    {
    case 0:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 2990; /* *smaxv32hf3_mask */

    case 1:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2998; /* *smaxv16hf3_mask */

    case 2:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 3005; /* *smaxv8hf3_mask */

    case 3:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 3010; /* *smaxv16sf3_mask */

    case 4:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3018; /* *smaxv8sf3_mask */

    case 5:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
        return -1;
      return 3025; /* *smaxv4sf3_mask */

    case 6:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 3030; /* *smaxv8df3_mask */

    case 7:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3038; /* *smaxv4df3_mask */

    case 8:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3306 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 395 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3045; /* *smaxv2df3_mask */

    case 9:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7768; /* *avx512f_smaxv16si3_mask */

    case 10:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7776; /* *avx512f_smaxv8si3_mask */

    case 11:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7784; /* *avx512f_smaxv4si3_mask */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17811 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7868; /* *sse4_1_smaxv4si3_mask */

    case 12:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7792; /* *avx512f_smaxv8di3_mask */

    case 13:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7800; /* *avx512f_smaxv4di3_mask */

    case 14:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7808; /* *avx512f_smaxv2di3_mask */

    case 15:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17719 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7816; /* smaxv64qi3_mask */

    case 16:
      if (register_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17719 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7824; /* smaxv16qi3_mask */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17811 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7864; /* *sse4_1_smaxv16qi3_mask */

    case 17:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17719 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7832; /* smaxv32qi3_mask */

    case 18:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17719 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7840; /* smaxv32hi3_mask */

    case 19:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17719 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7848; /* smaxv16hi3_mask */

    case 20:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17719 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7856; /* smaxv8hi3_mask */

    case 21:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32100 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10591; /* avx10_2_smaxpbf16_v32bf_mask */

    case 22:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32100 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 10595; /* avx10_2_smaxpbf16_v16bf_mask */

    case 23:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32100 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 10599; /* avx10_2_smaxpbf16_v8bf_mask */

    case 24:
      if (!(
#line 3467 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3127; /* *avx512fp16_vmsmaxv8hf3 */

    case 25:
      if (!
#line 3467 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3135; /* *sse_vmsmaxv4sf3 */

    case 26:
      if (!(
#line 3467 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 480 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3143; /* *sse2_vmsmaxv2df3 */

    default:
      return -1;
    }
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern321 (x2))
    {
    case 0:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4415; /* avx512fp16_vcvtph2uw_v32hi */

    case 1:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!vector_operand (operands[1], E_V16HFmode)
              || !(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4423; /* avx512fp16_vcvtph2udq_v16si */

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !(
#line 8706 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 675 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4838; /* *avx512f_fixuns_notruncv16sfv16si */

        default:
          return -1;
        }

    case 2:
      switch (pattern775 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4431; /* avx512fp16_vcvtph2uqq_v8di */

        case 1:
          if (!(
#line 8739 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 627 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4858; /* *avx512dq_cvtps2uqqv8di */

        case 2:
          if (!(
#line 9721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 537 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5104; /* fixuns_notruncv8dfv8di2 */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4439; /* avx512fp16_vcvtph2uw_v16hi */

    case 4:
      switch (pattern775 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4447; /* avx512fp16_vcvtph2udq_v8si */

        case 1:
          if (!(
#line 8706 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 675 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4842; /* *avx512vl_fixuns_notruncv8sfv8si */

        case 2:
          if (!(
#line 9500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 471 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5010; /* fixuns_notruncv8dfv8si2 */

        default:
          return -1;
        }

    case 5:
      switch (pattern776 (x2, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4455; /* avx512fp16_vcvtph2uqq_v4di */

        case 1:
          if (!(
#line 8739 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 627 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4862; /* *avx512dq_cvtps2uqqv4di */

        case 2:
          if (!(
#line 9721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 537 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5108; /* fixuns_notruncv4dfv4di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4463; /* avx512fp16_vcvtph2uw_v8hi */

    case 7:
      switch (pattern776 (x2, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 761 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4467; /* avx512fp16_vcvtph2udq_v4si */

        case 1:
          if (!(
#line 8706 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 675 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4846; /* *avx512vl_fixuns_notruncv4sfv4si */

        case 2:
          if (!(
#line 9500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 471 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5014; /* fixuns_notruncv4dfv4si2 */

        default:
          return -1;
        }

    case 8:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7617 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 761 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4471; /* avx512fp16_vcvtph2uqq_v2di */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 9721 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 537 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5112; /* fixuns_notruncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 8752 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4866; /* *avx512dq_cvtps2uqqv2di */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      return recog_220 (x1, insn, pnum_clobbers);

    case 3:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      switch (XINT (x4, 1))
        {
        case 192:
          x7 = XEXP (x3, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1407 (x2))
            {
            case 0:
              if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4041 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3221; /* reducesv8hf_round */

            case 1:
              if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4041 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode)))))
                return -1;
              return 3225; /* reducesv4sf_round */

            case 2:
              if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4041 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 480 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3229; /* reducesv2df_round */

            default:
              return -1;
            }

        case 133:
          return recog_218 (x1, insn, pnum_clobbers);

        case 217:
          switch (pattern1129 (x2))
            {
            case 0:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7147 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4324; /* fma_fmaddc_v32hf_maskz_1_round */

            case 1:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7147 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4332; /* fma_fmaddc_v16hf_maskz_1_round */

            case 2:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4366; /* avx512bw_fmaddc_v32hf_mask_round */

            case 3:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4370; /* avx512vl_fmaddc_v16hf_mask_round */

            case 4:
              if (!(
#line 460 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7474 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4397; /* avx512fp16_fma_fmaddcsh_v8hf_round */

            default:
              return -1;
            }

        case 219:
          switch (pattern1129 (x2))
            {
            case 0:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7147 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4328; /* fma_fcmaddc_v32hf_maskz_1_round */

            case 1:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7147 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4336; /* fma_fcmaddc_v16hf_maskz_1_round */

            case 2:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4368; /* avx512bw_fcmaddc_v32hf_mask_round */

            case 3:
              if (!(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4372; /* avx512vl_fcmaddc_v16hf_mask_round */

            case 4:
              if (!(
#line 460 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7474 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4401; /* avx512fp16_fma_fcmaddcsh_v8hf_round */

            default:
              return -1;
            }

        case 194:
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x9, E_SImode))
            return -1;
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              x10 = XEXP (x3, 1);
              operands[4] = x10;
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1644 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29812 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 9959; /* avx512dq_rangepv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1644 (x2, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29812 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                    return -1;
                  return 9963; /* avx512dq_rangepv8sf_mask_round */

                case E_V8DFmode:
                  if (pattern1644 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29812 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 522 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 9969; /* avx512dq_rangepv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1644 (x2, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29812 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 522 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                    return -1;
                  return 9973; /* avx512dq_rangepv4df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[4] = x9;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1405 (x2, 
E_V4SFmode) != 0
                      || !(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29835 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                    return -1;
                  return 9978; /* avx512dq_rangesv4sf_round */

                case E_V2DFmode:
                  if (pattern1405 (x2, 
E_V2DFmode) != 0
                      || !(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29835 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 475 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 9982; /* avx512dq_rangesv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 166:
          x7 = XEXP (x3, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1407 (x2))
            {
            case 0:
              if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 10040; /* avx512f_vgetmantv8hf_round */

            case 1:
              if (!
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 10044; /* avx512f_vgetmantv4sf_round */

            case 2:
              if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 480 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 10048; /* avx512f_vgetmantv2df_round */

            default:
              return -1;
            }

        case 279:
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x9, E_SImode))
            return -1;
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              x10 = XEXP (x3, 1);
              operands[4] = x10;
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1644 (x2, 
E_V32HFmode, 
E_SImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 532 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
                    return -1;
                  return 10938; /* avx10_2_minmaxpv32hf_mask_round */

                case E_V16HFmode:
                  if (pattern1644 (x2, 
E_V16HFmode, 
E_HImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10942; /* avx10_2_minmaxpv16hf_mask_round */

                case E_V8HFmode:
                  if (pattern1644 (x2, 
E_V8HFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10946; /* avx10_2_minmaxpv8hf_mask_round */

                case E_V16SFmode:
                  if (pattern1644 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 533 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
                    return -1;
                  return 10950; /* avx10_2_minmaxpv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1644 (x2, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10954; /* avx10_2_minmaxpv8sf_mask_round */

                case E_V4SFmode:
                  if (pattern1644 (x2, 
E_V4SFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10958; /* avx10_2_minmaxpv4sf_mask_round */

                case E_V8DFmode:
                  if (pattern1644 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 534 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
                    return -1;
                  return 10962; /* avx10_2_minmaxpv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1644 (x2, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10966; /* avx10_2_minmaxpv4df_mask_round */

                case E_V2DFmode:
                  if (pattern1644 (x2, 
E_V2DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))))
                    return -1;
                  return 10970; /* avx10_2_minmaxpv2df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[4] = x9;
              switch (pattern1406 (x2))
                {
                case 0:
                  if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32664 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 10973; /* avx10_2_minmaxsv8hf_round */

                case 1:
                  if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32664 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                    return -1;
                  return 10977; /* avx10_2_minmaxsv4sf_round */

                case 2:
                  if (!(
#line 486 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32664 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 480 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 10981; /* avx10_2_minmaxsv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_219 (x1, insn, pnum_clobbers);

    case 4:
      if (XINT (x4, 1) != 163)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x4, 0, 2);
      operands[3] = x8;
      x11 = XVECEXP (x4, 0, 3);
      operands[4] = x11;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[5] = x10;
          x7 = XEXP (x3, 2);
          operands[6] = x7;
          operands[7] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1669 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14146 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7099; /* avx512f_fixupimmv16sf_maskz_1_round */

            case E_V8SFmode:
              if (pattern1669 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14146 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7103; /* avx512vl_fixupimmv8sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1669 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14146 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 522 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7109; /* avx512f_fixupimmv8df_maskz_1_round */

            case E_V4DFmode:
              if (pattern1669 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                  || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14146 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 522 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7113; /* avx512vl_fixupimmv4df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              operands[6] = x9;
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1695 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14162 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7117; /* avx512f_fixupimmv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1695 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14162 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7119; /* avx512vl_fixupimmv8sf_mask_round */

                case E_V8DFmode:
                  if (pattern1695 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14162 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 522 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7122; /* avx512f_fixupimmv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1695 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14162 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 522 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7124; /* avx512vl_fixupimmv4df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[5] = x9;
              if (!rtx_equal_p (x10, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1696 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 7127; /* avx512f_sfixupimmv4sf_round */

                case E_V2DFmode:
                  if (pattern1696 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !(
#line 286 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14194 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 475 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 7131; /* avx512f_sfixupimmv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (!const_4_or_8_to_11_operand (x3, E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_MERGE:
      if (GET_MODE (x5) != E_V4HFmode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_V4HFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 4)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x7, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x7, 0, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x7, 0, 3);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || !register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || GET_MODE (x4) != E_V8HFmode)
        return -1;
      x12 = XEXP (x5, 0);
      if (GET_MODE (x12) != E_V4HFmode)
        return -1;
      x13 = XEXP (x6, 0);
      operands[2] = x13;
      if (!nonimm_or_0_operand (operands[2], E_V8HFmode))
        return -1;
      x14 = XEXP (x5, 2);
      operands[3] = x14;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x15 = XEXP (x4, 1);
      operands[4] = x15;
      if (!const0_operand (operands[4], E_V4HFmode))
        return -1;
      operands[5] = x3;
      switch (GET_CODE (x12))
        {
        case FLOAT:
          x16 = XEXP (x12, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_V4DImode)
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7707 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode))))))
            return -1;
          return 4526; /* avx512fp16_vcvtqq2ph_v4di_mask_round_1 */

        case UNSIGNED_FLOAT:
          x16 = XEXP (x12, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_V4DImode)
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7707 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode))))))
            return -1;
          return 4528; /* avx512fp16_vcvtuqq2ph_v4di_mask_round_1 */

        case FLOAT_TRUNCATE:
          x16 = XEXP (x12, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_V4DFmode)
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8191 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode))))))
            return -1;
          return 4748; /* avx512fp16_vcvtpd2ph_v4df_mask_round_1 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x15 = XEXP (x4, 1);
      if (GET_CODE (x15) != FLOAT_TRUNCATE)
        return -1;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      x17 = XEXP (x15, 0);
      operands[1] = x17;
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1312 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31706 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 562 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10434; /* avx10_2_cvt2ps2phx_v32hf_round */

        case E_V16HFmode:
          if (pattern1312 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31706 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode))))))
            return -1;
          return 10438; /* avx10_2_cvt2ps2phx_v16hf_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM)
    return -1;
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 154)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!const1248_operand (operands[4], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  x8 = XEXP (x1, 1);
  x9 = XVECEXP (x8, 0, 1);
  operands[3] = x9;
  x10 = XVECEXP (x8, 0, 0);
  if (!rtx_equal_p (x10, operands[6]))
    return -1;
  switch (GET_MODE (operands[5]))
    {
    case E_V16SImode:
      if (!vsib_mem_operator (operands[5], E_V16SImode)
          || GET_MODE (x8) != E_V16SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          switch (pattern1697 (
E_SImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9836; /* *avx512f_scattersiv16si */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9860; /* *avx512f_scatterdiv16si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1697 (
E_DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9848; /* *avx512f_scattersiv16si */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9872; /* *avx512f_scatterdiv16si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!vsib_mem_operator (operands[5], E_V16SFmode)
          || GET_MODE (x8) != E_V16SFmode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          switch (pattern1698 (
E_SImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9837; /* *avx512f_scattersiv16sf */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9861; /* *avx512f_scatterdiv16sf */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1698 (
E_DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9849; /* *avx512f_scattersiv16sf */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9873; /* *avx512f_scatterdiv16sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern1600 (x1, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9838; /* *avx512f_scattersiv8di */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9862; /* *avx512f_scatterdiv8di */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9850; /* *avx512f_scattersiv8di */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9874; /* *avx512f_scatterdiv8di */

        default:
          return -1;
        }

    case E_V8DFmode:
      switch (pattern1600 (x1, 
E_V8DFmode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9839; /* *avx512f_scattersiv8df */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9863; /* *avx512f_scatterdiv8df */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9851; /* *avx512f_scattersiv8df */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9875; /* *avx512f_scatterdiv8df */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern1601 (x1, 
E_V8SImode))
        {
        case 0:
          switch (pattern1734 (
E_SImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9840; /* *avx512f_scattersiv8si */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9864; /* *avx512f_scatterdiv8si */

            default:
              return -1;
            }

        case 1:
          switch (pattern1734 (
E_DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9852; /* *avx512f_scattersiv8si */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9876; /* *avx512f_scatterdiv8si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8SFmode:
      switch (pattern1601 (x1, 
E_V8SFmode))
        {
        case 0:
          switch (pattern1735 (
E_SImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9841; /* *avx512f_scattersiv8sf */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9865; /* *avx512f_scatterdiv8sf */

            default:
              return -1;
            }

        case 1:
          switch (pattern1735 (
E_DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9853; /* *avx512f_scattersiv8sf */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9877; /* *avx512f_scatterdiv8sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern1603 (x1, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9842; /* *avx512f_scattersiv4di */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9866; /* *avx512f_scatterdiv4di */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9854; /* *avx512f_scattersiv4di */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9878; /* *avx512f_scatterdiv4di */

        default:
          return -1;
        }

    case E_V4DFmode:
      switch (pattern1603 (x1, 
E_V4DFmode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9843; /* *avx512f_scattersiv4df */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9867; /* *avx512f_scatterdiv4df */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9855; /* *avx512f_scattersiv4df */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9879; /* *avx512f_scatterdiv4df */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern1605 (x1, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9844; /* *avx512f_scattersiv4si */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9868; /* *avx512f_scatterdiv4si */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9856; /* *avx512f_scattersiv4si */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9880; /* *avx512f_scatterdiv4si */

        default:
          return -1;
        }

    case E_V4SFmode:
      switch (pattern1605 (x1, 
E_V4SFmode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9845; /* *avx512f_scattersiv4sf */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9869; /* *avx512f_scatterdiv4sf */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9857; /* *avx512f_scattersiv4sf */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9881; /* *avx512f_scatterdiv4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern1605 (x1, 
E_V2DImode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9846; /* *avx512f_scattersiv2di */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9870; /* *avx512f_scatterdiv2di */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9858; /* *avx512f_scattersiv2di */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9882; /* *avx512f_scatterdiv2di */

        default:
          return -1;
        }

    case E_V2DFmode:
      switch (pattern1605 (x1, 
E_V2DFmode))
        {
        case 0:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9847; /* *avx512f_scattersiv2df */

        case 1:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9871; /* *avx512f_scatterdiv2df */

        case 2:
          if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9859; /* *avx512f_scattersiv2df */

        case 3:
          if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9883; /* *avx512f_scatterdiv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
      switch (pattern495 (x3))
        {
        case 0:
          if (!
#line 21598 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512VBMI
   && ix86_pre_reload_split ()))
            return -1;
          return 8481; /* *vec_concatv16qi_permt2 */

        case 1:
          if (!
#line 21623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW
   && ix86_pre_reload_split ()))
            return -1;
          return 8482; /* *vec_concatv8hi_permt2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern169 (x3, 
E_V16SImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9378; /* avx512f_vpermt2varv16si3 */

        case E_V16SFmode:
          if (pattern1028 (x3, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9380; /* avx512f_vpermt2varv16sf3 */

        case E_V8DImode:
          if (pattern169 (x3, 
E_V8DImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9382; /* avx512f_vpermt2varv8di3 */

        case E_V8DFmode:
          if (pattern1028 (x3, 
E_V8DFmode, 
E_V8DImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9384; /* avx512f_vpermt2varv8df3 */

        case E_V8SImode:
          if (pattern169 (x3, 
E_V8SImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9386; /* avx512vl_vpermt2varv8si3 */

        case E_V8SFmode:
          if (pattern1028 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9388; /* avx512vl_vpermt2varv8sf3 */

        case E_V4DImode:
          if (pattern169 (x3, 
E_V4DImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28133 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9390; /* avx512vl_vpermt2varv4di3 */

        case E_V4DFmode:
          if (pattern1028 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28133 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9392; /* avx512vl_vpermt2varv4df3 */

        case E_V4SImode:
          if (pattern169 (x3, 
E_V4SImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28134 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9394; /* avx512vl_vpermt2varv4si3 */

        case E_V4SFmode:
          if (pattern1028 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28134 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9396; /* avx512vl_vpermt2varv4sf3 */

        case E_V2DImode:
          if (pattern169 (x3, 
E_V2DImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9398; /* avx512vl_vpermt2varv2di3 */

        case E_V2DFmode:
          if (pattern1028 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9400; /* avx512vl_vpermt2varv2df3 */

        case E_V32HImode:
          if (pattern169 (x3, 
E_V32HImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 9402; /* avx512bw_vpermt2varv32hi3 */

        case E_V16HImode:
          if (pattern169 (x3, 
E_V16HImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9404; /* avx512vl_vpermt2varv16hi3 */

        case E_V8HImode:
          if (pattern169 (x3, 
E_V8HImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9406; /* avx512vl_vpermt2varv8hi3 */

        case E_V64QImode:
          if (pattern169 (x3, 
E_V64QImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28139 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 9408; /* avx512bw_vpermt2varv64qi3 */

        case E_V32QImode:
          if (pattern169 (x3, 
E_V32QImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28140 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9410; /* avx512vl_vpermt2varv32qi3 */

        case E_V16QImode:
          if (pattern169 (x3, 
E_V16QImode) != 0
              || !(
#line 28223 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28141 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9412; /* avx512vl_vpermt2varv16qi3 */

        case E_V32HFmode:
          if (pattern1028 (x3, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 28238 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9414; /* avx512bw_vpermt2varv32hf3 */

        case E_V16HFmode:
          if (pattern1028 (x3, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 28238 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9416; /* avx512vl_vpermt2varv16hf3 */

        case E_V8HFmode:
          if (pattern1028 (x3, 
E_V8HFmode, 
E_V8HImode) != 0
              || !(
#line 28238 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9418; /* avx512fp16_vpermt2varv8hf3 */

        case E_V32BFmode:
          if (pattern1028 (x3, 
E_V32BFmode, 
E_V32HImode) != 0
              || !(
#line 28238 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 559 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9420; /* avx512bw_vpermt2varv32bf3 */

        case E_V16BFmode:
          if (pattern1028 (x3, 
E_V16BFmode, 
E_V16HImode) != 0
              || !(
#line 28238 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 559 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9422; /* avx512vl_vpermt2varv16bf3 */

        case E_V8BFmode:
          if (pattern1028 (x3, 
E_V8BFmode, 
E_V8HImode) != 0
              || !(
#line 28238 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 559 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9424; /* avx512vl_vpermt2varv8bf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern149 (x3, 
E_V32HFmode) != 0
          || !(
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 532 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10935; /* avx10_2_minmaxpv32hf */

    case E_V16HFmode:
      if (pattern149 (x3, 
E_V16HFmode) != 0
          || !
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10939; /* avx10_2_minmaxpv16hf */

    case E_V8HFmode:
      if (pattern149 (x3, 
E_V8HFmode) != 0
          || !
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10943; /* avx10_2_minmaxpv8hf */

    case E_V16SFmode:
      if (pattern149 (x3, 
E_V16SFmode) != 0
          || !(
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 533 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10947; /* avx10_2_minmaxpv16sf */

    case E_V8SFmode:
      if (pattern149 (x3, 
E_V8SFmode) != 0
          || !
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10951; /* avx10_2_minmaxpv8sf */

    case E_V4SFmode:
      if (pattern149 (x3, 
E_V4SFmode) != 0
          || !
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10955; /* avx10_2_minmaxpv4sf */

    case E_V8DFmode:
      if (pattern149 (x3, 
E_V8DFmode) != 0
          || !(
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 534 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10959; /* avx10_2_minmaxpv8df */

    case E_V4DFmode:
      if (pattern149 (x3, 
E_V4DFmode) != 0
          || !
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10963; /* avx10_2_minmaxpv4df */

    case E_V2DFmode:
      if (pattern149 (x3, 
E_V2DFmode) != 0
          || !
#line 32649 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10967; /* avx10_2_minmaxpv2df */

    default:
      return -1;
    }
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern60 (x3, 
E_V16SImode) != 0
          || !(
#line 14056 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7076; /* *avx512f_alignv16si */

    case E_V8SImode:
      if (pattern60 (x3, 
E_V8SImode) != 0
          || !(
#line 14056 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7078; /* *avx512vl_alignv8si */

    case E_V4SImode:
      if (pattern60 (x3, 
E_V4SImode) != 0
          || !(
#line 14056 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7080; /* *avx512vl_alignv4si */

    case E_V8DImode:
      if (pattern60 (x3, 
E_V8DImode) != 0
          || !(
#line 14056 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7082; /* *avx512f_alignv8di */

    case E_V4DImode:
      if (pattern60 (x3, 
E_V4DImode) != 0
          || !(
#line 14056 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7084; /* *avx512vl_alignv4di */

    case E_V2DImode:
      if (pattern60 (x3, 
E_V2DImode) != 0
          || !(
#line 14056 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7086; /* *avx512vl_alignv2di */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1))
    {
    case 0:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10179; /* vpshrd_v32hi */

    case 1:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10181; /* vpshrd_v16si */

    case 2:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10183; /* vpshrd_v8di */

    case 3:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10185; /* vpshrd_v16hi */

    case 4:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10187; /* vpshrd_v8si */

    case 5:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10189; /* vpshrd_v4di */

    case 6:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10191; /* vpshrd_v8hi */

    case 7:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10193; /* vpshrd_v4si */

    case 8:
      if (!(
#line 30396 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10195; /* vpshrd_v2di */

    default:
      return -1;
    }
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !nonimmediate_operand (operands[2], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 11675 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 5276; /* sse_loadlps */

        case E_V4DImode:
          if (pattern1231 (x2, 
E_V4DImode, 
E_V2DImode) != 0
              || !
#line 28432 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9458; /* vec_set_lo_v4di */

        case E_V4DFmode:
          if (pattern1231 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
              || !
#line 28432 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9460; /* vec_set_lo_v4df */

        default:
          return -1;
        }

    case 1:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !nonimmediate_operand (operands[2], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nonimm_or_0_operand (operands[1], E_V2DFmode)
          || !
#line 14787 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7212; /* sse2_loadlpd */

    case 8:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 10]
          || pattern1232 (x4, 
15, 
14, 
13, 
12, 
11) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1231 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
              || !(
#line 20095 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8394; /* vec_set_lo_v16sf */

        case E_V16SImode:
          if (pattern1231 (x2, 
E_V16SImode, 
E_V8SImode) != 0
              || !(
#line 20095 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8396; /* vec_set_lo_v16si */

        case E_V16HImode:
          if (pattern1231 (x2, 
E_V16HImode, 
E_V8HImode) != 0
              || !
#line 28529 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9474; /* vec_set_lo_v16hi */

        case E_V16HFmode:
          if (pattern1231 (x2, 
E_V16HFmode, 
E_V8HFmode) != 0
              || !
#line 28529 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9475; /* vec_set_lo_v16hf */

        case E_V16BFmode:
          if (pattern1231 (x2, 
E_V16BFmode, 
E_V8BFmode) != 0
              || !
#line 28529 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9476; /* vec_set_lo_v16bf */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1231 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
              || !(
#line 20127 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8402; /* vec_set_lo_v8df */

        case E_V8DImode:
          if (pattern1231 (x2, 
E_V8DImode, 
E_V4DImode) != 0
              || !(
#line 20127 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8404; /* vec_set_lo_v8di */

        case E_V8SImode:
          if (pattern1231 (x2, 
E_V8SImode, 
E_V4SImode) != 0
              || !
#line 28481 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9466; /* vec_set_lo_v8si */

        case E_V8SFmode:
          if (pattern1231 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
              || !
#line 28481 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9468; /* vec_set_lo_v8sf */

        default:
          return -1;
        }

    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 18]
          || pattern1232 (x4, 
23, 
22, 
21, 
20, 
19) != 0)
        return -1;
      x11 = XVECEXP (x4, 0, 8);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x12 = XVECEXP (x4, 0, 9);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x13 = XVECEXP (x4, 0, 10);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x14 = XVECEXP (x4, 0, 11);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x15 = XVECEXP (x4, 0, 12);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x16 = XVECEXP (x4, 0, 13);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x17 = XVECEXP (x4, 0, 14);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x18 = XVECEXP (x4, 0, 15);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern1231 (x2, 
E_V32QImode, 
E_V16QImode) != 0
          || !
#line 28577 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9480; /* vec_set_lo_v32qi */

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern1140 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 1846 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 2548; /* *sse2_movq128_v2di */

            case E_V2DFmode:
              if (pattern1140 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 1846 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 2549; /* *sse2_movq128_v2df */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!nonimmediate_operand (operands[2], E_DFmode)
              || pattern1141 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 14728 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7211; /* sse2_loadhpd */

        default:
          return -1;
        }

    case 2:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1141 (x2, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !nonimmediate_operand (operands[2], E_V2SFmode)
              || !
#line 11622 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 5274; /* sse_loadhps */

        case E_V4DImode:
          if (pattern1142 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 28456 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9462; /* vec_set_hi_v4di */

        case E_V4DFmode:
          if (pattern1142 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 28456 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9464; /* vec_set_hi_v4df */

        default:
          return -1;
        }

    case 8:
      if (pattern671 (x4) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1142 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !(
#line 20112 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8398; /* vec_set_hi_v16sf */

        case E_V16SImode:
          if (pattern1142 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 20112 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8400; /* vec_set_hi_v16si */

        case E_V16HImode:
          if (pattern1142 (x2, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 28551 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9477; /* vec_set_hi_v16hi */

        case E_V16HFmode:
          if (pattern1142 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
              || !
#line 28551 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9478; /* vec_set_hi_v16hf */

        case E_V16BFmode:
          if (pattern1142 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
              || !
#line 28551 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9479; /* vec_set_hi_v16bf */

        default:
          return -1;
        }

    case 4:
      if (pattern672 (x4, 
3, 
2, 
1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1142 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !(
#line 20142 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8406; /* vec_set_hi_v8df */

        case E_V8DImode:
          if (pattern1142 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 20142 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8408; /* vec_set_hi_v8di */

        case E_V8SImode:
          if (pattern1142 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 28504 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9470; /* vec_set_hi_v8si */

        case E_V8SFmode:
          if (pattern1142 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 28504 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9472; /* vec_set_hi_v8sf */

        default:
          return -1;
        }

    case 16:
      if (pattern791 (x4, 
6, 
5, 
4) != 0
          || pattern1485 (x4, 
11, 
10, 
9, 
8, 
7) != 0
          || pattern1142 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 28603 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9481; /* vec_set_hi_v32qi */

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 5901 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3795; /* *fma_fmadd_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5919 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3819; /* *fma_fmadd_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 5901 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3796; /* *fma_fmadd_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5921 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3830; /* *fma_fmadd_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 5901 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3797; /* *fma_fmadd_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5919 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3815; /* *fma_fmadd_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 5901 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3798; /* *fma_fmadd_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5921 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3826; /* *fma_fmadd_v4df */

        case E_V32HFmode:
          if (pattern864 (x2, 
E_V32HFmode) != 0
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5914 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3799; /* *fma_fmadd_v32hf */

        case E_V16HFmode:
          if (pattern864 (x2, 
E_V16HFmode) != 0
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5915 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3803; /* *fma_fmadd_v16hf */

        case E_V8HFmode:
          if (pattern864 (x2, 
E_V8HFmode) != 0
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5916 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3807; /* *fma_fmadd_v8hf */

        case E_V16SFmode:
          if (pattern864 (x2, 
E_V16SFmode) != 0
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3811; /* *fma_fmadd_v16sf */

        case E_V8DFmode:
          if (pattern864 (x2, 
E_V8DFmode) != 0
              || !(
#line 5929 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5920 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3822; /* *fma_fmadd_v8df */

        case E_V32BFmode:
          if (pattern924 (x2, 
E_V32BFmode) != 0
              || !(
#line 32135 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10626; /* avx10_2_fmaddnepbf16_v32bf */

        case E_V16BFmode:
          if (pattern924 (x2, 
E_V16BFmode) != 0
              || !
#line 32135 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10628; /* avx10_2_fmaddnepbf16_v16bf */

        case E_V8BFmode:
          if (pattern924 (x2, 
E_V8BFmode) != 0
              || !
#line 32135 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10630; /* avx10_2_fmaddnepbf16_v8bf */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x4) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6000 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3864; /* *fma_fmsub_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5919 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3888; /* *fma_fmsub_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x4) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 6000 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3865; /* *fma_fmsub_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5921 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3899; /* *fma_fmsub_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x4) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 6000 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3866; /* *fma_fmsub_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5919 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3884; /* *fma_fmsub_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x4) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 6000 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3867; /* *fma_fmsub_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5921 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3895; /* *fma_fmsub_v4df */

        case E_V32HFmode:
          if (pattern865 (x2, 
E_V32HFmode) != 0
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5914 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3868; /* *fma_fmsub_v32hf */

        case E_V16HFmode:
          if (pattern865 (x2, 
E_V16HFmode) != 0
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5915 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3872; /* *fma_fmsub_v16hf */

        case E_V8HFmode:
          if (pattern865 (x2, 
E_V8HFmode) != 0
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5916 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3876; /* *fma_fmsub_v8hf */

        case E_V16SFmode:
          if (pattern865 (x2, 
E_V16SFmode) != 0
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3880; /* *fma_fmsub_v16sf */

        case E_V8DFmode:
          if (pattern865 (x2, 
E_V8DFmode) != 0
              || !(
#line 6032 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5920 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3891; /* *fma_fmsub_v8df */

        case E_V32BFmode:
          if (pattern925 (x2, 
E_V32BFmode) != 0
              || !(
#line 32263 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10650; /* avx10_2_fmsubnepbf16_v32bf */

        case E_V16BFmode:
          if (pattern925 (x2, 
E_V16BFmode) != 0
              || !
#line 32263 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10652; /* avx10_2_fmsubnepbf16_v16bf */

        case E_V8BFmode:
          if (pattern925 (x2, 
E_V8BFmode) != 0
              || !
#line 32263 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10654; /* avx10_2_fmsubnepbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_279 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  x14 = XVECEXP (x3, 0, 8);
  operands[11] = x14;
  x15 = XVECEXP (x3, 0, 9);
  operands[12] = x15;
  x16 = XVECEXP (x3, 0, 10);
  operands[13] = x16;
  x17 = XVECEXP (x3, 0, 11);
  operands[14] = x17;
  x18 = XVECEXP (x3, 0, 12);
  operands[15] = x18;
  x19 = XVECEXP (x3, 0, 13);
  operands[16] = x19;
  x20 = XVECEXP (x3, 0, 14);
  operands[17] = x20;
  x21 = XVECEXP (x3, 0, 15);
  operands[18] = x21;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (pattern1414 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_16_to_19_operand (operands[5], E_VOIDmode)
          && const_16_to_19_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_20_to_23_operand (operands[9], E_VOIDmode)
          && const_20_to_23_operand (operands[10], E_VOIDmode)
          && const_8_to_11_operand (operands[11], E_VOIDmode)
          && const_8_to_11_operand (operands[12], E_VOIDmode)
          && const_24_to_27_operand (operands[13], E_VOIDmode)
          && const_24_to_27_operand (operands[14], E_VOIDmode)
          && const_12_to_15_operand (operands[15], E_VOIDmode)
          && const_12_to_15_operand (operands[16], E_VOIDmode)
          && const_28_to_31_operand (operands[17], E_VOIDmode)
          && const_28_to_31_operand (operands[18], E_VOIDmode)
          && 
#line 14284 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12))))
        return 7186; /* avx512f_shufps512_1 */
      if (!const_0_to_15_operand (operands[3], E_VOIDmode)
          || pattern1850 () != 0
          || !(
#line 20413 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8426; /* avx512f_shuf_f32x4_1 */

    case E_V16SImode:
      if (pattern1414 (x2, 
E_V16SImode, 
E_V32SImode) != 0
          || !const_0_to_15_operand (operands[3], E_VOIDmode)
          || pattern1850 () != 0
          || !(
#line 20413 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8428; /* avx512f_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  if (const_0_to_7_operand (operands[2], E_VOIDmode))
    {
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      if (const_0_to_7_operand (operands[3], E_VOIDmode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (nonimmediate_operand (operands[0], E_V2DFmode)
                  && GET_MODE (x2) == E_V2DFmode
                  && register_operand (operands[1], E_V8DFmode)
                  && (
#line 12454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && INTVAL (operands[2]) % 2 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 5336; /* *avx512dq_vextractf64x2_1 */
              break;

            case E_V2DImode:
              if (nonimmediate_operand (operands[0], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && register_operand (operands[1], E_V8DImode)
                  && (
#line 12454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && INTVAL (operands[2]) % 2 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 5337; /* *avx512dq_vextracti64x2_1 */
              break;

            default:
              break;
            }
        }
    }
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (XWINT (x5, 0) != 1L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!nonimmediate_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_V4DImode)
              || !
#line 12880 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5360; /* vec_extract_lo_v4di */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 12880 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5361; /* vec_extract_lo_v4df */

        default:
          return -1;
        }

    case 2L:
      if (XWINT (x5, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!nonimmediate_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V4DImode)
              || !
#line 12916 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5364; /* vec_extract_hi_v4di */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 12916 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5365; /* vec_extract_hi_v4df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_288 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x4;
  res = recog_290 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 0L
      || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || !register_operand (operands[0], E_V8HImode)
      || GET_MODE (x2) != E_V8HImode
      || !vector_operand (operands[1], E_V8HImode)
      || pattern1491 (x3) != 0
      || !
#line 21003 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
    return -1;
  return 8450; /* sse2_pshufhw_1 */
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[3] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[5] = x6;
  x7 = XVECEXP (x3, 0, 5);
  operands[7] = x7;
  x8 = XVECEXP (x3, 0, 6);
  operands[8] = x8;
  x9 = XVECEXP (x3, 0, 7);
  operands[9] = x9;
  x10 = XVECEXP (x3, 0, 8);
  operands[10] = x10;
  x11 = XVECEXP (x3, 0, 9);
  operands[11] = x11;
  x12 = XVECEXP (x3, 0, 10);
  operands[12] = x12;
  x13 = XVECEXP (x3, 0, 11);
  operands[13] = x13;
  x14 = XVECEXP (x3, 0, 12);
  operands[14] = x14;
  x15 = XVECEXP (x3, 0, 13);
  operands[15] = x15;
  x16 = XVECEXP (x3, 0, 14);
  operands[16] = x16;
  x17 = XVECEXP (x3, 0, 15);
  operands[17] = x17;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || pattern1827 () != 0
          || !(
#line 20465 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8430; /* *avx512f_shuf_f32x4_1_1 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      if (register_operand (operands[1], E_V16SImode)
          && pattern1827 () == 0
          && (
#line 20465 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 8432; /* *avx512f_shuf_i32x4_1_1 */
      if (!nonimmediate_operand (operands[1], E_V16SImode)
          || pattern1706 () != 0
          || !const_8_to_11_operand (operands[10], E_VOIDmode)
          || !const_8_to_11_operand (operands[11], E_VOIDmode)
          || !const_8_to_11_operand (operands[12], E_VOIDmode)
          || !const_8_to_11_operand (operands[13], E_VOIDmode)
          || !const_12_to_15_operand (operands[14], E_VOIDmode)
          || !const_12_to_15_operand (operands[15], E_VOIDmode)
          || !const_12_to_15_operand (operands[16], E_VOIDmode)
          || !const_12_to_15_operand (operands[17], E_VOIDmode)
          || !
#line 20547 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
   && INTVAL (operands[2]) + 8 == INTVAL (operands[10])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[11])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[12])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[13])
   && INTVAL (operands[2]) + 12 == INTVAL (operands[14])
   && INTVAL (operands[3]) + 12 == INTVAL (operands[15])
   && INTVAL (operands[4]) + 12 == INTVAL (operands[16])
   && INTVAL (operands[5]) + 12 == INTVAL (operands[17])))
        return -1;
      return 8434; /* avx512f_pshufd_1 */

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      switch (pattern335 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_V16BFmode:
              if (pattern613 (x2, 
E_V16BFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 427 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3688; /* avx512bf16_andnotv16bf3 */

            case E_V8BFmode:
              if (pattern613 (x2, 
E_V8BFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 427 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3689; /* avx512bf16_andnotv8bf3 */

            case E_V16HFmode:
              if (pattern613 (x2, 
E_V16HFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 428 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3690; /* avx512fp16_andnotv16hf3 */

            case E_V8HFmode:
              if (pattern613 (x2, 
E_V8HFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 428 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3691; /* avx512fp16_andnotv8hf3 */

            case E_V8SFmode:
              if (pattern613 (x2, 
E_V8SFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)) && 
#line 429 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3692; /* avx_andnotv8sf3 */

            case E_V4SFmode:
              if (pattern613 (x2, 
E_V4SFmode) != 0
                  || !
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)))
                return -1;
              return 3694; /* sse_andnotv4sf3 */

            case E_V4DFmode:
              if (pattern613 (x2, 
E_V4DFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)) && 
#line 430 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3696; /* avx_andnotv4df3 */

            case E_V2DFmode:
              if (pattern613 (x2, 
E_V2DFmode) != 0
                  || !(
#line 5222 "../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)) && 
#line 430 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3698; /* sse2_andnotv2df3 */

            case E_V32BFmode:
              if (pattern739 (x2, 
E_V32BFmode) != 0
                  || !(
#line 5297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 16 != 16)) && 
#line 492 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3700; /* avx512bf16_andnotv32bf3 */

            case E_V32HFmode:
              if (pattern739 (x2, 
E_V32HFmode) != 0
                  || !(
#line 5297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 16 != 16)) && 
#line 493 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3701; /* avx512fp16_andnotv32hf3 */

            case E_V16SFmode:
              if (pattern739 (x2, 
E_V16SFmode) != 0
                  || !(
#line 5297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 32 != 16)) && 
#line 494 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3702; /* avx512f_andnotv16sf3 */

            case E_V8DFmode:
              if (pattern739 (x2, 
E_V8DFmode) != 0
                  || !(
#line 5297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 64 != 16)) && 
#line 495 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3704; /* avx512f_andnotv8df3 */

            case E_V1TImode:
              if (pattern613 (x2, 
E_V1TImode) != 0
                  || !
#line 5588 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 3777; /* *andnotv1ti3 */

            case E_V16SImode:
              if (pattern933 (x2, 
E_V16SImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7983; /* *andnotv16si3 */

            case E_V8DImode:
              if (pattern933 (x2, 
E_V8DImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 570 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7984; /* *andnotv8di3 */

            case E_V64QImode:
              if (pattern933 (x2, 
E_V64QImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7985; /* *andnotv64qi3 */

            case E_V32QImode:
              if (pattern933 (x2, 
E_V32QImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7986; /* *andnotv32qi3 */

            case E_V16QImode:
              if (pattern933 (x2, 
E_V16QImode) != 0
                  || !
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
                return -1;
              return 7987; /* *andnotv16qi3 */

            case E_V32HImode:
              if (pattern933 (x2, 
E_V32HImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 572 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7988; /* *andnotv32hi3 */

            case E_V16HImode:
              if (pattern933 (x2, 
E_V16HImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 572 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7989; /* *andnotv16hi3 */

            case E_V8HImode:
              if (pattern933 (x2, 
E_V8HImode) != 0
                  || !
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
                return -1;
              return 7990; /* *andnotv8hi3 */

            case E_V8SImode:
              if (pattern933 (x2, 
E_V8SImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 573 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7991; /* *andnotv8si3 */

            case E_V4SImode:
              if (pattern933 (x2, 
E_V4SImode) != 0
                  || !
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
                return -1;
              return 7992; /* *andnotv4si3 */

            case E_V4DImode:
              if (pattern933 (x2, 
E_V4DImode) != 0
                  || !(
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 574 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7993; /* *andnotv4di3 */

            case E_V2DImode:
              if (pattern933 (x2, 
E_V2DImode) != 0
                  || !
#line 18487 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
                return -1;
              return 7994; /* *andnotv2di3 */

            default:
              return -1;
            }

        case 1:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8082; /* *norv16si3 */

        case 2:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 570 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8084; /* *norv8di3 */

        case 3:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8086; /* *norv64qi3 */

        case 4:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8088; /* *norv32qi3 */

        case 5:
          if (!
#line 19021 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
            return -1;
          return 8090; /* *norv16qi3 */

        case 6:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 572 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8092; /* *norv32hi3 */

        case 7:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 572 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8094; /* *norv16hi3 */

        case 8:
          if (!
#line 19021 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
            return -1;
          return 8096; /* *norv8hi3 */

        case 9:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 573 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8098; /* *norv8si3 */

        case 10:
          if (!
#line 19021 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
            return -1;
          return 8100; /* *norv4si3 */

        case 11:
          if (!(
#line 19021 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 574 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8102; /* *norv4di3 */

        case 12:
          if (!
#line 19021 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
            return -1;
          return 8104; /* *norv2di3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      return recog_300 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern533 (x2))
            {
            case 0:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5516; /* *avx512bw_vpternlogv64qi_1 */

            case 1:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5543; /* *avx512vl_vpternlogv32qi_1 */

            case 2:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5570; /* *avx512vl_vpternlogv16qi_1 */

            case 3:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5597; /* *avx512bw_vpternlogv32hi_1 */

            case 4:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5624; /* *avx512vl_vpternlogv16hi_1 */

            case 5:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5651; /* *avx512vl_vpternlogv8hi_1 */

            case 6:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5678; /* *avx512f_vpternlogv16si_1 */

            case 7:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5705; /* *avx512vl_vpternlogv8si_1 */

            case 8:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5732; /* *avx512vl_vpternlogv4si_1 */

            case 9:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5759; /* *avx512f_vpternlogv8di_1 */

            case 10:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5786; /* *avx512vl_vpternlogv4di_1 */

            case 11:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5813; /* *avx512vl_vpternlogv2di_1 */

            case 12:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5519; /* *avx512bw_vpternlogv64qi_1 */

            case 13:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5546; /* *avx512vl_vpternlogv32qi_1 */

            case 14:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5573; /* *avx512vl_vpternlogv16qi_1 */

            case 15:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5600; /* *avx512bw_vpternlogv32hi_1 */

            case 16:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5627; /* *avx512vl_vpternlogv16hi_1 */

            case 17:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5654; /* *avx512vl_vpternlogv8hi_1 */

            case 18:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5681; /* *avx512f_vpternlogv16si_1 */

            case 19:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5708; /* *avx512vl_vpternlogv8si_1 */

            case 20:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5735; /* *avx512vl_vpternlogv4si_1 */

            case 21:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5762; /* *avx512f_vpternlogv8di_1 */

            case 22:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5789; /* *avx512vl_vpternlogv4di_1 */

            case 23:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5816; /* *avx512vl_vpternlogv2di_1 */

            case 24:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5522; /* *avx512bw_vpternlogv64qi_1 */

            case 25:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5549; /* *avx512vl_vpternlogv32qi_1 */

            case 26:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5576; /* *avx512vl_vpternlogv16qi_1 */

            case 27:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5603; /* *avx512bw_vpternlogv32hi_1 */

            case 28:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5630; /* *avx512vl_vpternlogv16hi_1 */

            case 29:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5657; /* *avx512vl_vpternlogv8hi_1 */

            case 30:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5684; /* *avx512f_vpternlogv16si_1 */

            case 31:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5711; /* *avx512vl_vpternlogv8si_1 */

            case 32:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5738; /* *avx512vl_vpternlogv4si_1 */

            case 33:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5765; /* *avx512f_vpternlogv8di_1 */

            case 34:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5792; /* *avx512vl_vpternlogv4di_1 */

            case 35:
              if (!
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5819; /* *avx512vl_vpternlogv2di_1 */

            case 36:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6812; /* *avx512bw_vpternlogv64qi_3 */

            case 37:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6821; /* *avx512vl_vpternlogv32qi_3 */

            case 38:
              if (!
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6830; /* *avx512vl_vpternlogv16qi_3 */

            case 39:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6839; /* *avx512bw_vpternlogv32hi_3 */

            case 40:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6848; /* *avx512vl_vpternlogv16hi_3 */

            case 41:
              if (!
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6857; /* *avx512vl_vpternlogv8hi_3 */

            case 42:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6866; /* *avx512f_vpternlogv16si_3 */

            case 43:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6875; /* *avx512vl_vpternlogv8si_3 */

            case 44:
              if (!
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6884; /* *avx512vl_vpternlogv4si_3 */

            case 45:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6893; /* *avx512f_vpternlogv8di_3 */

            case 46:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6902; /* *avx512vl_vpternlogv4di_3 */

            case 47:
              if (!
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6911; /* *avx512vl_vpternlogv2di_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern535 (x2))
            {
            case 0:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6164; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6191; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6218; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6245; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6272; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6299; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6326; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6353; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6380; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6407; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6434; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6461; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern535 (x2))
            {
            case 0:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6167; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6194; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6221; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6248; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6275; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6302; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6329; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6356; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6383; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6410; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6437; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6464; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern535 (x2))
            {
            case 0:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6170; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6197; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6224; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6251; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6278; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6305; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6332; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6359; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6386; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6413; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6440; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6467; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_302 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_301 (x1, insn, pnum_clobbers);

    case GT:
      switch (pattern337 (x2))
        {
        case 0:
          if (!(
#line 17325 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7676; /* *avx2_lshrv4di3_1 */

        case 1:
          if (!
#line 17325 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()))
            return -1;
          return 7677; /* *avx2_lshrv2di3_1 */

        default:
          return -1;
        }

    case LT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DImode:
          if (pattern934 (x2, 
E_V4DImode) != 0
              || !(
#line 17342 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7678; /* *avx2_lshrv4di3_2 */

        case E_V2DImode:
          if (pattern934 (x2, 
E_V2DImode) != 0
              || !
#line 17342 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 7679; /* *avx2_lshrv2di3_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (pattern180 (x3))
        {
        case 0:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && 1 && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2677; /* *addv32hf3 */

        case 1:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && 1 && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2685; /* *addv16hf3 */

        case 2:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2693; /* *addv8hf3 */

        case 3:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2701; /* *addv16sf3 */

        case 4:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2709; /* *addv8sf3 */

        case 5:
          if (!
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2717; /* *addv4sf3 */

        case 6:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && 1 && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2725; /* *addv8df3 */

        case 7:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && 1 && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2733; /* *addv4df3 */

        case 8:
          if (!(
#line 2661 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && 1 && 1) && 
#line 395 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2741; /* *addv2df3 */

        case 9:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 588 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7459; /* *addv64qi3 */

        case 10:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 588 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7461; /* *addv32qi3 */

        case 11:
          if (!
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16QImode, operands)))
            return -1;
          return 7463; /* *addv16qi3 */

        case 12:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V32HImode, operands)) && 
#line 589 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7465; /* *addv32hi3 */

        case 13:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16HImode, operands)) && 
#line 589 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7467; /* *addv16hi3 */

        case 14:
          if (!
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8HImode, operands)))
            return -1;
          return 7469; /* *addv8hi3 */

        case 15:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16SImode, operands)) && 
#line 590 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7471; /* *addv16si3 */

        case 16:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8SImode, operands)) && 
#line 590 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7473; /* *addv8si3 */

        case 17:
          if (!
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V4SImode, operands)))
            return -1;
          return 7475; /* *addv4si3 */

        case 18:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8DImode, operands)) && 
#line 591 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7477; /* *addv8di3 */

        case 19:
          if (!(
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V4DImode, operands)) && 
#line 591 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7479; /* *addv4di3 */

        case 20:
          if (!
#line 16267 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V2DImode, operands)))
            return -1;
          return 7481; /* *addv2di3 */

        case 21:
          if (!(
#line 32110 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10602; /* avx10_2_addnepbf16_v32bf */

        case 22:
          if (!
#line 32110 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10610; /* avx10_2_addnepbf16_v16bf */

        case 23:
          if (!
#line 32110 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10618; /* avx10_2_addnepbf16_v8bf */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern183 (x3))
        {
        case 0:
          if (!(
#line 7161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4341; /* fma_v32hf_fadd_fmul */

        case 1:
          if (!(
#line 7161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4342; /* fma_v16hf_fadd_fmul */

        case 2:
          if (!(
#line 7161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4343; /* fma_v8hf_fadd_fmul */

        case 3:
          if (!(
#line 7178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4344; /* fma_v32hf_fadd_fcmul */

        case 4:
          if (!(
#line 7178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4345; /* fma_v16hf_fadd_fcmul */

        case 5:
          if (!(
#line 7178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4346; /* fma_v8hf_fadd_fcmul */

        case 6:
          if (!(
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4347; /* fma_fmaddc_v32hf_fma_zero */

        case 7:
          if (!(
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4349; /* fma_fmaddc_v16hf_fma_zero */

        case 8:
          if (!(
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4351; /* fma_fmaddc_v8hf_fma_zero */

        case 9:
          if (!(
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4348; /* fma_fcmaddc_v32hf_fma_zero */

        case 10:
          if (!(
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4350; /* fma_fcmaddc_v16hf_fma_zero */

        case 11:
          if (!(
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4352; /* fma_fcmaddc_v8hf_fma_zero */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern327 (x4) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 8:
              if (pattern1314 (x4) != 0)
                return -1;
              x8 = XEXP (x3, 1);
              if (GET_CODE (x8) != MULT
                  || GET_MODE (x8) != E_V8SImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_V8SImode)
                return -1;
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != VEC_SELECT
                  || GET_MODE (x10) != E_V8HImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != PARALLEL
                  || pattern1860 (x11, 
8) != 0)
                return -1;
              x12 = XEXP (x8, 1);
              if (pattern1840 (x12, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              x14 = XEXP (x13, 1);
              if (pattern1877 (x14, 
8) != 0
                  || !register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || GET_MODE (x4) != E_V8SImode
                  || GET_MODE (x5) != E_V8SImode
                  || GET_MODE (x6) != E_V8HImode
                  || !nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              x15 = XEXP (x4, 1);
              if (GET_MODE (x15) != E_V8SImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_V8HImode
                  || !nonimmediate_operand (operands[2], E_V16HImode))
                return -1;
              x17 = XEXP (x10, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return -1;
              x18 = XEXP (x13, 0);
              if (!rtx_equal_p (x18, operands[2])
                  || !
#line 16742 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 7591; /* *avx2_pmaddwd */

            case 4:
              x19 = XVECEXP (x7, 0, 0);
              if (GET_CODE (x19) != CONST_INT)
                return -1;
              x20 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x20) != CONST_INT)
                return -1;
              x21 = XVECEXP (x7, 0, 2);
              if (GET_CODE (x21) != CONST_INT)
                return -1;
              x22 = XVECEXP (x7, 0, 3);
              if (GET_CODE (x22) != CONST_INT)
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x23 = XEXP (x16, 1);
              if (XVECLEN (x23, 0) != 4)
                return -1;
              x24 = XVECEXP (x23, 0, 0);
              if (GET_CODE (x24) != CONST_INT)
                return -1;
              x25 = XVECEXP (x23, 0, 1);
              if (GET_CODE (x25) != CONST_INT)
                return -1;
              x26 = XVECEXP (x23, 0, 2);
              if (GET_CODE (x26) != CONST_INT)
                return -1;
              x27 = XVECEXP (x23, 0, 3);
              if (GET_CODE (x27) != CONST_INT
                  || pattern883 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                  || GET_MODE (x15) != E_V4SImode
                  || GET_MODE (x16) != E_V4HImode)
                return -1;
              switch (XWINT (x19, 0))
                {
                case 0L:
                  if (XWINT (x20, 0) != 2L
                      || XWINT (x21, 0) != 4L
                      || XWINT (x22, 0) != 6L
                      || XWINT (x24, 0) != 0L
                      || XWINT (x25, 0) != 2L
                      || XWINT (x26, 0) != 4L
                      || XWINT (x27, 0) != 6L)
                    return -1;
                  x8 = XEXP (x3, 1);
                  if (pattern1780 (x8, 
E_V4HImode, 
E_V4SImode, 
SIGN_EXTEND) != 0
                      || !vector_operand (operands[1], E_V8HImode)
                      || !vector_operand (operands[2], E_V8HImode))
                    return -1;
                  x9 = XEXP (x8, 0);
                  x10 = XEXP (x9, 0);
                  x17 = XEXP (x10, 0);
                  if (!rtx_equal_p (x17, operands[1]))
                    return -1;
                  x12 = XEXP (x8, 1);
                  x13 = XEXP (x12, 0);
                  x18 = XEXP (x13, 0);
                  if (!rtx_equal_p (x18, operands[2])
                      || !
#line 16797 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 7592; /* *sse2_pmaddwd */

                case 1L:
                  if (XWINT (x20, 0) != 3L
                      || XWINT (x21, 0) != 5L
                      || XWINT (x22, 0) != 7L
                      || XWINT (x24, 0) != 1L
                      || XWINT (x25, 0) != 3L
                      || XWINT (x26, 0) != 5L
                      || XWINT (x27, 0) != 7L
                      || !nonimmediate_operand (operands[1], E_V8HImode)
                      || !nonimmediate_operand (operands[2], E_V8HImode))
                    return -1;
                  x8 = XEXP (x3, 1);
                  operands[3] = x8;
                  if (!register_operand (operands[3], E_V4SImode)
                      || !
#line 26165 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8990; /* xop_pmacswd */

                default:
                  return -1;
                }

            case 2:
              if (pattern1315 (x3) != 0)
                return -1;
              x15 = XEXP (x4, 1);
              if (GET_MODE (x15) != E_V2DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              x8 = XEXP (x3, 1);
              operands[3] = x8;
              switch (pattern1824 (x4))
                {
                case 0:
                  if (!
#line 26124 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8986; /* xop_pmacsdql */

                case 1:
                  if (!
#line 26143 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8988; /* xop_pmacsdqh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern329 (x3))
            {
            case 0:
              if (!
#line 26105 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8982; /* xop_pmacsww */

            case 1:
              if (!
#line 26105 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8984; /* xop_pmacsdd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern187 (x3))
        {
        case 0:
          if (!
#line 22567 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8584; /* avx2_phaddwv16hi3 */

        case 1:
          if (!
#line 22590 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8588; /* ssse3_phaddwv8hi3 */

        case 2:
          if (!
#line 22657 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8596; /* avx2_phadddv8si3 */

        case 3:
          if (!
#line 22678 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8598; /* ssse3_phadddv4si3 */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case MULT:
          if (pattern330 (x5) != 0)
            return -1;
          x28 = XEXP (x5, 1);
          if (GET_MODE (x28) != E_V4SImode)
            return -1;
          x29 = XEXP (x28, 0);
          if (GET_CODE (x29) != VEC_SELECT
              || GET_MODE (x29) != E_V4HImode)
            return -1;
          x30 = XEXP (x29, 1);
          if (GET_CODE (x30) != PARALLEL
              || XVECLEN (x30, 0) != 4)
            return -1;
          x31 = XVECEXP (x30, 0, 0);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x32 = XVECEXP (x30, 0, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x33 = XVECEXP (x30, 0, 2);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x34 = XVECEXP (x30, 0, 3);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != MULT
              || GET_MODE (x15) != E_V4SImode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SIGN_EXTEND
              || GET_MODE (x16) != E_V4SImode)
            return -1;
          x35 = XEXP (x16, 0);
          if (GET_CODE (x35) != VEC_SELECT
              || GET_MODE (x35) != E_V4HImode)
            return -1;
          x36 = XEXP (x35, 1);
          if (GET_CODE (x36) != PARALLEL
              || XVECLEN (x36, 0) != 4)
            return -1;
          x37 = XVECEXP (x36, 0, 0);
          if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x38 = XVECEXP (x36, 0, 1);
          if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x39 = XVECEXP (x36, 0, 2);
          if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x40 = XVECEXP (x36, 0, 3);
          if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
            return -1;
          x41 = XEXP (x15, 1);
          if (GET_CODE (x41) != SIGN_EXTEND
              || GET_MODE (x41) != E_V4SImode)
            return -1;
          x42 = XEXP (x41, 0);
          if (GET_CODE (x42) != VEC_SELECT
              || GET_MODE (x42) != E_V4HImode)
            return -1;
          x43 = XEXP (x42, 1);
          if (GET_CODE (x43) != PARALLEL
              || XVECLEN (x43, 0) != 4)
            return -1;
          x44 = XVECEXP (x43, 0, 0);
          if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x45 = XVECEXP (x43, 0, 1);
          if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x46 = XVECEXP (x43, 0, 2);
          if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x47 = XVECEXP (x43, 0, 3);
          if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode
              || pattern1880 (x3) != 0
              || !
#line 26198 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8992; /* xop_pmadcswd */

        case SIGN_EXTEND:
          switch (pattern333 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 26292 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9012; /* xop_phaddbd */

            case 1:
              if (!
#line 26388 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9018; /* xop_phaddwq */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern333 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 26292 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9013; /* xop_phaddubd */

            case 1:
              if (!
#line 26388 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9019; /* xop_phadduwq */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x5) != E_V2DImode)
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != PLUS
              || GET_MODE (x15) != E_V2DImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_V2DImode
              || pattern1031 (x8, 
E_V2DImode, 
PLUS) != 0
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || pattern1554 (x3, 
E_V2DImode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (pattern1813 (x3, 
SIGN_EXTEND) != 0
                  || !
#line 26340 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9014; /* xop_phaddbq */

            case ZERO_EXTEND:
              if (pattern1813 (x3, 
ZERO_EXTEND) != 0
                  || !
#line 26340 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 9015; /* xop_phaddubq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern189 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 26260 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9010; /* xop_phaddbw */

        case 1:
          if (!
#line 26360 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9016; /* xop_phaddwd */

        case 2:
          if (!
#line 26406 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9020; /* xop_phadddq */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern189 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 26260 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9011; /* xop_phaddubw */

        case 1:
          if (!
#line 26360 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9017; /* xop_phadduwd */

        case 2:
          if (!
#line 26406 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9021; /* xop_phaddudq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (nonimmediate_operand (operands[0], E_V64QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V64QImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 283 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2389; /* movv64qi_internal */
      if (!register_operand (operands[0], E_V64QImode)
          || !ternlog_operand (operands[1], E_V64QImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5492; /* *avx512bw_vpternlogv64qi_0 */

    case E_V32QImode:
      if (nonimmediate_operand (operands[0], E_V32QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V32QImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 283 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2390; /* movv32qi_internal */
      if (!register_operand (operands[0], E_V32QImode)
          || !ternlog_operand (operands[1], E_V32QImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5493; /* *avx512vl_vpternlogv32qi_0 */

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16QImode)
          && 
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2391; /* movv16qi_internal */
      if (!register_operand (operands[0], E_V16QImode)
          || !ternlog_operand (operands[1], E_V16QImode)
          || !
#line 13747 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5494; /* *avx512vl_vpternlogv16qi_0 */

    case E_V32HImode:
      if (nonimmediate_operand (operands[0], E_V32HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V32HImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 284 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2392; /* movv32hi_internal */
      if (!register_operand (operands[0], E_V32HImode)
          || !ternlog_operand (operands[1], E_V32HImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5495; /* *avx512bw_vpternlogv32hi_0 */

    case E_V16HImode:
      if (nonimmediate_operand (operands[0], E_V16HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16HImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16HImode)
       || register_operand (operands[1], V16HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 284 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2393; /* movv16hi_internal */
      if (!register_operand (operands[0], E_V16HImode)
          || !ternlog_operand (operands[1], E_V16HImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5496; /* *avx512vl_vpternlogv16hi_0 */

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8HImode)
          && 
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2394; /* movv8hi_internal */
      if (!register_operand (operands[0], E_V8HImode)
          || !ternlog_operand (operands[1], E_V8HImode)
          || !
#line 13747 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5497; /* *avx512vl_vpternlogv8hi_0 */

    case E_V16SImode:
      if (nonimmediate_operand (operands[0], E_V16SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16SImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 285 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2395; /* movv16si_internal */
      if (!register_operand (operands[0], E_V16SImode)
          || !ternlog_operand (operands[1], E_V16SImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5498; /* *avx512f_vpternlogv16si_0 */

    case E_V8SImode:
      if (nonimmediate_operand (operands[0], E_V8SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8SImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 285 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2396; /* movv8si_internal */
      if (!register_operand (operands[0], E_V8SImode)
          || !ternlog_operand (operands[1], E_V8SImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5499; /* *avx512vl_vpternlogv8si_0 */

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V4SImode)
          && 
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2397; /* movv4si_internal */
      if (!register_operand (operands[0], E_V4SImode)
          || !ternlog_operand (operands[1], E_V4SImode)
          || !
#line 13747 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5500; /* *avx512vl_vpternlogv4si_0 */

    case E_V8DImode:
      if (nonimmediate_operand (operands[0], E_V8DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8DImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 286 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2398; /* movv8di_internal */
      if (!register_operand (operands[0], E_V8DImode)
          || !ternlog_operand (operands[1], E_V8DImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5501; /* *avx512f_vpternlogv8di_0 */

    case E_V4DImode:
      if (nonimmediate_operand (operands[0], E_V4DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V4DImode)
          && (
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 286 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2399; /* movv4di_internal */
      if (!register_operand (operands[0], E_V4DImode)
          || !ternlog_operand (operands[1], E_V4DImode)
          || !(
#line 13747 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5502; /* *avx512vl_vpternlogv4di_0 */

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V2DImode)
          && 
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2400; /* movv2di_internal */
      if (!register_operand (operands[0], E_V2DImode)
          || !ternlog_operand (operands[1], E_V2DImode)
          || !
#line 13747 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5503; /* *avx512vl_vpternlogv2di_0 */

    case E_V4TImode:
      if (!nonimmediate_operand (operands[0], E_V4TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4TImode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4TImode)
       || register_operand (operands[1], V4TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 287 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2401; /* movv4ti_internal */

    case E_V2TImode:
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V2TImode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2TImode)
       || register_operand (operands[1], V2TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 287 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2402; /* movv2ti_internal */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V1TImode)
          || !
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V1TImode)
       || register_operand (operands[1], V1TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2403; /* movv1ti_internal */

    case E_V32HFmode:
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V32HFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 288 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2404; /* movv32hf_internal */

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16HFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 288 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2405; /* movv16hf_internal */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8HFmode)
          || !
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2406; /* movv8hf_internal */

    case E_V32BFmode:
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V32BFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32BFmode)
       || register_operand (operands[1], V32BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 289 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2407; /* movv32bf_internal */

    case E_V16BFmode:
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16BFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16BFmode)
       || register_operand (operands[1], V16BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 289 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2408; /* movv16bf_internal */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8BFmode)
          || !
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[1], V8BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2409; /* movv8bf_internal */

    case E_V16SFmode:
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16SFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 290 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2410; /* movv16sf_internal */

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8SFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 290 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2411; /* movv8sf_internal */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4SFmode)
          || !
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2412; /* movv4sf_internal */

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8DFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 291 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2413; /* movv8df_internal */

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4DFmode)
          || !(
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 291 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2414; /* movv4df_internal */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V2DFmode)
          || !
#line 1508 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2415; /* movv2df_internal */

    default:
      return -1;
    }
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern812 (x3, 
E_V32QImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8994; /* xop_pcmov_v32qi256 */

        case E_V16QImode:
          if (pattern812 (x3, 
E_V16QImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8995; /* xop_pcmov_v16qi */

        case E_V16HImode:
          if (pattern812 (x3, 
E_V16HImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8996; /* xop_pcmov_v16hi256 */

        case E_V8HImode:
          if (pattern812 (x3, 
E_V8HImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8997; /* xop_pcmov_v8hi */

        case E_V8SImode:
          if (pattern812 (x3, 
E_V8SImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8998; /* xop_pcmov_v8si256 */

        case E_V4SImode:
          if (pattern812 (x3, 
E_V4SImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8999; /* xop_pcmov_v4si */

        case E_V4DImode:
          if (pattern812 (x3, 
E_V4DImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9000; /* xop_pcmov_v4di256 */

        case E_V2DImode:
          if (pattern812 (x3, 
E_V2DImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9001; /* xop_pcmov_v2di */

        case E_V2TImode:
          if (pattern812 (x3, 
E_V2TImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9002; /* xop_pcmov_v2ti256 */

        case E_V1TImode:
          if (pattern812 (x3, 
E_V1TImode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9003; /* xop_pcmov_v1ti */

        case E_V16HFmode:
          if (pattern812 (x3, 
E_V16HFmode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9004; /* xop_pcmov_v16hf256 */

        case E_V8HFmode:
          if (pattern812 (x3, 
E_V8HFmode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9005; /* xop_pcmov_v8hf */

        case E_V8SFmode:
          if (pattern812 (x3, 
E_V8SFmode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9006; /* xop_pcmov_v8sf256 */

        case E_V4SFmode:
          if (pattern812 (x3, 
E_V4SFmode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9007; /* xop_pcmov_v4sf */

        case E_V4DFmode:
          if (pattern812 (x3, 
E_V4DFmode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9008; /* xop_pcmov_v4df256 */

        case E_V2DFmode:
          if (pattern812 (x3, 
E_V2DFmode) != 0
              || !
#line 26211 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9009; /* xop_pcmov_v2df */

        default:
          return -1;
        }

    case GE:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != ROTATERT)
            return -1;
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (pattern1146 (x3))
            {
            case 0:
              if (!
#line 26657 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 9037; /* xop_vrotlv16qi3 */

            case 1:
              if (!
#line 26657 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 9038; /* xop_vrotlv8hi3 */

            case 2:
              if (!
#line 26657 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 9039; /* xop_vrotlv4si3 */

            case 3:
              if (!
#line 26657 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 9040; /* xop_vrotlv2di3 */

            default:
              return -1;
            }

        case ASHIFT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x6 = XEXP (x3, 2);
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x9 = XEXP (x6, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              switch (pattern1146 (x3))
                {
                case 0:
                  if (!
#line 26894 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9041; /* xop_shav16qi3 */

                case 1:
                  if (!
#line 26894 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9042; /* xop_shav8hi3 */

                case 2:
                  if (!
#line 26894 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9043; /* xop_shav4si3 */

                case 3:
                  if (!
#line 26894 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9044; /* xop_shav2di3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x9 = XEXP (x6, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              switch (pattern1146 (x3))
                {
                case 0:
                  if (!
#line 26913 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9045; /* xop_shlv16qi3 */

                case 1:
                  if (!
#line 26913 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9046; /* xop_shlv8hi3 */

                case 2:
                  if (!
#line 26913 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9047; /* xop_shlv4si3 */

                case 3:
                  if (!
#line 26913 "../../gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 9048; /* xop_shlv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !vector_operand (operands[1], E_V64QImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23341 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8644; /* *absv64qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23341 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8645; /* *absv32qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8646; /* *absv16qi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !vector_operand (operands[1], E_V32HImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23342 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8647; /* *absv32hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !vector_operand (operands[1], E_V16HImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23342 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8648; /* *absv16hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vector_operand (operands[1], E_V8HImode)
          || !
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8649; /* *absv8hi2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !vector_operand (operands[1], E_V16SImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23343 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8650; /* *absv16si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !vector_operand (operands[1], E_V8SImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23343 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8651; /* *absv8si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vector_operand (operands[1], E_V4SImode)
          || !
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8652; /* *absv4si2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !vector_operand (operands[1], E_V8DImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8653; /* *absv8di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !vector_operand (operands[1], E_V4DImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8654; /* *absv4di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vector_operand (operands[1], E_V2DImode)
          || !(
#line 23351 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23345 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8655; /* *absv2di2 */

    default:
      return -1;
    }
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern49 (x3))
        {
        case 0:
          if (!
#line 14988 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7221; /* *avx512f_truncatev16siv16qi2 */

        case 1:
          if (!(
#line 15250 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15224 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7263; /* *avx512vl_truncatev16hiv16qi2 */

        case 2:
          if (!
#line 14988 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7224; /* *avx512f_truncatev16siv16hi2 */

        case 3:
          if (!
#line 14988 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7227; /* *avx512f_truncatev8div8si2 */

        case 4:
          if (!
#line 14988 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7230; /* *avx512f_truncatev8div8hi2 */

        case 5:
          if (!
#line 15250 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7260; /* *avx512vl_truncatev8siv8hi2 */

        case 6:
          if (!
#line 15161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7250; /* avx512bw_truncatev32hiv32qi2 */

        case 7:
          if (!
#line 15250 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7257; /* *avx512vl_truncatev4div4si2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (XWINT (x5, 0) != 16L)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern811 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 16420 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 653 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7561; /* *smulv32hi3_highpart */

                case 1:
                  if (!(
#line 16420 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7565; /* *smulv16hi3_highpart */

                case 2:
                  if (!
#line 16420 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
                    return -1;
                  return 7569; /* *smulv8hi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern811 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 16420 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 653 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7563; /* *umulv32hi3_highpart */

                case 1:
                  if (!(
#line 16420 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7567; /* *umulv16hi3_highpart */

                case 2:
                  if (!
#line 16420 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
                    return -1;
                  return 7571; /* *umulv8hi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              x12 = XEXP (x6, 1);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_V64QImode:
                  if (pattern1416 (x3, 
E_V64HImode, 
E_V64QImode) != 0
                      || !(
#line 21888 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 740 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8490; /* *avx512bw_uavgv64qi3 */

                case E_V32QImode:
                  if (pattern1416 (x3, 
E_V32HImode, 
E_V32QImode) != 0
                      || !(
#line 21888 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 740 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 8492; /* *avx2_uavgv32qi3 */

                case E_V16QImode:
                  if (pattern1416 (x3, 
E_V16HImode, 
E_V16QImode) != 0
                      || !
#line 21888 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8494; /* *sse2_uavgv16qi3 */

                case E_V32HImode:
                  if (pattern1416 (x3, 
E_V32SImode, 
E_V32HImode) != 0
                      || !(
#line 21888 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 741 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8496; /* *avx512bw_uavgv32hi3 */

                case E_V16HImode:
                  if (pattern1416 (x3, 
E_V16SImode, 
E_V16HImode) != 0
                      || !(
#line 21888 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 741 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 8498; /* *avx2_uavgv16hi3 */

                case E_V8HImode:
                  if (pattern1416 (x3, 
E_V8SImode, 
E_V8HImode) != 0
                      || !
#line 21888 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8500; /* *sse2_uavgv8hi3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (pattern617 (x7) != 0)
                return -1;
              x8 = XEXP (x7, 0);
              x10 = XEXP (x8, 0);
              x13 = XEXP (x10, 0);
              operands[1] = x13;
              if (nonimmediate_operand (operands[1], E_V32HImode))
                {
                  res = recog_316 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x14 = XEXP (x8, 1);
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              x12 = XEXP (x6, 1);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1524 (x3, 
E_V32HImode, 
E_V32SImode) != 0
                      || !(
#line 22992 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 653 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8613; /* *avx512bw_pmulhrswv32hi3 */

                case E_V16HImode:
                  if (pattern1524 (x3, 
E_V16HImode, 
E_V16SImode) != 0
                      || !(
#line 22992 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 8615; /* *avx2_pmulhrswv16hi3 */

                case E_V8HImode:
                  if (pattern1524 (x3, 
E_V8HImode, 
E_V8SImode) != 0
                      || !
#line 22992 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8617; /* *ssse3_pmulhrswv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !nonimmediate_operand (operands[1], E_V16SImode)
          || !(
#line 29935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10056; /* clzv16si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !(
#line 29935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10058; /* clzv8si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode)
          || !(
#line 29935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10060; /* clzv4si2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 29935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10062; /* clzv8di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || !(
#line 29935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10064; /* clzv4di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode)
          || !(
#line 29935 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10066; /* clzv2di2 */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern32 (x1))
    {
    case 0:
      if (!
#line 17553 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return -1;
      return 7695; /* *rotlv1ti3_internal */

    case 1:
      if (!(
#line 17649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7731; /* avx512f_rolv16si */

    case 2:
      if (!(
#line 17649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7735; /* avx512vl_rolv8si */

    case 3:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7739; /* avx512vl_rolv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26598 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9031; /* xop_rotlv4si3 */

    case 4:
      if (!(
#line 17649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7743; /* avx512f_rolv8di */

    case 5:
      if (!(
#line 17649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7747; /* avx512vl_rolv4di */

    case 6:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17649 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7751; /* avx512vl_rolv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26598 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9032; /* xop_rotlv2di3 */

    case 7:
      if (!
#line 26598 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9029; /* xop_rotlv16qi3 */

    case 8:
      if (!
#line 26598 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9030; /* xop_rotlv8hi3 */

    case 9:
      if (!(
#line 17639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7707; /* avx512f_rolvv16si */

    case 10:
      if (!(
#line 17639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7711; /* avx512vl_rolvv8si */

    case 11:
      if (!(
#line 17639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7715; /* avx512vl_rolvv4si */

    case 12:
      if (!(
#line 17639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7719; /* avx512f_rolvv8di */

    case 13:
      if (!(
#line 17639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7723; /* avx512vl_rolvv4di */

    case 14:
      if (!(
#line 17639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7727; /* avx512vl_rolvv2di */

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (pattern1148 (x1))
    {
    case 0:
      if (!(
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1861; /* stack_protect_set_1_si_si */

    case 1:
      if (!(
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1863; /* stack_protect_set_1_si_di */

    case 2:
      if (!(
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1862; /* stack_protect_set_1_di_si */

    case 3:
      if (!(
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1864; /* stack_protect_set_1_di_di */

    default:
      return -1;
    }
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 105:
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!push_operand (operands[0], E_TImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3922 "../../gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2 && TARGET_APX_PPX))
        return -1;
      return 163; /* push2p_di */

    case 40:
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          if (XWINT (x8, 0) == 0L)
            {
              res = recog_362 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != NEG
              || GET_MODE (x6) != E_CCOmode
              || GET_MODE (x3) != E_CCOmode)
            return -1;
          operands[2] = x8;
          x10 = XEXP (x4, 0);
          operands[0] = x10;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (pattern1657 (x9, 
E_QImode) != 0
                  || !
#line 14537 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, QImode, operands)
   && mode_signbit_p (QImode, operands[2])))
                return -1;
              return 991; /* *negvqi3 */

            case E_HImode:
              if (pattern1657 (x9, 
E_HImode) != 0
                  || !
#line 14537 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, HImode, operands)
   && mode_signbit_p (HImode, operands[2])))
                return -1;
              return 992; /* *negvhi3 */

            case E_SImode:
              if (pattern1657 (x9, 
E_SImode) != 0
                  || !
#line 14537 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands)
   && mode_signbit_p (SImode, operands[2])))
                return -1;
              return 993; /* *negvsi3 */

            case E_DImode:
              if (pattern1657 (x9, 
E_DImode) != 0
                  || !(
#line 14537 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands)
   && mode_signbit_p (DImode, operands[2])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 994; /* *negvdi3 */

            default:
              return -1;
            }

        case AND:
          x12 = XEXP (x7, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x8, 0) != 0L)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET
              || GET_MODE (x6) != E_CCCmode
              || GET_MODE (x3) != E_CCCmode)
            return -1;
          x13 = XEXP (x7, 0);
          operands[1] = x13;
          x10 = XEXP (x4, 0);
          operands[0] = x10;
          x9 = XEXP (x4, 1);
          switch (GET_CODE (x9))
            {
            case LSHIFTRT:
              switch (pattern1618 (x1))
                {
                case 0:
                  return 1387; /* lshrsi3_carry */

                case 1:
                  if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 1389; /* lshrdi3_carry */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1618 (x1))
                {
                case 0:
                  return 1388; /* ashrsi3_carry */

                case 1:
                  if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 1390; /* ashrdi3_carry */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 98:
      if (pattern550 (x1) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1419 (x3, 
E_SImode) != 0
              || !
#line 21751 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1566; /* bmi_bextr_si */

        case E_DImode:
          if (pattern1419 (x3, 
E_DImode) != 0
              || !(
#line 21751 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1567; /* bmi_bextr_di */

        default:
          return -1;
        }

    case 66:
      if (GET_MODE (x3) != E_XFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_XFmode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      if (!scratch_operand (operands[3], E_XFmode)
          || !
#line 24000 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1715; /* atan2xf3 */

    case 67:
      if (pattern551 (x1) != 0
          || !
#line 24303 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1716; /* fyl2xxf3_i387 */

    case 68:
      if (pattern551 (x1) != 0
          || !
#line 24400 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1717; /* fyl2xp1xf3_i387 */

    case 84:
      if (GET_MODE (x3) != E_XFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern813 (x9, 
E_XFmode, 
85, 
2, 
UNSPEC) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_XFmode)
          || pattern1420 (x1) != 0
          || !
#line 24535 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1720; /* fscalexf4_i387 */

    case 93:
      if (GET_MODE (x3) != E_CCZmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!flags_reg_operand (operands[0], E_CCZmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !scratch_operand (operands[3], E_SImode)
              || !
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          return 1877; /* stack_protect_test_1_si */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          return 1878; /* stack_protect_test_1_di */

        default:
          return -1;
        }

    case 63:
      if (pattern552 (x1) != 0
          || !
#line 890 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2051; /* mmx_ieee_maxv2sf3 */

    case 62:
      if (pattern552 (x1) != 0
          || !
#line 890 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2052; /* mmx_ieee_minv2sf3 */

    case 160:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      operands[5] = x6;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != UNSPEC
          || XVECLEN (x14, 0) != 4
          || XINT (x14, 1) != 154)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      operands[0] = x15;
      x16 = XVECEXP (x14, 0, 1);
      operands[2] = x16;
      x17 = XVECEXP (x14, 0, 2);
      operands[4] = x17;
      if (!const1248_operand (operands[4], E_SImode))
        return -1;
      x18 = XVECEXP (x14, 0, 3);
      operands[6] = x18;
      x8 = XVECEXP (x3, 0, 1);
      operands[3] = x8;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x7, operands[6]))
        return -1;
      switch (GET_MODE (operands[5]))
        {
        case E_V16SImode:
          if (!vsib_mem_operator (operands[5], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (x14))
            {
            case E_SImode:
              switch (pattern1766 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9836; /* *avx512f_scattersiv16si */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9860; /* *avx512f_scatterdiv16si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1766 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9848; /* *avx512f_scattersiv16si */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9872; /* *avx512f_scatterdiv16si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V16SFmode:
          if (!vsib_mem_operator (operands[5], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (x14))
            {
            case E_SImode:
              switch (pattern1767 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9837; /* *avx512f_scattersiv16sf */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9861; /* *avx512f_scatterdiv16sf */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1767 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9849; /* *avx512f_scattersiv16sf */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9873; /* *avx512f_scatterdiv16sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1708 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9838; /* *avx512f_scattersiv8di */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9862; /* *avx512f_scatterdiv8di */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9850; /* *avx512f_scattersiv8di */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9874; /* *avx512f_scatterdiv8di */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern1708 (x2, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9839; /* *avx512f_scattersiv8df */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9863; /* *avx512f_scatterdiv8df */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9851; /* *avx512f_scattersiv8df */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9875; /* *avx512f_scatterdiv8df */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern1709 (x2, 
E_V8SImode))
            {
            case 0:
              switch (pattern1815 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9840; /* *avx512f_scattersiv8si */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9864; /* *avx512f_scatterdiv8si */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1815 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9852; /* *avx512f_scattersiv8si */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9876; /* *avx512f_scatterdiv8si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8SFmode:
          switch (pattern1709 (x2, 
E_V8SFmode))
            {
            case 0:
              switch (pattern1816 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9841; /* *avx512f_scattersiv8sf */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9865; /* *avx512f_scatterdiv8sf */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1816 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9853; /* *avx512f_scattersiv8sf */

                case 1:
                  if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9877; /* *avx512f_scatterdiv8sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1711 (x2, 
E_V4DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9842; /* *avx512f_scattersiv4di */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9866; /* *avx512f_scatterdiv4di */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9854; /* *avx512f_scattersiv4di */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9878; /* *avx512f_scatterdiv4di */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern1711 (x2, 
E_V4DFmode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9843; /* *avx512f_scattersiv4df */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9867; /* *avx512f_scatterdiv4df */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9855; /* *avx512f_scattersiv4df */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9879; /* *avx512f_scatterdiv4df */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern1713 (x2, 
E_V4SImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9844; /* *avx512f_scattersiv4si */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9868; /* *avx512f_scatterdiv4si */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9856; /* *avx512f_scattersiv4si */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9880; /* *avx512f_scatterdiv4si */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1713 (x2, 
E_V4SFmode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9845; /* *avx512f_scattersiv4sf */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9869; /* *avx512f_scatterdiv4sf */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9857; /* *avx512f_scattersiv4sf */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9881; /* *avx512f_scatterdiv4sf */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern1713 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9846; /* *avx512f_scattersiv2di */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9870; /* *avx512f_scatterdiv2di */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9858; /* *avx512f_scattersiv2di */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9882; /* *avx512f_scatterdiv2di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern1713 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9847; /* *avx512f_scattersiv2df */

            case 1:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9871; /* *avx512f_scatterdiv2df */

            case 2:
              if (!(
#line 29599 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9859; /* *avx512f_scattersiv2df */

            case 3:
              if (!(
#line 29639 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1015 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9883; /* *avx512f_scatterdiv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = recog_390 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_CODE (x4))
        {
        case SUBREG:
          switch (pattern1046 (x2))
            {
            case 0:
              if (!
#line 8242 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8242 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8242 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        case CONST_INT:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != CLZ)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (XWINT (x4, 0))
            {
            case 63L:
              if (pattern1431 (x3, 
E_DImode) != 0
                  || !
#line 21252 "../../gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT))
                return -1;
              return 1525; /* bsr_rex64_1 */

            case 31L:
              if (pattern1431 (x3, 
E_SImode) != 0
                  || !
#line 21293 "../../gcc/config/i386/i386.md"
(!TARGET_LZCNT))
                return -1;
              return 1528; /* bsr_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern351 (x5) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x11 = XEXP (x4, 1);
      switch (GET_CODE (x11))
        {
        case LTU:
        case UNLT:
          operands[4] = x11;
          x12 = XEXP (x11, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x11, 0);
          operands[3] = x13;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1627 (x3, 
E_QImode) != 0
                  || !
#line 9271 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1627 (x3, 
E_HImode) != 0
                  || !
#line 9271 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 488; /* subhi3_carry */

            case E_SImode:
              if (pattern1628 (x3, 
E_SImode) != 0
                  || !
#line 9271 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 489; /* subsi3_carry */

            case E_DImode:
              if (pattern1628 (x3, 
E_DImode) != 0
                  || !(
#line 9271 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 490; /* subdi3_carry */

            default:
              return -1;
            }

        case EQ:
          x12 = XEXP (x11, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x11, 0);
          operands[3] = x13;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1566 (x3, 
E_QImode) != 0
                  || !
#line 10224 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1566 (x3, 
E_HImode) != 0
                  || !
#line 10224 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 571; /* *subhi3_eq */

            case E_SImode:
              if (pattern1567 (x3, 
E_SImode) != 0
                  || !
#line 10224 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 572; /* *subsi3_eq */

            case E_DImode:
              if (pattern1567 (x3, 
E_DImode) != 0
                  || !(
#line 10224 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 573; /* *subdi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      res = recog_397 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x5;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x5, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern227 (x8, 
E_CCmode, 
17) != 0
              || GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          switch (pattern1621 (x2))
            {
            case 0:
              if (
#line 12762 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 731; /* *andqi_exthi_1_slp */
              break;

            case 1:
              if (
#line 12762 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 734; /* *andqi_extsi_1_slp */
              break;

            case 2:
              if ((
#line 12762 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 737; /* *andqi_extdi_1_slp */
              break;

            case 3:
              return 755; /* *andqi_exthi_0 */

            case 4:
              return 758; /* *andqi_extsi_0 */

            case 5:
              if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 761; /* *andqi_extdi_0 */
              break;

            default:
              break;
            }
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != SUBREG)
            return -1;
          switch (pattern1622 (x2))
            {
            case 0:
              if (!
#line 12795 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 740; /* *andqi_exthi_2_slp */

            case 1:
              if (!
#line 12795 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 743; /* *andqi_extsi_2_slp */

            case 2:
              if (!(
#line 12795 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 746; /* *andqi_extdi_2_slp */

            case 3:
              return 764; /* *andqi_ext2hi_0 */

            case 4:
              return 767; /* *andqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 770; /* *andqi_ext2di_0 */

            default:
              return -1;
            }

        case ROTATE:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern406 (x8) != 0)
            return -1;
          switch (pattern1433 (x2))
            {
            case 0:
              if (!
#line 18956 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1409; /* *btrqi_1 */

            case 1:
              if (!
#line 18956 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1410; /* *btrhi_1 */

            default:
              return -1;
            }

        case CTZ:
          switch (pattern819 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 21137 "../../gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT))
                return -1;
              return 1518; /* *ctzsi2_zext */

            case 1:
              if (!
#line 21166 "../../gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1519; /* *ctzsi2_zext_falsedep */

            default:
              return -1;
            }

        case CLZ:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x10 = XEXP (x3, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          x8 = XVECEXP (x1, 0, 1);
          switch (pattern818 (x8, pnum_clobbers))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 21574 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT))
                return -1;
              return 1540; /* *clzsi2_lzcnt_zext */

            case 1:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!nonimmediate_operand (operands[1], E_SImode)
                      || !
#line 21602 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1541; /* *clzsi2_lzcnt_zext_falsedep */

                case E_DImode:
                  if (!nonimmediate_operand (operands[1], E_DImode)
                      || !(
#line 21602 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1542; /* *clzsi2_lzcnt_zext_falsedep */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case POPCOUNT:
          switch (pattern819 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 22255 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
                return -1;
              return 1626; /* *popcountsi2_zext */

            case 1:
              if (!
#line 22289 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1627; /* *popcountsi2_zext_falsedep */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          res = recog_398 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_QImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != LSHIFTRT)
            return -1;
          x10 = XEXP (x3, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern227 (x8, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1527 (x3))
            {
            case 0:
              if (!
#line 19358 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1436; /* *btsi_setncqi */

            case 1:
              if (!(
#line 19358 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1437; /* *btdi_setncqi */

            default:
              return -1;
            }

        case LSHIFTRT:
          x10 = XEXP (x3, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern227 (x8, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1244 (x3))
            {
            case 0:
              if (!
#line 19376 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1438; /* *btsi_setncsi */

            case 1:
              if (!(
#line 19376 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1439; /* *btdi_setncdi */

            default:
              return -1;
            }

        case ASHIFT:
          x9 = XEXP (x5, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern227 (x8, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1246 (x3))
            {
            case 0:
              if (!
#line 21957 "../../gcc/config/i386/i386.md"
(TARGET_BMI2))
                return -1;
              return 1590; /* *bmi2_bzhi_si3_3 */

            case 1:
              if (!(
#line 21957 "../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1591; /* *bmi2_bzhi_di3_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern371 (x1, 
-2))
        {
        case 0:
          x12 = XEXP (x4, 1);
          operands[2] = x12;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern946 (x3))
                {
                case 0:
                  if (
#line 18887 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    return 1403; /* *btrsi */
                  break;

                case 1:
                  if ((
#line 18887 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1404; /* *btrdi */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x12) != SUBREG)
            return -1;
          switch (pattern1329 (x3))
            {
            case 0:
              if (!
#line 18906 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1405; /* *btrsi_mask */

            case 1:
              if (!(
#line 18906 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1406; /* *btrdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18934 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1407; /* *btrsi_mask_1 */

        case 2:
          if (!(
#line 18934 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1408; /* *btrdi_mask_1 */

        default:
          return -1;
        }

    case NEG:
      if (pattern345 (x1) != 0)
        return -1;
      x10 = XEXP (x3, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern200 (x3, 
E_SImode) != 0
              || !
#line 21778 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1570; /* *bmi_blsi_si */

        case E_DImode:
          if (pattern200 (x3, 
E_DImode) != 0
              || !(
#line 21778 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1571; /* *bmi_blsi_di */

        default:
          return -1;
        }

    case PLUS:
      x12 = XEXP (x4, 1);
      if (GET_CODE (x12) != CONST_INT
          || pattern338 (x1) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          switch (XWINT (x12, 0))
            {
            case -1L:
              switch (pattern1328 (x3))
                {
                case 0:
                  if (!
#line 21835 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  return 1578; /* *bmi_blsr_si */

                case 1:
                  if (!(
#line 21835 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1579; /* *bmi_blsr_di */

                case 2:
                  if (!
#line 22150 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1616; /* *tbm_tzmsk_si */

                case 3:
                  if (!(
#line 22150 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1617; /* *tbm_tzmsk_di */

                default:
                  return -1;
                }

            case 1L:
              switch (pattern1328 (x3))
                {
                case 0:
                  if (!
#line 22041 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1600; /* *tbm_blcfill_si */

                case 1:
                  if (!(
#line 22041 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1601; /* *tbm_blcfill_di */

                case 2:
                  if (!
#line 22069 "../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1604; /* *tbm_blcic_si */

                case 3:
                  if (!(
#line 22069 "../../gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1605; /* *tbm_blcic_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          x9 = XEXP (x5, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x12, 0) != -1L)
            return -1;
          switch (pattern1246 (x3))
            {
            case 0:
              if (!
#line 21943 "../../gcc/config/i386/i386.md"
(TARGET_BMI2))
                return -1;
              return 1588; /* *bmi2_bzhi_si3_2 */

            case 1:
              if (!(
#line 21943 "../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1589; /* *bmi2_bzhi_di3_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS
          || pattern693 (x5) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x13 = XEXP (x8, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 17
          || GET_MODE (x13) != E_CCmode)
        return -1;
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x5, 0);
      x14 = XEXP (x9, 1);
      operands[2] = x14;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !
#line 21989 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2))
        return -1;
      return 1593; /* *bmi2_bzhi_zero_extendsidi_5 */

    default:
      return -1;
    }
}

 int
recog_412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case CTZ:
      switch (pattern937 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 21179 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1520; /* *ctzsidi2_sext */

        case 1:
          if (!
#line 21218 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1522; /* *ctzsidi2_sext_falsedep */

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CLZ
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern227 (x10, 
E_CCmode, 
17) != 0)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21350 "../../gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT && ix86_pre_reload_split ()))
        return -1;
      return 1531; /* *bsr_2 */

    default:
      return -1;
    }
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 4
      || XINT (x4, 1) != 153)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != 154)
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != SCRATCH)
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 4)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x13 = XVECEXP (x9, 0, 3);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x2, 0);
  operands[0] = x15;
  x16 = XVECEXP (x6, 0, 1);
  if (!register_operand (x16, E_V4DImode))
    return -1;
  x17 = XVECEXP (x6, 0, 2);
  if (!const1248_operand (x17, E_SImode))
    return -1;
  x18 = XEXP (x14, 0);
  operands[1] = x18;
  x19 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x19))
    {
    case REG:
    case SUBREG:
      operands[2] = x19;
      operands[7] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[3] = x20;
      operands[4] = x16;
      operands[6] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[5] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1847 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29404 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9732; /* *avx2_gatherdiv8si_3 */

            case 1:
              if (!(
#line 29404 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9734; /* *avx2_gatherdiv8si_3 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1847 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29404 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9733; /* *avx2_gatherdiv8sf_3 */

            case 1:
              if (!(
#line 29404 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9735; /* *avx2_gatherdiv8sf_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PC:
      operands[6] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[2] = x20;
      operands[3] = x16;
      operands[5] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[4] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1843 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29428 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9736; /* *avx2_gatherdiv8si_4 */

            case 1:
              if (!(
#line 29428 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9738; /* *avx2_gatherdiv8si_4 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1843 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29428 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9737; /* *avx2_gatherdiv8sf_4 */

            case 1:
              if (!(
#line 29428 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9739; /* *avx2_gatherdiv8sf_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_427 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      return recog_422 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern227 (x7, 
E_CCmode, 
17) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1441 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 4979 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return -1;
              return 185; /* extendsidi2_1 */

            case E_TImode:
              if (pattern1441 (x3, 
E_DImode, 
E_TImode) != 0
                  || !
#line 4987 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 186; /* extendditi2 */

            default:
              return -1;
            }

        case CTZ:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != UNSPEC
              || XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 38)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17
              || GET_MODE (x8) != E_CCmode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x7, 0, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 21218 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1522; /* *ctzsidi2_sext_falsedep */

        default:
          return -1;
        }

    case FIX:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      switch (pattern824 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 6015 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(TARGET_64BIT && SSE_FLOAT_MODE_P (GET_MODE (operands[1])))))
            return -1;
          *pnum_clobbers = 1;
          return 235; /* fix_truncdi_i387 */

        case 1:
          if (!
#line 6028 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !SSE_FLOAT_MODE_P (GET_MODE (operands[1]))))
            return -1;
          return 236; /* fix_trunchi_i387 */

        case 2:
          if (!
#line 6028 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !SSE_FLOAT_MODE_P (GET_MODE (operands[1]))))
            return -1;
          return 237; /* fix_truncsi_i387 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      switch (pattern573 (x1))
        {
        case 0:
          if (!
#line 6291 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 261; /* floatunssisf2_i387_with_xmm */

        case 1:
          if (!
#line 6291 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 262; /* floatunssidf2_i387_with_xmm */

        case 2:
          if (!
#line 6291 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 263; /* floatunssixf2_i387_with_xmm */

        default:
          return -1;
        }

    case EQ:
      return recog_426 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 627; /* smulsi3_highpart */

        case 1:
          if (!
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 629; /* smuldi3_highpart */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 628; /* umulsi3_highpart */

        case 1:
          if (!
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 630; /* umuldi3_highpart */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_423 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != LSHIFTRT)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != MULT)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern828 (x1) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[3] = x12;
      x13 = XEXP (x9, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTEND:
          switch (pattern1501 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 11168 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 633; /* *smuldi3_highpart_1 */

            case 1:
              if (!
#line 11217 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 637; /* *smulsi3_highpart_1 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1501 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 11168 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 634; /* *umuldi3_highpart_1 */

            case 1:
              if (!
#line 11217 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 638; /* *umulsi3_highpart_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      switch (pattern216 (x1))
        {
        case 0:
          switch (pattern1336 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 639; /* divmodsi4_1 */

            case 1:
              if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 640; /* divmoddi4_1 */

            case 2:
              if (!
#line 1191 "../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              return 647; /* *divmodhi4 */

            case 3:
              return 648; /* *divmodsi4 */

            case 4:
              if (!
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 649; /* *divmoddi4 */

            case 5:
              if ((
#line 11845 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1191 "../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                return 661; /* *divmodhi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1191 "../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              *pnum_clobbers = 1;
              return 667; /* *divmodhi4_noext */

            case 6:
              if (
#line 11845 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                return 663; /* *divmodsi4_noext_nf */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 669; /* *divmodsi4_noext */

            case 7:
              if ((
#line 11845 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 665; /* *divmoddi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 671; /* *divmoddi4_noext */

            default:
              return -1;
            }

        case 1:
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern953 (x4, 
E_CCmode, 
17) != 0
              || pattern1496 (x1) != 0
              || !
#line 11901 "../../gcc/config/i386/i386.md"
(!optimize_function_for_size_p (cfun)))
            return -1;
          return 677; /* *divmodsi4_const */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern217 (x1))
        {
        case 0:
          switch (pattern1336 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 641; /* udivmodsi4_1 */

            case 1:
              if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 642; /* udivmoddi4_1 */

            case 2:
              if (!
#line 1191 "../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              return 650; /* *udivmodhi4 */

            case 3:
              return 651; /* *udivmodsi4 */

            case 4:
              if (!
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 652; /* *udivmoddi4 */

            case 5:
              if ((
#line 11845 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1191 "../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                return 662; /* *udivmodhi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1191 "../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              *pnum_clobbers = 1;
              return 668; /* *udivmodhi4_noext */

            case 6:
              if (
#line 11845 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                return 664; /* *udivmodsi4_noext_nf */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 670; /* *udivmodsi4_noext */

            case 7:
              if ((
#line 11845 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 666; /* *udivmoddi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1192 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 672; /* *udivmoddi4_noext */

            default:
              return -1;
            }

        case 1:
          x4 = XVECEXP (x1, 0, 2);
          if (pattern953 (x4, 
E_CCmode, 
17) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1497 (x1, 
E_SImode) != 0
                  || !
#line 11654 "../../gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
                return -1;
              return 653; /* *udivmodsi4_pow2 */

            case E_DImode:
              if (pattern1497 (x1, 
E_DImode) != 0
                  || !(
#line 11654 "../../gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 654; /* *udivmoddi4_pow2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 14828 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1016; /* *abshf2_1 */

        case 1:
          if (!
#line 14844 "../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1018; /* *abssf2_1 */

        case 2:
          if (!
#line 14844 "../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1020; /* *absdf2_1 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 14828 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1017; /* *neghf2_1 */

        case 1:
          if (!
#line 14844 "../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1019; /* *negsf2_1 */

        case 2:
          if (!
#line 14844 "../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1021; /* *negdf2_1 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1332; /* ix86_rotldi3_doubleword */

        case 1:
          if (!
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1333; /* ix86_rotlti3_doubleword */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1334; /* ix86_rotrdi3_doubleword */

        case 1:
          if (!
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1335; /* ix86_rotrti3_doubleword */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_QImode
          || pattern382 (x1) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      x7 = XVECEXP (x1, 0, 1);
      x15 = XEXP (x7, 1);
      x16 = XEXP (x15, 1);
      operands[3] = x16;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 20477 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
        return -1;
      return 1485; /* *sibcall_value_pop_memory */

    case PLUS:
      x4 = XVECEXP (x1, 0, 2);
      if (pattern222 (x4) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 6)
        {
          x14 = XEXP (x3, 1);
          if (GET_CODE (x14) == CONST_INT)
            {
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) == REG
                  && REGNO (x5) == 7)
                {
                  x7 = XVECEXP (x1, 0, 1);
                  if (pattern712 (x7, 
6, 
MEM) == 0)
                    {
                      switch (XWINT (x14, 0))
                        {
                        case 4L:
                          if (pattern1679 (x1, 
E_SImode) == 0
                              && 
#line 20883 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                            return 1504; /* *leave */
                          break;

                        case 8L:
                          if (pattern1679 (x1, 
E_DImode) == 0
                              && 
#line 20891 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                            return 1505; /* *leave_rex64 */
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
        }
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x12 = XEXP (x7, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 17
          || GET_MODE (x12) != E_CCmode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      operands[1] = x6;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1505 (x3, 
E_SImode) != 0
              || !
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))
            return -1;
          return 1849; /* pro_epilogue_adjust_stack_add_si */

        case E_DImode:
          if (pattern1505 (x3, 
E_DImode) != 0
              || !
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))
            return -1;
          return 1850; /* pro_epilogue_adjust_stack_add_di */

        default:
          return -1;
        }

    case FFS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER
          || pattern711 (x1) != 0
          || !
#line 20986 "../../gcc/config/i386/i386.md"
(!TARGET_CMOVE))
        return -1;
      return 1507; /* ffssi2_no_cmove */

    case COMPARE:
      if (GET_MODE (x3) != E_CCCmode)
        return -1;
      x14 = XEXP (x3, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern574 (x1, 
CTZ, 
E_CCCmode) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 38)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      x17 = XVECEXP (x4, 0, 0);
      operands[2] = x17;
      x15 = XEXP (x7, 1);
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern1658 (x15, 
E_SImode) != 0
              || !
#line 21044 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1510; /* *tzcntsi_1_falsedep */

        case E_DImode:
          if (pattern1658 (x15, 
E_DImode) != 0
              || !(
#line 21044 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1511; /* *tzcntdi_1_falsedep */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern225 (x1))
        {
        case 0:
          return 1516; /* *ctzsi2_falsedep */

        case 1:
          if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1517; /* *ctzdi2_falsedep */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_DImode)
        return -1;
      x14 = XEXP (x3, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 38
          || pattern828 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x7, 0, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (GET_CODE (x9))
        {
        case CTZ:
          x13 = XEXP (x9, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21166 "../../gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT))
            return -1;
          return 1519; /* *ctzsi2_zext_falsedep */

        case CLZ:
          x13 = XEXP (x9, 0);
          operands[1] = x13;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 21602 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
                return -1;
              return 1541; /* *clzsi2_lzcnt_zext_falsedep */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 21602 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1542; /* *clzsi2_lzcnt_zext_falsedep */

            default:
              return -1;
            }

        case POPCOUNT:
          x13 = XEXP (x9, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22289 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
            return -1;
          return 1627; /* *popcountsi2_zext_falsedep */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 21559 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1538; /* *clzsi2_lzcnt_falsedep */

        case 1:
          if (!(
#line 21559 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1539; /* *clzdi2_lzcnt_falsedep */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 22234 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT))
            return -1;
          return 1624; /* *popcountsi2_falsedep */

        case 1:
          if (!(
#line 22234 "../../gcc/config/i386/i386.md"
(TARGET_POPCNT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1625; /* *popcountdi2_falsedep */

        default:
          return -1;
        }

    case MEM:
      return recog_425 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (pattern226 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern381 (x4, 
36) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      x19 = XEXP (x5, 0);
      operands[1] = x19;
      x7 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      x15 = XEXP (x7, 1);
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x16 = XEXP (x15, 1);
      switch (XWINT (x16, 0))
        {
        case 8L:
          switch (pattern1573 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 25698 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1769; /* *strsetdi_rex_1 */

            case 1:
              if (!(
#line 25698 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1770; /* *strsetdi_rex_1 */

            default:
              return -1;
            }

        case 4L:
          switch (pattern1573 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 25713 "../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1771; /* *strsetsi_1 */

            case 1:
              if (!(
#line 25713 "../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1772; /* *strsetsi_1 */

            default:
              return -1;
            }

        case 2L:
          switch (pattern1573 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 25727 "../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1773; /* *strsethi_1 */

            case 1:
              if (!(
#line 25727 "../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1774; /* *strsethi_1 */

            default:
              return -1;
            }

        case 1L:
          switch (pattern1573 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 25741 "../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1775; /* *strsetqi_1 */

            case 1:
              if (!(
#line 25741 "../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1776; /* *strsetqi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XVECEXP (x1, 0, 1);
      if (pattern227 (x7, 
E_CCmode, 
17) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern222 (x4) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern568 (x3, 
E_SImode) != 0
              || !
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))
            return -1;
          return 1851; /* pro_epilogue_adjust_stack_sub_si */

        case E_DImode:
          if (pattern568 (x3, 
E_DImode) != 0
              || !
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))
            return -1;
          return 1852; /* pro_epilogue_adjust_stack_sub_di */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_424 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return split_5 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) != 17
              || pattern55 (x1, 
E_CCCmode) != 0
              || !(
#line 9877 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9879 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_195 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x2), 0))
            return NULL;
          x3 = XEXP (x2, 0);
          switch (GET_CODE (x3))
            {
            case NOT:
              switch (pattern249 (x1))
                {
                case 0:
                  if (!
#line 15137 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_549 (insn, operands);

                case 1:
                  if (!
#line 15137 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_550 (insn, operands);

                case 2:
                  if (!(
#line 15137 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_551 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              switch (pattern292 (x2))
                {
                case 0:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_601 (insn, operands);

                case 1:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_603 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              switch (pattern292 (x2))
                {
                case 0:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_602 (insn, operands);

                case 1:
                  if (!((
#line 16740 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16742 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_604 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_6 (x1, insn);

    case IOR:
      return split_7 (x1, insn);

    case XOR:
      return split_8 (x1, insn);

    case FLOAT_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case SUBREG:
        case MEM:
          if (memory_operand (operands[1], E_VOIDmode)
              && any_fp_register_operand (operands[0], E_VOIDmode)
              && 
#line 4608 "../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
            return gen_split_49 (insn, operands);
          break;

        case REG:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[1], E_SFmode)
          || !sse_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return NULL;
      if (
#line 5333 "../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_70 (insn, operands);
      if (!
#line 5396 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_71 (insn, operands);

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 4654 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 4656 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case E_DImode:
              if (GET_MODE (x2) != E_DImode)
                return NULL;
              if (memory_operand (operands[0], E_DImode)
                  && memory_operand (operands[1], E_SImode)
                  && 
#line 4778 "../../gcc/config/i386/i386.md"
(reload_completed))
                return gen_split_54 (insn, operands);
              if (general_reg_operand (operands[0], E_DImode)
                  && general_reg_operand (operands[1], E_SImode)
                  && 
#line 4785 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && REGNO (operands[0]) == REGNO (operands[1])))
                return gen_split_55 (insn, operands);
              if (!nonimmediate_gr_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 4793 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return NULL;
              return gen_split_56 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 19
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x5 = XVECEXP (x3, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !(
#line 23066 "../../gcc/config/i386/i386.md"
(TARGET_X32) && 
#line 23068 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!sse_reg_operand (operands[0], E_SFmode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return NULL;
      if (
#line 5572 "../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_72 (insn, operands);
      if (!
#line 5626 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_73 (insn, operands);

    case FLOAT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x2) != E_SFmode)
            return NULL;
          if (sse_reg_operand (operands[0], E_SFmode)
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (
#line 6153 "../../gcc/config/i386/i386.md"
(TARGET_SSE2
   && TARGET_USE_VECTOR_CONVERTS
   && optimize_function_for_speed_p (cfun)
   && reload_completed
   && (MEM_P (operands[1]) || TARGET_INTER_UNIT_MOVES_TO_VEC)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_79 (insn, operands);
              if (
#line 6238 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_87 (insn, operands);
            }
          if (register_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_DImode)
              && 
#line 6182 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return gen_split_81 (insn, operands);
          if (!sse_reg_operand (operands[0], E_SFmode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 6238 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_88 (insn, operands);

        case E_DFmode:
          if (GET_MODE (x2) != E_DFmode)
            return NULL;
          if (sse_reg_operand (operands[0], E_DFmode)
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (
#line 6153 "../../gcc/config/i386/i386.md"
(TARGET_SSE2
   && TARGET_USE_VECTOR_CONVERTS
   && optimize_function_for_speed_p (cfun)
   && reload_completed
   && (MEM_P (operands[1]) || TARGET_INTER_UNIT_MOVES_TO_VEC)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_80 (insn, operands);
              if (
#line 6238 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_89 (insn, operands);
            }
          if (register_operand (operands[0], E_DFmode)
              && register_operand (operands[1], E_DImode)
              && 
#line 6182 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return gen_split_82 (insn, operands);
          if (!sse_reg_operand (operands[0], E_DFmode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 6238 "../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_90 (insn, operands);

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !register_operand (operands[1], E_DImode)
              || !
#line 6182 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return NULL;
          return gen_split_83 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const1248_operand (operands[1], E_SImode)
              || !
#line 6422 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed))
            return NULL;
          return gen_split_96 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const1248_operand (operands[1], E_DImode)
              || !(
#line 6422 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_97 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 2:
          switch (XINT (x2, 1))
            {
            case 40:
              if (GET_MODE (x2) != E_CCCmode)
                return NULL;
              x7 = XVECEXP (x2, 0, 0);
              if (GET_CODE (x7) != LTU
                  || pattern716 (x7) != 0
                  || pattern246 (x1) != 0)
                return NULL;
              x8 = XEXP (x7, 0);
              switch (GET_MODE (x8))
                {
                case E_CCmode:
                  if (!(
#line 9898 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9900 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case E_CCCmode:
                  if (!(
#line 9898 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9900 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                default:
                  return NULL;
                }

            case 45:
              if (pattern296 (x2) != 0)
                return NULL;
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 1);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode)
                  || !(
#line 19570 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 19572 "../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_856 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (XINT (x2, 1))
            {
            case 97:
              switch (pattern300 (x2))
                {
                case 0:
                  if (!((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 21665 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_890 (insn, operands);

                case 1:
                  if (!((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21645 "../../gcc/config/i386/i386.md"
(TARGET_BMI))) && 
#line 21665 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_892 (insn, operands);

                default:
                  return NULL;
                }

            case 96:
              switch (pattern300 (x2))
                {
                case 0:
                  if (!((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 21665 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_891 (insn, operands);

                case 1:
                  if (!((
#line 21663 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21646 "../../gcc/config/i386/i386.md"
(TARGET_LZCNT))) && 
#line 21665 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_893 (insn, operands);

                default:
                  return NULL;
                }

            case 19:
              x7 = XVECEXP (x2, 0, 0);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern23 (x2))
                {
                case 0:
                  if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                    return NULL;
                  return gen_split_907 (insn, operands);

                case 1:
                  if (!
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                    return NULL;
                  return gen_split_908 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          switch (pattern402 (x2))
            {
            case 0:
              return gen_split_400 (insn, operands);

            case 1:
              return gen_split_403 (insn, operands);

            case 2:
              return gen_split_409 (insn, operands);

            case 3:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_406 (insn, operands);

            case 4:
              if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_412 (insn, operands);

            case 5:
              if (!
#line 13862 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_415 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern402 (x2))
            {
            case 0:
              return gen_split_401 (insn, operands);

            case 1:
              return gen_split_404 (insn, operands);

            case 2:
              return gen_split_410 (insn, operands);

            case 3:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_407 (insn, operands);

            case 4:
              if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_413 (insn, operands);

            case 5:
              if (!
#line 13862 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_416 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern402 (x2))
            {
            case 0:
              return gen_split_402 (insn, operands);

            case 1:
              return gen_split_405 (insn, operands);

            case 2:
              return gen_split_411 (insn, operands);

            case 3:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_408 (insn, operands);

            case 4:
              if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_414 (insn, operands);

            case 5:
              if (!
#line 13862 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_417 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14970 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14972 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_540 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14970 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14972 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_541 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 15053 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15057 "../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_542 (insn, operands);

        case 2:
          if (!(
#line 15053 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15057 "../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_543 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          switch (pattern125 (x2))
            {
            case 0:
              if (!
#line 15982 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return NULL;
              return gen_split_570 (insn, operands);

            case 1:
              if (!(
#line 15982 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_571 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          if (!const_0_to_3_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!general_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !index_reg_operand (operands[1], E_QImode)
                  || !
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_581 (insn, operands);

            case E_HImode:
              if (!general_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !index_reg_operand (operands[1], E_HImode)
                  || !
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_582 (insn, operands);

            case E_SImode:
              if (!general_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !index_reg_operand (operands[1], E_SImode)
                  || !
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_583 (insn, operands);

            case E_DImode:
              if (!general_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !index_reg_operand (operands[1], E_DImode)
                  || !(
#line 16304 "../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_584 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern229 (x2))
        {
        case 0:
          if (!
#line 17439 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_618 (insn, operands);

        case 1:
          if (!(
#line 17439 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_620 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern229 (x2))
            {
            case 0:
              if (!
#line 17439 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return NULL;
              return gen_split_619 (insn, operands);

            case 1:
              if (!(
#line 17439 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_621 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          if (pattern290 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 18020 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_STV && TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32) && 
#line 18024 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_676 (insn, operands);
          if (!(
#line 18037 "../../gcc/config/i386/i386.md"
(!TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32
   && ix86_pre_reload_split ()) && 
#line 18042 "../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_677 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      return split_9 (x1, insn);

    case ROTATERT:
      return split_11 (x1, insn);

    case IF_THEN_ELSE:
      return split_12 (x1, insn);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x2))
        {
        case GEU:
        case LTU:
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case GTU:
        case LEU:
          operands[1] = x2;
          if (shr_comparison_operator (operands[1], E_QImode))
            {
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (nonimmediate_operand (operands[0], E_QImode))
                {
                  x3 = XEXP (x2, 0);
                  operands[2] = x3;
                  if (register_operand (operands[2], E_DImode))
                    {
                      x6 = XEXP (x2, 1);
                      operands[3] = x6;
                      if (const_int_operand (operands[3], E_VOIDmode)
                          && 
#line 19457 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3]) + 1), 32, 63)))
                        return gen_split_850 (insn, operands);
                    }
                }
            }
          break;

        case NE:
          switch (pattern230 (x1))
            {
            case 0:
              return gen_split_857 (insn, operands);

            case 1:
              return gen_split_858 (insn, operands);

            default:
              break;
            }
          break;

        case EQ:
          switch (pattern230 (x1))
            {
            case 0:
              return gen_split_859 (insn, operands);

            case 1:
              return gen_split_860 (insn, operands);

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17)
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !ix86_comparison_operator (operands[1], E_DImode)
              || !(
#line 19495 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL) && 
#line 19497 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_851 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !ix86_comparison_operator (operands[1], E_HImode)
              || !(
#line 19528 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19531 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_854 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !ix86_comparison_operator (operands[1], E_SImode)
              || !(
#line 19528 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19531 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_855 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      return split_10 (x1, insn);

    case CLZ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern125 (x2))
        {
        case 0:
          if (!(
#line 21502 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 21504 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_884 (insn, operands);

        case 1:
          if (!((
#line 21502 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21504 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_885 (insn, operands);

        default:
          return NULL;
        }

    case POPCOUNT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern125 (x2))
        {
        case 0:
          if (!(
#line 22159 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 22167 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_898 (insn, operands);

        case 1:
          if (!((
#line 22159 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 22167 "../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_899 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (nonimmediate_gr_operand (operands[0], E_V8QImode)
          && nonimmediate_gr_operand (operands[1], E_V8QImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_979 (insn, operands);
      break;

    case E_V4HImode:
      if (nonimmediate_gr_operand (operands[0], E_V4HImode)
          && nonimmediate_gr_operand (operands[1], E_V4HImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_980 (insn, operands);
      break;

    case E_V2SImode:
      if (nonimmediate_gr_operand (operands[0], E_V2SImode)
          && nonimmediate_gr_operand (operands[1], E_V2SImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_981 (insn, operands);
      break;

    case E_V1DImode:
      if (nonimmediate_gr_operand (operands[0], E_V1DImode)
          && nonimmediate_gr_operand (operands[1], E_V1DImode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_982 (insn, operands);
      break;

    case E_V2SFmode:
      if (nonimmediate_gr_operand (operands[0], E_V2SFmode)
          && nonimmediate_gr_operand (operands[1], E_V2SFmode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_983 (insn, operands);
      break;

    case E_V4HFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4HFmode)
          && nonimmediate_gr_operand (operands[1], E_V4HFmode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_984 (insn, operands);
      break;

    case E_V4BFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4BFmode)
          && nonimmediate_gr_operand (operands[1], E_V4BFmode)
          && 
#line 310 "../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_985 (insn, operands);
      break;

    case E_V4QImode:
      if (push_operand (operands[0], E_V4QImode)
          && sse_reg_operand (operands[1], E_V4QImode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1003 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1008 (insn, operands);
        }
      break;

    case E_V2HImode:
      if (push_operand (operands[0], E_V2HImode)
          && sse_reg_operand (operands[1], E_V2HImode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1004 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1009 (insn, operands);
        }
      break;

    case E_V1SImode:
      if (push_operand (operands[0], E_V1SImode)
          && sse_reg_operand (operands[1], E_V1SImode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1005 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1010 (insn, operands);
        }
      break;

    case E_V2HFmode:
      if (push_operand (operands[0], E_V2HFmode)
          && sse_reg_operand (operands[1], E_V2HFmode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1006 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1011 (insn, operands);
        }
      break;

    case E_V2BFmode:
      if (push_operand (operands[0], E_V2BFmode)
          && sse_reg_operand (operands[1], E_V2BFmode))
        {
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1007 (insn, operands);
          if ((
#line 440 "../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1012 (insn, operands);
        }
      break;

    case E_V2QImode:
      if (push_operand (operands[0], E_V2QImode)
          && sse_reg_operand (operands[1], E_V2QImode))
        {
          if ((
#line 614 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1013 (insn, operands);
          if ((
#line 614 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1014 (insn, operands);
        }
      break;

    case E_P2QImode:
      if (nonimmediate_operand (operands[0], E_P2QImode)
          && nonimmediate_operand (operands[1], E_P2QImode)
          && (
#line 30945 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 30948 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3807 (insn, operands);
      break;

    case E_P2HImode:
      if (nonimmediate_operand (operands[0], E_P2HImode)
          && nonimmediate_operand (operands[1], E_P2HImode)
          && (
#line 30945 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 30948 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3808 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != SUBREG)
    return NULL;
  operands[0] = x3;
  switch (SUBREG_BYTE (x2))
    {
    case 8:
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 14639 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return NULL;
      return gen_split_3162 (insn, operands);

    case 0:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 14692 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return NULL;
              return gen_split_3164 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21449 "../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (SImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3390 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21449 "../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (DImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3391 (insn, operands);

            default:
              return NULL;
            }

        case SS_TRUNCATE:
          switch (pattern724 (x2))
            {
            case 0:
              if (!(
#line 15412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15414 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3176 (insn, operands);

            case 1:
              if (!(
#line 15507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3179 (insn, operands);

            case 2:
              if (!(
#line 15507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3182 (insn, operands);

            case 3:
              if (!(
#line 15858 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15860 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3198 (insn, operands);

            case 4:
              if (!((
#line 15605 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15587 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15607 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3185 (insn, operands);

            case 5:
              if (!(
#line 15605 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15607 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3188 (insn, operands);

            case 6:
              if (!(
#line 16121 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16123 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3205 (insn, operands);

            case 7:
              if (!(
#line 15767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3192 (insn, operands);

            case 8:
              if (!(
#line 15767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3195 (insn, operands);

            case 9:
              if (!(
#line 16008 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16010 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3202 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          switch (pattern724 (x2))
            {
            case 0:
              if (!(
#line 15412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15414 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3177 (insn, operands);

            case 1:
              if (!(
#line 15507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3180 (insn, operands);

            case 2:
              if (!(
#line 15507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3183 (insn, operands);

            case 3:
              if (!(
#line 15858 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15860 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3199 (insn, operands);

            case 4:
              if (!((
#line 15605 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15587 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15607 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3186 (insn, operands);

            case 5:
              if (!(
#line 15605 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15607 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3189 (insn, operands);

            case 6:
              if (!(
#line 16121 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16123 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3206 (insn, operands);

            case 7:
              if (!(
#line 15767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3193 (insn, operands);

            case 8:
              if (!(
#line 15767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3196 (insn, operands);

            case 9:
              if (!(
#line 16008 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16010 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3203 (insn, operands);

            default:
              return NULL;
            }

        case US_TRUNCATE:
          switch (pattern724 (x2))
            {
            case 0:
              if (!(
#line 15412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15414 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3178 (insn, operands);

            case 1:
              if (!(
#line 15507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3181 (insn, operands);

            case 2:
              if (!(
#line 15507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3184 (insn, operands);

            case 3:
              if (!(
#line 15858 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15860 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3200 (insn, operands);

            case 4:
              if (!((
#line 15605 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15587 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15607 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3187 (insn, operands);

            case 5:
              if (!(
#line 15605 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15607 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3190 (insn, operands);

            case 6:
              if (!(
#line 16121 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16123 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3207 (insn, operands);

            case 7:
              if (!(
#line 15767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3194 (insn, operands);

            case 8:
              if (!(
#line 15767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3197 (insn, operands);

            case 9:
              if (!(
#line 16008 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16010 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3204 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 12471 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1549 (insn, operands);

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 12889 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1558 (insn, operands);

        default:
          return NULL;
        }

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !(
#line 12471 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 718 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1550 (insn, operands);

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !
#line 12889 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1557 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern835 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 4);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return NULL;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return NULL;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return NULL;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return NULL;
  switch (pattern1533 (x2))
    {
    case 0:
      if (!(
#line 12841 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1555 (insn, operands);

    case 1:
      if (!(
#line 12841 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 722 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1556 (insn, operands);

    case 2:
      if (!(
#line 13081 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13083 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case 3:
      if (!(
#line 13081 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13083 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1565 (insn, operands);

    case 4:
      if (!(
#line 13081 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13083 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1566 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      res = split_60 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 4:
      res = split_61 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 8:
      res = split_62 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 16:
      if (pattern836 (x3, 
6, 
5, 
4) == 0
          && pattern1508 (x3, 
11, 
10, 
9, 
8, 
7) == 0)
        {
          switch (pattern1776 (x2))
            {
            case 0:
              if (((
#line 13025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1033 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13034 "../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1561 (insn, operands);
              break;

            case 1:
              if (((
#line 13025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1033 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13034 "../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1562 (insn, operands);
              break;

            case 2:
              if (((
#line 13025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1033 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13034 "../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1563 (insn, operands);
              break;

            case 3:
              if ((
#line 13195 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13197 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1568 (insn, operands);
              break;

            default:
              break;
            }
        }
      break;

    case 32:
      if (pattern838 (x3, 
11, 
10, 
9, 
8) == 0
          && pattern1687 (x3, 
15, 
14, 
13, 
12, 
16) == 0
          && pattern1797 (x3, 
21, 
20, 
19, 
18, 
17) == 0
          && pattern1839 (x3, 
26, 
25, 
24, 
23, 
22) == 0)
        {
          x4 = XVECEXP (x3, 0, 27);
          if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 27]
              && pattern1857 (x3, 
31, 
30, 
29, 
28) == 0
              && nonimmediate_operand (operands[0], E_V32QImode)
              && GET_MODE (x2) == E_V32QImode
              && nonimmediate_operand (operands[1], E_V64QImode)
              && (
#line 13127 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13137 "../../gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
            return gen_split_1567 (insn, operands);
        }
      break;

    default:
      break;
    }
  if (XVECLEN (x3, 0) < 1)
    return NULL;
  operands[2] = x3;
  if (!avx_vbroadcast_operand (operands[2], E_VOIDmode))
    return NULL;
  x5 = XVECEXP (x3, 0, 0);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !(
#line 27388 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)) && 
#line 27391 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_3715 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !(
#line 27388 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)) && 
#line 27391 "../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_3716 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_66 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern956 (x2, 
E_V32BFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1478 (insn, operands);

        case E_V16BFmode:
          if (pattern956 (x2, 
E_V16BFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1479 (insn, operands);

        case E_V8BFmode:
          if (pattern956 (x2, 
E_V8BFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1480 (insn, operands);

        case E_V32HFmode:
          if (pattern956 (x2, 
E_V32HFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1481 (insn, operands);

        case E_V16HFmode:
          if (pattern956 (x2, 
E_V16HFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1482 (insn, operands);

        case E_V8HFmode:
          if (pattern956 (x2, 
E_V8HFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1483 (insn, operands);

        case E_V16SFmode:
          if (pattern956 (x2, 
E_V16SFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1484 (insn, operands);

        case E_V8SFmode:
          if (pattern956 (x2, 
E_V8SFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1485 (insn, operands);

        case E_V4SFmode:
          if (pattern956 (x2, 
E_V4SFmode) != 0
              || !(
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1486 (insn, operands);

        case E_V8DFmode:
          if (pattern956 (x2, 
E_V8DFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1487 (insn, operands);

        case E_V4DFmode:
          if (pattern956 (x2, 
E_V4DFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 418 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1488 (insn, operands);

        case E_V2DFmode:
          if (pattern956 (x2, 
E_V2DFmode) != 0
              || !((
#line 5457 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 418 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 5459 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1489 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern533 (x2))
            {
            case 0:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1649 (insn, operands);

            case 1:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1676 (insn, operands);

            case 2:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1703 (insn, operands);

            case 3:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1730 (insn, operands);

            case 4:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1757 (insn, operands);

            case 5:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1784 (insn, operands);

            case 6:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1811 (insn, operands);

            case 7:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1838 (insn, operands);

            case 8:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1865 (insn, operands);

            case 9:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1892 (insn, operands);

            case 10:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1919 (insn, operands);

            case 11:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1946 (insn, operands);

            case 12:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1652 (insn, operands);

            case 13:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1679 (insn, operands);

            case 14:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1706 (insn, operands);

            case 15:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1733 (insn, operands);

            case 16:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1760 (insn, operands);

            case 17:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1787 (insn, operands);

            case 18:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1814 (insn, operands);

            case 19:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1841 (insn, operands);

            case 20:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1868 (insn, operands);

            case 21:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1895 (insn, operands);

            case 22:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1922 (insn, operands);

            case 23:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1949 (insn, operands);

            case 24:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1655 (insn, operands);

            case 25:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1682 (insn, operands);

            case 26:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1709 (insn, operands);

            case 27:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1736 (insn, operands);

            case 28:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1763 (insn, operands);

            case 29:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1790 (insn, operands);

            case 30:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1817 (insn, operands);

            case 31:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1844 (insn, operands);

            case 32:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1871 (insn, operands);

            case 33:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1898 (insn, operands);

            case 34:
              if (!((
#line 13777 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1925 (insn, operands);

            case 35:
              if (!(
#line 13777 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1952 (insn, operands);

            case 36:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2945 (insn, operands);

            case 37:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2954 (insn, operands);

            case 38:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2963 (insn, operands);

            case 39:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2972 (insn, operands);

            case 40:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2981 (insn, operands);

            case 41:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2990 (insn, operands);

            case 42:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2999 (insn, operands);

            case 43:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3008 (insn, operands);

            case 44:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3017 (insn, operands);

            case 45:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3026 (insn, operands);

            case 46:
              if (!((
#line 13946 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3035 (insn, operands);

            case 47:
              if (!(
#line 13946 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3044 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern535 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2297 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2324 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2351 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2378 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2405 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2432 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2459 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2486 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2513 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2540 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2567 (insn, operands);

            case 11:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2594 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern535 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2300 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2327 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2354 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2381 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2408 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2435 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2462 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2489 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2516 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2543 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2570 (insn, operands);

            case 11:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2597 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern535 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2330 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2357 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2384 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2411 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2438 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2465 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2492 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2519 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2546 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2573 (insn, operands);

            case 11:
              if (!(
#line 13862 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2600 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      return split_65 (x1, insn);

    case XOR:
      return split_64 (x1, insn);

    case GT:
      switch (pattern337 (x2))
        {
        case 0:
          if (!((
#line 17325 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17327 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3225 (insn, operands);

        case 1:
          if (!(
#line 17325 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 17327 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3226 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DImode:
          if (pattern934 (x2, 
E_V4DImode) != 0)
            return NULL;
          if (((
#line 17342 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 705 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17344 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3227 (insn, operands);
          if (!(
#line 17354 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 777 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return NULL;
          return gen_split_3233 (insn, operands);

        case E_V2DImode:
          if (pattern934 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 17342 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 17344 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3228 (insn, operands);
          if (!
#line 17354 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_3234 (insn, operands);

        case E_V16HImode:
          if (pattern934 (x2, 
E_V16HImode) != 0
              || !(
#line 17354 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 775 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return NULL;
          return gen_split_3229 (insn, operands);

        case E_V8HImode:
          if (pattern934 (x2, 
E_V8HImode) != 0
              || !
#line 17354 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_3230 (insn, operands);

        case E_V8SImode:
          if (pattern934 (x2, 
E_V8SImode) != 0
              || !(
#line 17354 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 776 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return NULL;
          return gen_split_3231 (insn, operands);

        case E_V4SImode:
          if (pattern934 (x2, 
E_V4SImode) != 0
              || !
#line 17354 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_3232 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != NOT)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern1063 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return NULL;
          if (register_operand (operands[1], E_SImode)
              && 
#line 18617 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return gen_split_3336 (insn, operands);
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3346 (insn, operands);

        case E_V2DImode:
          if (pattern1063 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return NULL;
          if (register_operand (operands[1], E_DImode)
              && 
#line 18617 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return gen_split_3337 (insn, operands);
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3349 (insn, operands);

        case E_V64QImode:
          if (pattern595 (x2, 
E_V64QImode, 
E_QImode) != 0
              || !(
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 588 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3338 (insn, operands);

        case E_V32QImode:
          if (pattern595 (x2, 
E_V32QImode, 
E_QImode) != 0
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3339 (insn, operands);

        case E_V16QImode:
          if (pattern595 (x2, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3340 (insn, operands);

        case E_V32HImode:
          if (pattern595 (x2, 
E_V32HImode, 
E_HImode) != 0
              || !(
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 589 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3341 (insn, operands);

        case E_V16HImode:
          if (pattern595 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3342 (insn, operands);

        case E_V8HImode:
          if (pattern595 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3343 (insn, operands);

        case E_V16SImode:
          if (pattern595 (x2, 
E_V16SImode, 
E_SImode) != 0
              || !(
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 590 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3344 (insn, operands);

        case E_V8SImode:
          if (pattern595 (x2, 
E_V8SImode, 
E_SImode) != 0
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3345 (insn, operands);

        case E_V8DImode:
          if (pattern595 (x2, 
E_V8DImode, 
E_DImode) != 0
              || !(
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 591 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3347 (insn, operands);

        case E_V4DImode:
          if (pattern595 (x2, 
E_V4DImode, 
E_DImode) != 0
              || !
#line 18633 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3348 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern618 (x2, 
E_V16SImode, 
E_SImode) != 0
              || !(
#line 18449 "../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 804 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3330 (insn, operands);

        case E_V8SImode:
          if (pattern618 (x2, 
E_V8SImode, 
E_SImode) != 0
              || !
#line 18449 "../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3331 (insn, operands);

        case E_V4SImode:
          if (pattern618 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 18449 "../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3332 (insn, operands);

        case E_V8DImode:
          if (pattern618 (x2, 
E_V8DImode, 
E_DImode) != 0
              || !(
#line 18449 "../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 805 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3333 (insn, operands);

        case E_V4DImode:
          if (pattern618 (x2, 
E_V4DImode, 
E_DImode) != 0
              || !
#line 18449 "../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3334 (insn, operands);

        case E_V2DImode:
          if (pattern618 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 18449 "../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3335 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || QImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3718 (insn, operands);

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || QImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3719 (insn, operands);

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3720 (insn, operands);

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3721 (insn, operands);

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          if (
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || SImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return gen_split_3722 (insn, operands);
          if (!
#line 27988 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3728 (insn, operands);

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || SImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3723 (insn, operands);

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3724 (insn, operands);

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x2) != E_V8HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3725 (insn, operands);

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || BFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3726 (insn, operands);

        case E_V8BFmode:
          if (!register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x2) != E_V8BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 27965 "../../gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || BFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3727 (insn, operands);

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 27988 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3729 (insn, operands);

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 27988 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3730 (insn, operands);

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 27988 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3731 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_84 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = split_81 (x1, insn);
  if (res != NULL_RTX)
    return res;
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return split_79 (x1, insn);

    case VEC_MERGE:
      return split_78 (x1, insn);

    case VEC_SELECT:
      return split_83 (x1, insn);

    case AND:
    case IOR:
    case XOR:
    case NOT:
      return split_80 (x1, insn);

    case PLUS:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != UNSPEC)
        return NULL;
      switch (pattern183 (x2))
        {
        case 0:
          if (!((
#line 7161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7164 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1490 (insn, operands);

        case 1:
          if (!((
#line 7161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7164 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1491 (insn, operands);

        case 2:
          if (!((
#line 7161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7164 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1492 (insn, operands);

        case 3:
          if (!((
#line 7178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7181 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1493 (insn, operands);

        case 4:
          if (!((
#line 7178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7181 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1494 (insn, operands);

        case 5:
          if (!((
#line 7178 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7181 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1495 (insn, operands);

        case 6:
          if (!((
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7199 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1496 (insn, operands);

        case 7:
          if (!((
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7199 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1498 (insn, operands);

        case 8:
          if (!((
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7199 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1500 (insn, operands);

        case 9:
          if (!((
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7199 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1497 (insn, operands);

        case 10:
          if (!((
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7199 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1499 (insn, operands);

        case 11:
          if (!((
#line 7196 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 555 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7199 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1501 (insn, operands);

        default:
          return NULL;
        }

    case VEC_CONCAT:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          switch (pattern178 (x2))
            {
            case 0:
              if (!(
#line 12097 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12099 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1539 (insn, operands);

            case 1:
              if (!(
#line 12211 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12213 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1543 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          if (GET_MODE (x3) != E_DFmode)
            return NULL;
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != PARALLEL
              || XVECLEN (x4, 0) != 1)
            return NULL;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !memory_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode)
            return NULL;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DFmode))
            return NULL;
          x7 = XEXP (x3, 0);
          if (!rtx_equal_p (x7, operands[0])
              || !
#line 14751 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_3165 (insn, operands);

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          res = split_77 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (GET_CODE (x3) != SUBREG
              || pattern597 (x2) != 0
              || !register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode)
            return NULL;
          x7 = XEXP (x3, 0);
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          if (!memory_operand (operands[1], E_V16QImode))
            return NULL;
          x6 = XEXP (x2, 1);
          x9 = XEXP (x6, 0);
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !(
#line 27908 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && ix86_pre_reload_split ()) && 
#line 27910 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3717 (insn, operands);

        case VEC_CONCAT:
          if (pattern408 (x2) != 0)
            return NULL;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1486 (x2, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0
                  || !((
#line 30138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30140 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3801 (insn, operands);

            case E_V16SFmode:
              if (pattern1486 (x2, 
E_V8SFmode, 
E_V4SFmode, 
E_V16SFmode) != 0
                  || !((
#line 30138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30140 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3802 (insn, operands);

            case E_V8DFmode:
              if (pattern1486 (x2, 
E_V4DFmode, 
E_V2DFmode, 
E_V8DFmode) != 0
                  || !((
#line 30138 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30140 "../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3803 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case EQ:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case US_MINUS:
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V32QImode:
              if (pattern957 (x2, 
E_V32QImode) != 0
                  || !(
#line 16337 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V32QImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 736 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3208 (insn, operands);

            case E_V16QImode:
              if (pattern957 (x2, 
E_V16QImode) != 0
                  || !
#line 16337 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V16QImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)))
                return NULL;
              return gen_split_3209 (insn, operands);

            case E_V16HImode:
              if (pattern957 (x2, 
E_V16HImode) != 0
                  || !(
#line 16337 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V16HImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 737 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3210 (insn, operands);

            case E_V8HImode:
              if (pattern957 (x2, 
E_V8HImode) != 0
                  || !
#line 16337 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V8HImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)))
                return NULL;
              return gen_split_3211 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != LSHIFTRT)
            return NULL;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          x12 = XEXP (x7, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x4 = XEXP (x3, 1);
          operands[3] = x4;
          x6 = XEXP (x2, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern1255 (x2, 
E_V16HImode) != 0
                  || !(
#line 17531 "../../gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (HImode) - 1) && 
#line 775 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3256 (insn, operands);

            case E_V8HImode:
              if (pattern1255 (x2, 
E_V8HImode) != 0
                  || !
#line 17531 "../../gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (HImode) - 1))
                return NULL;
              return gen_split_3257 (insn, operands);

            case E_V8SImode:
              if (pattern1255 (x2, 
E_V8SImode) != 0
                  || !(
#line 17531 "../../gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (SImode) - 1) && 
#line 776 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3258 (insn, operands);

            case E_V4SImode:
              if (pattern1255 (x2, 
E_V4SImode) != 0
                  || !
#line 17531 "../../gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (SImode) - 1))
                return NULL;
              return gen_split_3259 (insn, operands);

            case E_V4DImode:
              if (pattern1255 (x2, 
E_V4DImode) != 0
                  || !(
#line 17531 "../../gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (DImode) - 1) && 
#line 777 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3260 (insn, operands);

            case E_V2DImode:
              if (pattern1255 (x2, 
E_V2DImode) != 0
                  || !
#line 17531 "../../gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (DImode) - 1))
                return NULL;
              return gen_split_3261 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LT:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern231 (x2, 
E_V16HImode) != 0
              || !((
#line 17127 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 744 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17129 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3212 (insn, operands);

        case E_V8HImode:
          if (pattern231 (x2, 
E_V8HImode) != 0
              || !(
#line 17127 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 17129 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3213 (insn, operands);

        case E_V8SImode:
          if (pattern231 (x2, 
E_V8SImode) != 0
              || !((
#line 17127 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 745 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17129 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3214 (insn, operands);

        case E_V4SImode:
          if (pattern231 (x2, 
E_V4SImode) != 0
              || !(
#line 17127 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 17129 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3215 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern236 (x2))
        {
        case 0:
          if (!(
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V32HImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3244 (insn, operands);

        case 1:
          if (!(
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V16SImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3247 (insn, operands);

        case 2:
          if (!(
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V8DImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 786 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3250 (insn, operands);

        case 3:
          if (!(
#line 17453 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 17456 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3253 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern236 (x2))
        {
        case 0:
          if (!(
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V32HImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3245 (insn, operands);

        case 1:
          if (!(
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V16SImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3248 (insn, operands);

        case 2:
          if (!(
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V8DImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 786 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3251 (insn, operands);

        case 3:
          if (!(
#line 17482 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 17485 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3254 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern235 (x2, 
E_V32HImode) == 0
                  && (
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V32HImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return gen_split_3246 (insn, operands);
              break;

            case E_V16SImode:
              if (pattern235 (x2, 
E_V16SImode) == 0
                  && (
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V16SImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return gen_split_3249 (insn, operands);
              break;

            case E_V8DImode:
              if (pattern235 (x2, 
E_V8DImode) == 0
                  && (
#line 17394 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V8DImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 786 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return gen_split_3252 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          if (const_0_to_255_operand (operands[2], E_SImode)
              && register_operand (operands[0], E_V1TImode)
              && GET_MODE (x2) == E_V1TImode
              && register_operand (operands[1], E_V1TImode)
              && (
#line 17512 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 17515 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3255 (insn, operands);
          break;

        default:
          break;
        }
      if (!nonmemory_operand (operands[2], E_DImode)
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 26979 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 26981 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3714 (insn, operands);

    case ROTATE:
      if (pattern237 (x2) != 0
          || !(
#line 17553 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 17556 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3262 (insn, operands);

    case ROTATERT:
      if (pattern237 (x2) != 0
          || !(
#line 17582 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()) && 
#line 17585 "../../gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3263 (insn, operands);

    case VEC_DUPLICATE:
      return split_82 (x1, insn);

    case SIGN_EXTEND:
      x3 = XEXP (x2, 0);
      if (pattern238 (x3) != 0)
        return NULL;
      switch (pattern681 (x2))
        {
        case 0:
          if ((
#line 24265 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()) && 
#line 24268 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3507 (insn, operands);
          if (!(
#line 24265 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24268 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3508 (insn, operands);

        case 1:
          if ((
#line 24417 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24420 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3515 (insn, operands);
          if (!(
#line 24417 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24420 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3516 (insn, operands);

        case 2:
          if (!(
#line 24781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 24783 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3539 (insn, operands);

        case 3:
          if ((
#line 24651 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24654 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3531 (insn, operands);
          if (!(
#line 24651 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24654 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3532 (insn, operands);

        case 4:
          if ((
#line 24981 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24984 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3550 (insn, operands);
          if (!(
#line 24981 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24984 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3551 (insn, operands);

        case 5:
          if ((
#line 25206 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25209 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3562 (insn, operands);
          if (!(
#line 25206 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25209 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3563 (insn, operands);

        case 6:
          if ((
#line 24482 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24485 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3519 (insn, operands);
          if (!(
#line 24482 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24485 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3520 (insn, operands);

        case 7:
          if ((
#line 24842 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24845 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3543 (insn, operands);
          if (!(
#line 24842 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24845 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3544 (insn, operands);

        case 8:
          if ((
#line 25044 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25047 "../../gcc/config/i386/sse.md"
( 1)))
            return gen_split_3554 (insn, operands);
          if (!(
#line 25044 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25047 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3555 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x2, 0);
      if (pattern238 (x3) != 0)
        return NULL;
      x7 = XEXP (x3, 0);
      x11 = XEXP (x7, 0);
      switch (GET_CODE (x11))
        {
        case VEC_CONCAT:
          switch (pattern679 (x2))
            {
            case 0:
              if ((
#line 24265 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()) && 
#line 24268 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_3509 (insn, operands);
              if (!(
#line 24265 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24268 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3510 (insn, operands);

            case 1:
              if ((
#line 24417 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24420 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_3517 (insn, operands);
              if (!(
#line 24417 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24420 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3518 (insn, operands);

            case 2:
              if (!(
#line 24781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 24783 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3541 (insn, operands);

            case 3:
              if ((
#line 24651 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24654 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_3533 (insn, operands);
              if (!(
#line 24651 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24654 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3534 (insn, operands);

            case 4:
              if ((
#line 24981 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24984 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_3552 (insn, operands);
              if (!(
#line 24981 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24984 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3553 (insn, operands);

            case 5:
              if ((
#line 25206 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25209 "../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_3564 (insn, operands);
              if (!(
#line 25206 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25209 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3565 (insn, operands);

            default:
              return NULL;
            }

        case VEC_MERGE:
          x13 = XEXP (x11, 0);
          if (GET_CODE (x13) != VEC_DUPLICATE)
            return NULL;
          if (GET_MODE (x13) == E_V4SImode)
            {
              switch (pattern1033 (x2))
                {
                case 0:
                  if ((
#line 24482 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24485 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3521 (insn, operands);
                  if ((
#line 24482 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24485 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3522 (insn, operands);
                  break;

                case 1:
                  if ((
#line 24842 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24845 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3545 (insn, operands);
                  if ((
#line 24842 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24845 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3546 (insn, operands);
                  break;

                case 2:
                  if ((
#line 25044 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25047 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3556 (insn, operands);
                  if ((
#line 25044 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25047 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3557 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x14 = XEXP (x11, 2);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1034 (x2))
            {
            case 0:
              if (!(
#line 24918 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 24920 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3547 (insn, operands);

            case 1:
              if (!(
#line 24918 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 24920 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3548 (insn, operands);

            case 2:
              if (!(
#line 24918 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 24920 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3549 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return NULL;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!memory_operand (operands[0], E_DFmode))
    return NULL;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!sse_reg_operand (operands[1], E_V2DFmode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_DFmode)
    return NULL;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return NULL;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x11 = XEXP (x7, 0);
  operands[2] = x11;
  if (!memory_operand (operands[2], E_DFmode))
    return NULL;
  x12 = XEXP (x8, 0);
  operands[3] = x12;
  if (!sse_reg_operand (operands[3], E_V2DFmode)
      || !
#line 1977 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_SSE_UNALIGNED_STORE_OPTIMAL
   && ix86_operands_ok_for_move_multiple (operands, false, DFmode)))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_402 (insn, operands);
}

 rtx_insn *
peephole2_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (address_no_seg_operand (operands[1], E_SImode)
      && 
#line 6386 "../../gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])
   && peep2_regno_dead_p (0, FLAGS_REG)
   && ix86_avoid_lea_for_addr (peep2_next_insn (0), operands)))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_60 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !memory_operand (operands[1], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 20196 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_176 (insn, operands);

    case UNSPEC_VOLATILE:
      if (pattern840 (x2) != 0)
        return NULL;
      x6 = PATTERN (peep2_next_insn (2));
      switch (GET_CODE (x6))
        {
        case CALL:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_QImode)
            return NULL;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          x9 = XEXP (x7, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !(
#line 20211 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_178 (insn, operands);

        case PARALLEL:
          if (XVECLEN (x6, 0) != 2)
            return NULL;
          x10 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 1);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_SImode)
            return NULL;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 7
              || GET_MODE (x12) != E_SImode)
            return NULL;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 7
              || GET_MODE (x13) != E_SImode)
            return NULL;
          x14 = XEXP (x11, 1);
          operands[4] = x14;
          if (!immediate_operand (operands[4], E_SImode))
            return NULL;
          x15 = XVECEXP (x6, 0, 0);
          switch (GET_CODE (x15))
            {
            case CALL:
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != MEM
                  || GET_MODE (x16) != E_QImode)
                return NULL;
              x17 = XEXP (x15, 1);
              operands[3] = x17;
              x18 = XEXP (x16, 0);
              if (!rtx_equal_p (x18, operands[0])
                  || !
#line 20292 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_181 (insn, operands);

            case SET:
              x17 = XEXP (x15, 1);
              if (GET_CODE (x17) != CALL)
                return NULL;
              x19 = XEXP (x17, 0);
              if (GET_CODE (x19) != MEM
                  || GET_MODE (x19) != E_QImode)
                return NULL;
              x16 = XEXP (x15, 0);
              operands[2] = x16;
              x20 = XEXP (x17, 1);
              operands[3] = x20;
              x21 = XEXP (x19, 0);
              if (!rtx_equal_p (x21, operands[0])
                  || !
#line 20511 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_189 (insn, operands);

            default:
              return NULL;
            }

        case SET:
          if (pattern1343 (x6) != 0
              || !(
#line 20422 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_186 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      if (XVECLEN (x2, 0) != 2)
        return NULL;
      x22 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x22) != CALL)
        return NULL;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != E_QImode)
        return NULL;
      x24 = XVECEXP (x2, 0, 1);
      if (pattern1257 (x24) != 0)
        return NULL;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 7
          || GET_MODE (x25) != E_SImode)
        return NULL;
      x26 = XEXP (x22, 1);
      operands[3] = x26;
      x27 = XEXP (x24, 1);
      x28 = XEXP (x27, 1);
      operands[4] = x28;
      if (!immediate_operand (operands[4], E_SImode))
        return NULL;
      x29 = XEXP (x23, 0);
      if (!rtx_equal_p (x29, operands[0])
          || !
#line 20273 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_180 (insn, operands);

    case SET:
      switch (pattern841 (x2))
        {
        case 0:
          if (!(
#line 20309 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && peep2_reg_dead_p (2, operands[0])) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_182 (insn, operands);

        case 1:
          if (!(
#line 20405 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_184 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  if (!general_reg_operand (x3, E_SImode))
    return NULL;
  operands[8] = x3;
  switch (pattern961 (x1, 
E_SImode, 
E_DImode))
    {
    case 0:
      if (
#line 9654 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_100 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    case 1:
      if (
#line 9709 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (6, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && !reg_overlap_mentioned_p (operands[0], operands[10])
   && !reg_overlap_mentioned_p (operands[10], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[11])
   && !reg_overlap_mentioned_p (operands[11], operands[1])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))))
        {
          *pmatch_len_ = 5;
          res = gen_peephole2_102 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (pattern964 (x1, 
E_SImode) != 0
      || !
#line 26398 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_207 (insn, operands);
}

 rtx_insn *
peephole2_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (address_no_seg_operand (operands[1], E_DImode)
      && (
#line 6386 "../../gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])
   && peep2_regno_dead_p (0, FLAGS_REG)
   && ix86_avoid_lea_for_addr (peep2_next_insn (0), operands)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_61 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !memory_operand (operands[1], E_DImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 20196 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_177 (insn, operands);

    case UNSPEC_VOLATILE:
      if (pattern840 (x2) != 0)
        return NULL;
      x6 = PATTERN (peep2_next_insn (2));
      switch (GET_CODE (x6))
        {
        case CALL:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_QImode)
            return NULL;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          x9 = XEXP (x7, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !(
#line 20211 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_179 (insn, operands);

        case SET:
          if (pattern1343 (x6) != 0
              || !(
#line 20422 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_187 (insn, operands);

        default:
          return NULL;
        }

    case SET:
      switch (pattern841 (x2))
        {
        case 0:
          if (!(
#line 20309 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && peep2_reg_dead_p (2, operands[0])) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_183 (insn, operands);

        case 1:
          if (!(
#line 20405 "../../gcc/config/i386/i386.md"
(!TARGET_X32
   && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_185 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!flags_reg_operand (x2, E_VOIDmode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  operands[4] = x2;
  res = peephole2_19 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  if (peep2_current_count < 4)
    return NULL;
  operands[6] = x2;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x5, 0);
  operands[7] = x6;
  if (!flags_reg_operand (operands[7], E_VOIDmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 1);
  operands[5] = x8;
  x9 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 1);
  if (!ix86_comparison_operator (x10, E_QImode))
    return NULL;
  operands[3] = x10;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17)
    return NULL;
  x12 = XEXP (x10, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x13 = XEXP (x9, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_QImode))
    return NULL;
  x14 = PATTERN (peep2_next_insn (3));
  switch (GET_CODE (x14))
    {
    case SET:
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != ZERO_EXTEND)
        return NULL;
      x16 = XEXP (x14, 0);
      operands[4] = x16;
      if (!any_QIreg_operand (operands[4], E_VOIDmode))
        return NULL;
      x17 = XEXP (x15, 0);
      if (!rtx_equal_p (x17, operands[2])
          || !
#line 19984 "../../gcc/config/i386/i386.md"
((peep2_reg_dead_p (4, operands[2])
    || operands_match_p (operands[2], operands[4]))
   && ! reg_overlap_mentioned_p (operands[4], operands[0])
   && ! reg_overlap_mentioned_p (operands[4], operands[1])
   && ! reg_overlap_mentioned_p (operands[4], operands[5])
   && ! reg_set_p (operands[4], operands[5])
   && refers_to_regno_p (FLAGS_REG, operands[1], (rtx *)NULL)
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_171 (insn, operands);

    case PARALLEL:
      if (XVECLEN (x14, 0) != 2)
        return NULL;
      x18 = XVECEXP (x14, 0, 0);
      if (GET_CODE (x18) != SET)
        return NULL;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != ZERO_EXTEND)
        return NULL;
      x20 = XVECEXP (x14, 0, 1);
      if (GET_CODE (x20) != CLOBBER)
        return NULL;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 17
          || GET_MODE (x21) != E_CCmode)
        return NULL;
      x22 = XEXP (x18, 0);
      operands[4] = x22;
      if (!any_QIreg_operand (operands[4], E_VOIDmode))
        return NULL;
      x23 = XEXP (x19, 0);
      if (!rtx_equal_p (x23, operands[2])
          || !
#line 20057 "../../gcc/config/i386/i386.md"
((peep2_reg_dead_p (4, operands[2])
    || operands_match_p (operands[2], operands[4]))
   && ! reg_overlap_mentioned_p (operands[4], operands[0])
   && ! reg_overlap_mentioned_p (operands[4], operands[1])
   && ! reg_overlap_mentioned_p (operands[4], operands[5])
   && ! reg_set_p (operands[4], operands[5])
   && refers_to_regno_p (FLAGS_REG, operands[1], (rtx *)NULL)
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_174 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (memory_operand (operands[1], E_SImode)
      && register_operand (operands[0], E_SImode))
    {
      res = peephole2_23 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4
      || !general_reg_operand (operands[1], E_SImode)
      || !general_reg_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return NULL;
  x6 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x4, 1);
  operands[5] = x7;
  x8 = XEXP (x6, 1);
  operands[6] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return NULL;
  x10 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x10) != SET
      || pattern1347 (x10, 
E_SImode) != 0
      || !
#line 26364 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_204 (insn, operands);
}

 rtx_insn *
peephole2_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || pattern112 (x2) != 0)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!general_reg_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0])
      || !
#line 22526 "../../gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)))
    return NULL;
  *pmatch_len_ = 0;
  return gen_peephole2_191 (insn, operands);
}

 rtx_insn *
peephole2_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!general_reg_operand (operands[1], E_QImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return NULL;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 27
          || GET_MODE (x8) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 17
          || GET_MODE (x9) != E_CCmode)
        return NULL;
      x10 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = XEXP (x7, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_193 (insn, operands);

    case E_SImode:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != POPCOUNT
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x12 = XEXP (x8, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return NULL;
      x13 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x13) != SET
          || pattern1750 (x13) != 0)
        return NULL;
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x17 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x17) != SET)
        return NULL;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != IF_THEN_ELSE)
        return NULL;
      x19 = XEXP (x18, 0);
      if (!bt_comparison_operator (x19, E_VOIDmode))
        return NULL;
      operands[4] = x19;
      if (pattern1864 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      x21 = XEXP (x20, 0);
      operands[5] = x21;
      if (!
#line 22706 "../../gcc/config/i386/i386.md"
(REGNO (operands[2]) == REGNO (operands[3])
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_194 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != 17)
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!general_reg_operand (operands[1], E_QImode)
          || !
#line 26885 "../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_213 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[1], E_HImode)
          || !
#line 26885 "../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_214 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[1], E_SImode)
          || !
#line 26885 "../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_215 (insn, operands);

    case E_DImode:
      if (!general_reg_operand (operands[1], E_DImode)
          || !(
#line 26885 "../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_216 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XWINT (x2, 0) == -1L)
    {
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (general_reg_operand (operands[0], E_HImode)
              && 
#line 28371 "../../gcc/config/i386/i386.md"
((TARGET_MOVE_M1_VIA_OR || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_335 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_SImode:
          if (general_reg_operand (operands[0], E_SImode)
              && 
#line 28371 "../../gcc/config/i386/i386.md"
((TARGET_MOVE_M1_VIA_OR || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_336 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_DImode:
          if (general_reg_operand (operands[0], E_DImode)
              && (
#line 28371 "../../gcc/config/i386/i386.md"
((TARGET_MOVE_M1_VIA_OR || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_337 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  operands[2] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (pattern600 (x3, 
2) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != 110)
    return NULL;
  x6 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS
      || pattern1509 (x3) != 0
      || pattern1688 (x3) != 0)
    return NULL;
  x8 = PATTERN (peep2_next_insn (2));
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 1);
  operands[3] = x10;
  x11 = XEXP (x9, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern1855 (x3, 
E_HImode) != 0
          || !
#line 724 "../../gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_416 (insn, operands);

    case E_SImode:
      if (pattern1855 (x3, 
E_SImode) != 0
          || !
#line 724 "../../gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_417 (insn, operands);

    case E_DImode:
      if (pattern1855 (x3, 
E_DImode) != 0
          || !(
#line 724 "../../gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_418 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x5) != E_CCmode)
        return NULL;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return NULL;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || !general_gr_operand (operands[1], E_QImode)
              || GET_MODE (x7) != E_QImode
              || !
#line 8682 "../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_64 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || !general_gr_operand (operands[1], E_HImode)
              || GET_MODE (x7) != E_HImode
              || !
#line 8682 "../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_65 (insn, operands);

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || !general_gr_operand (operands[1], E_SImode)
              || GET_MODE (x7) != E_SImode
              || !
#line 8682 "../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_66 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || !general_gr_operand (operands[1], E_DImode)
              || GET_MODE (x7) != E_DImode
              || !(
#line 8682 "../../gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_67 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 2)
        return NULL;
      x12 = XEXP (x6, 0);
      if (GET_CODE (x12) != PLUS)
        return NULL;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return NULL;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case LTU:
        case UNLT:
          operands[4] = x14;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != PLUS)
            return NULL;
          x16 = XEXP (x8, 0);
          switch (GET_CODE (x16))
            {
            case LTU:
            case UNLT:
              operands[3] = x16;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x18 = XEXP (x8, 1);
              if (GET_CODE (x18) != ZERO_EXTEND)
                return NULL;
              x7 = XEXP (x4, 1);
              if (GET_CODE (x7) != PLUS)
                return NULL;
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != PLUS)
                return NULL;
              x19 = XEXP (x9, 0);
              switch (GET_CODE (x19))
                {
                case LTU:
                case UNLT:
                  if (!rtx_equal_p (x19, operands[4])
                      || GET_MODE (x3) != E_CCCmode
                      || GET_MODE (x5) != E_CCCmode)
                    return NULL;
                  x20 = XEXP (x14, 0);
                  operands[2] = x20;
                  if (!flags_reg_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x21 = XEXP (x13, 1);
                  operands[0] = x21;
                  x22 = XEXP (x12, 1);
                  operands[1] = x22;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2]))
                    return NULL;
                  x24 = XEXP (x18, 0);
                  if (!rtx_equal_p (x24, operands[1]))
                    return NULL;
                  x25 = XEXP (x9, 1);
                  if (!rtx_equal_p (x25, operands[0]))
                    return NULL;
                  x10 = XEXP (x7, 1);
                  if (!rtx_equal_p (x10, operands[1]))
                    return NULL;
                  x11 = XEXP (x4, 0);
                  if (!rtx_equal_p (x11, operands[0]))
                    return NULL;
                  x26 = PATTERN (peep2_next_insn (1));
                  if (GET_CODE (x26) != SET)
                    return NULL;
                  switch (GET_MODE (x6))
                    {
                    case E_DImode:
                      switch (pattern1859 (x1, 
E_SImode, 
E_DImode))
                        {
                        case 0:
                          if (!
#line 9083 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                            return NULL;
                          *pmatch_len_ = 1;
                          return gen_peephole2_84 (insn, operands);

                        case 1:
                          if (!
#line 9177 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[5])
   && !reg_overlap_mentioned_p (operands[5], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[6])
   && !reg_overlap_mentioned_p (operands[6], operands[1])))
                            return NULL;
                          *pmatch_len_ = 3;
                          return gen_peephole2_88 (insn, operands);

                        default:
                          return NULL;
                        }

                    case E_TImode:
                      switch (pattern1859 (x1, 
E_DImode, 
E_TImode))
                        {
                        case 0:
                          if (!(
#line 9083 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            return NULL;
                          *pmatch_len_ = 1;
                          return gen_peephole2_85 (insn, operands);

                        case 1:
                          if (!(
#line 9177 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[5])
   && !reg_overlap_mentioned_p (operands[5], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[6])
   && !reg_overlap_mentioned_p (operands[6], operands[1])) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            return NULL;
                          *pmatch_len_ = 3;
                          return gen_peephole2_89 (insn, operands);

                        default:
                          return NULL;
                        }

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      if (peep2_current_count < 2)
        return NULL;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      x27 = XEXP (x6, 1);
      operands[1] = x27;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      x26 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x26) != SET)
        return NULL;
      x28 = XEXP (x26, 1);
      if (!rtx_equal_p (x28, operands[0]))
        return NULL;
      x29 = XEXP (x26, 0);
      if (!rtx_equal_p (x29, operands[1]))
        return NULL;
      if (GET_CODE (x6) == PLUS)
        {
          res = peephole2_42 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[2] = x6;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return NULL;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!plusminuslogic_operator (operands[2], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_QImode)
              || !
#line 28074 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_309 (insn, operands);

        case E_HImode:
          if (!plusminuslogic_operator (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_HImode)
              || !
#line 28074 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_310 (insn, operands);

        case E_SImode:
          if (!plusminuslogic_operator (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode)
              || !
#line 28074 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_311 (insn, operands);

        case E_DImode:
          if (!plusminuslogic_operator (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode)
              || !(
#line 28074 "../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_312 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
